// This code conforms with the UFC specification version 2018.1.0
// and was automatically generated by FFC version 2019.1.0.post0.
//
// This code was generated with the option '-l dolfin' and
// contains DOLFIN-specific wrappers that depend on DOLFIN.
//
// This code was generated with the following parameters:
//

//  add_tabulate_tensor_timing:     False
//  convert_exceptions_to_warnings: False
//  cpp_optimize:                   True
//  cpp_optimize_flags:             '-O2'
//  epsilon:                        1e-14
//  error_control:                  False
//  external_include_dirs:          ''
//  external_includes:              ''
//  external_libraries:             ''
//  external_library_dirs:          ''
//  form_postfix:                   True
//  format:                         'dolfin'
//  generate_dummy_tabulate_tensor: False
//  max_signature_length:           0
//  optimize:                       True
//  precision:                      None
//  quadrature_degree:              None
//  quadrature_rule:                None
//  representation:                 'auto'
//  split:                          False

#ifndef __FORMS_H
#define __FORMS_H
#include <algorithm>
#include <cmath>
#include <iostream>
#include <stdexcept>
#include <ufc.h>

class forms_finite_element_0: public ufc::finite_element
{
public:

  forms_finite_element_0() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Lagrange', triangle, 1)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 3;
  }

  std::size_t value_rank() const final override
  {
    return 0;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t value_size() const final override
  {
    return 1;
  }

  std::size_t reference_value_rank() const final override
  {
    return 0;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    return 1;
  }

  std::size_t reference_value_size() const final override
  {
    return 1;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 3; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[3 * ip + 2] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 3 * num_derivatives, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[3] = {};
    const std::size_t num_components[3] = { 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 3; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[3 * num_derivatives * ip + num_derivatives * i + r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 3 * num_derivatives, 0.0);
    const std::size_t reference_offsets[3] = {};
    const std::size_t physical_offsets[3] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 3; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[3 * num_derivatives * ip + num_derivatives * d + s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[3 * num_derivatives * ip + num_derivatives * d + r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[3];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[3];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 1; ++k)
        values[k] = physical_values[i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold value of a single dof.
    double dof_values = 0.0;
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis(r, &dof_values, x, coordinate_dofs, cell_orientation);
        values[r] = dof_values;
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, num_derivatives * 3, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 3; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < num_derivatives; ++s)
            values[num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[1];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[1] = dof_values[1];
    vertex_values[2] = dof_values[2];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[6] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 6, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_0();
  }

};


class forms_finite_element_1: public ufc::finite_element
{
public:

  forms_finite_element_1() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 6;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 1;
  }

  const char * family() const final override
  {
    return "Lagrange";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    for (std::size_t k = 0; k < num_points * 6 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 2] += coefficients2[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 3 + 1] += coefficients0[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 4 + 1] += coefficients1[0][r] * basisvalues1[r];
        for (std::size_t r = 0; r < 3; ++r)
            reference_values[6 * 2 * ip + 2 * 5 + 1] += coefficients2[0][r] * basisvalues1[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 6 * num_derivatives * 2, 0.0);
    if (order > 1)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][3][3] =
        { { { 0.0, 0.0, 0.0 },
            { 4.8989794855663495, 0.0, 0.0 },
            { 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0 },
            { 2.449489742783182, 0.0, 0.0 },
            { 4.242640687119285, 0.0, 0.0 } } };
    static const double coefficients0[1][3] = { { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients1[1][3] = { { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 } };
    static const double coefficients2[1][3] = { { 0.4714045207910316, 0.0, 0.3333333333333333 } };
    const std::size_t reference_offset[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t num_components[6] = { 1, 1, 1, 1, 1, 1 };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues1[3] = {};
        basisvalues1[0] = 1.0;
        const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues1[1] = tmp1_1;
        basisvalues1[2] = (0.5 + 1.5 * Y[1]) * basisvalues1[0];
        basisvalues1[0] *= std::sqrt(0.5);
        basisvalues1[2] *= std::sqrt(1.0);
        basisvalues1[1] *= std::sqrt(3.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 6; ++i)
        {
            double derivatives[2] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients0[0][s] * aux[s];
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients1[0][s] * aux[s];
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[3] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[3][3] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 9, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[3][3];
                        std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 9, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 3; ++s)
                        for (std::size_t t = 0; t < 3; ++t)
                            aux[s] += dmats[s][t] * basisvalues1[t];
                    derivatives[r] = 0.0;
                    for (std::size_t s = 0; s < 3; ++s)
                        derivatives[r] += coefficients2[0][s] * aux[s];
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    std::fill_n(values, num_points * 6 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    const std::size_t physical_offsets[6] = { 0, 0, 0, 1, 1, 1 };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[2][2];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 6; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 1; ++i)
                {
                    // Using affine transform to map values back to the physical element.
                    const double mapped_value = reference_values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[6 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[12];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[12];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[1][2][1] =
        { { { 0 },
            { 1 } } };
    // Declare transformation matrix
    double transform[2][2] =
        { { 1.0, 1.0 },
          { 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 1:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 2:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[r] += transform[r][s] * derivatives[s];
        }
        break;
    case 3:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, -0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 4:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910317, 0.2886751345948129, -0.16666666666666666 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    case 5:
        {
            double basisvalues[3] = {};
            basisvalues[0] = 1.0;
            const double tmp1_1 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_1;
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[1] *= std::sqrt(3.0);
            // Table(s) of coefficients
            static const double coefficients0[3] = { 0.4714045207910316, 0.0, 0.3333333333333333 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 4.8989794855663495, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0 } };
            static const double dmats1[3][3] =
                { { 0.0, 0.0, 0.0 },
                  { 2.449489742783182, 0.0, 0.0 },
                  { 4.242640687119285, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[2] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[3][3] =
                { { 1.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 9, 0.0);
                for (std::size_t t = 0; t < 3; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 9, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 9, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 3; ++t)
                            for (std::size_t u = 0; u < 3; ++u)
                                for (std::size_t tu = 0; tu < 3; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 3; ++s)
                    for (std::size_t t = 0; t < 3; ++t)
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t s = 0; s < num_derivatives; ++s)
                    values[num_derivatives + r] += transform[r][s] * derivatives[s];
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 6, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 1)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[4] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 6; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    switch (i)
    {
    case 0:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 1:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 2:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0];
        }
        break;
    case 3:
        {
            y[0] = coordinate_dofs[0];
            y[1] = coordinate_dofs[1];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 4:
        {
            y[0] = coordinate_dofs[2];
            y[1] = coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    case 5:
        {
            y[0] = coordinate_dofs[4];
            y[1] = coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[1];
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[0] = vals[0];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[1] = vals[0];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = vals[0];
    y[0] = coordinate_dofs[0];
    y[1] = coordinate_dofs[1];
    f.evaluate(vals, y, c);
    values[3] = vals[1];
    y[0] = coordinate_dofs[2];
    y[1] = coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[4] = vals[1];
    y[0] = coordinate_dofs[4];
    y[1] = coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[1];
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Evaluate function and change variables
    vertex_values[0] = dof_values[0];
    vertex_values[2] = dof_values[1];
    vertex_values[4] = dof_values[2];
    // Evaluate function and change variables
    vertex_values[1] = dof_values[3];
    vertex_values[3] = dof_values[4];
    vertex_values[5] = dof_values[5];
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    dof_coordinates[0] = coordinate_dofs[0];
    dof_coordinates[1] = coordinate_dofs[1];
    dof_coordinates[2] = coordinate_dofs[2];
    dof_coordinates[2 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 2] = coordinate_dofs[4];
    dof_coordinates[2 * 2 + 1] = coordinate_dofs[5];
    dof_coordinates[2 * 3] = coordinate_dofs[0];
    dof_coordinates[2 * 3 + 1] = coordinate_dofs[1];
    dof_coordinates[2 * 4] = coordinate_dofs[2];
    dof_coordinates[2 * 4 + 1] = coordinate_dofs[3];
    dof_coordinates[2 * 5] = coordinate_dofs[4];
    dof_coordinates[2 * 5 + 1] = coordinate_dofs[5];
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    static const double dof_X[12] = { 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 1.0 };
    std::copy_n(dof_X, 12, reference_dof_coordinates);
  }

  std::size_t num_sub_elements() const final override
  {
    return 2;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_0();
    case 1:
        return new forms_finite_element_0();
    default:
        return nullptr;
    }
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_1();
  }

};


class forms_finite_element_2: public ufc::finite_element
{
public:

  forms_finite_element_2() : ufc::finite_element()
  {
    // Do nothing
  }

  ~forms_finite_element_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t space_dimension() const final override
  {
    return 15;
  }

  std::size_t value_rank() const final override
  {
    return 1;
  }

  std::size_t value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t value_size() const final override
  {
    return 2;
  }

  std::size_t reference_value_rank() const final override
  {
    return 1;
  }

  std::size_t reference_value_dimension(std::size_t i) const final override
  {
    static const int return_values[1] = { 2 };
    if (i >= 1)
        return 1;
    return return_values[i];
  }

  std::size_t reference_value_size() const final override
  {
    return 2;
  }

  std::size_t degree() const final override
  {
    return 3;
  }

  const char * family() const final override
  {
    return "Nedelec 1st kind H(curl)";
  }

  void evaluate_reference_basis(double * reference_values,
                                std::size_t num_points,
                                const double * X) const final override
  {
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112332, 0.08417937871268429, -0.11664236870396065, 0.0, -0.14682003422210377, 0.07290148043997553, -0.10101525445522076 },
          { 0.0, 0.0, 0.0, 0.321678327423669, -0.134687005940295, 0.09720197391996724, 0.26057971086461384, -0.12987926104263017, 0.09768798378956733, -0.0631345340345131 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359535, -0.1683587574253683, 0.34992710611188205, 0.0, 0.06776309271789413, -0.145802960879951, 0.30304576336566247 },
          { 0.0, 0.0, 0.0, -0.16518616813647943, 0.23570226039551642, -0.27216552697590846, -0.12026755886059136, 0.14682003422210418, -0.22453655975512488, 0.17677669529663712 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.039123039821797816, -0.08417937871268422, -0.34992710611188227, 0.0, -0.03388154635894715, -0.07290148043997549, -0.30304576336566286 },
          { 0.0, 0.0, 0.0, 0.06085806194501889, 0.0, 0.2138443426239283, 0.06013377943029567, 0.0395284707521043, 0.11226827987756255, -0.13889597487592942 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.16953317256112316, 0.08417937871268413, 0.1166423687039608, 0.0, 0.1468200342221036, 0.07290148043997546, 0.10101525445522097 },
          { 0.0, 0.0, 0.0, 0.491211499984792, 0.21886638465297922, 0.21384434262392793, -0.2605797108646135, 0.01694077317947354, -0.024786503349591843, 0.03788072042070794 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359535, -0.16835875742536835, -0.34992710611188227, 0.0, -0.06776309271789413, -0.14580296087995095, -0.30304576336566286 },
          { 0.0, 0.0, 0.0, -0.2434322477800735, -0.40406101782088477, -0.6220926330877908, 0.12026755886059096, 0.07905694150420917, 0.07873359887517382, -0.12626906806902682 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179783, -0.08417937871268412, 0.34992710611188205, 0.0, 0.03388154635894713, -0.07290148043997532, 0.3030457633656627 },
          { 0.0, 0.0, 0.0, 0.09998110176681535, -0.08417937871268365, 0.5637714487358108, -0.06013377943029568, 0.07341001711105219, -0.18516976031753804, 0.16414978848973458 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686869, 0.30304576336566347, 0.31104631654389586, 0.0, -0.09035079029052548, -0.14580296087995084, -0.20203050891044214 },
          { 0.0, 0.0, 0.0, 0.16953317256112263, 0.08417937871268412, 0.11664236870396119, 0.16035674514745452, 0.06776309271789374, 0.032076651393589506, -0.07576144084141621 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373743, 0.0, -0.1555231582719479, 0.0, 0.18070158058105062, 0.0, 0.10101525445522119 },
          { 0.0, 0.0, 0.0, -0.38253638936868667, 0.06734350297014757, -0.07776157913597413, -0.3207134902949088, 0.0903507902905252, -0.0641533027871787, 0.050507627227610714 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.382536389368687, -0.30304576336566347, 0.3110463165438961, 0.0, -0.09035079029052526, 0.14580296087995112, -0.20203050891044186 },
          { 0.0, 0.0, 0.0, 0.21300321680756457, -0.21886638465297933, 0.19440394783993478, 0.16035674514745457, -0.15811388300841953, 0.17787961227354052, -0.12626906806902655 } };
    static const double coefficients9[2][10] =
        { { 4.0, 0.0, 0.0, -0.36885555678165954, -0.47619047619047605, -1.649572197684647, 0.0, -0.31943828249997047, -0.4123930494211606, 0.5714285714285701 },
          { 0.0, 0.0, 0.0, 0.6147592613027614, 0.47619047619047705, -0.5498573992282143, 0.5669467095138392, 0.15971914124998665, -0.4536323543632775, 0.35714285714285793 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999999, 0.0, -0.6776309271789408, 1.8079567149113942, 0.0, 0.0, -0.5868455973269656, -1.2626906806902616, 0.0 },
          { 0.0, 0.0, 0.0, 1.054092553389457, 1.166423687039608, -0.3367175148507348, 1.041547612244119, 0.6846531968814584, -0.5808377131175199, 0.21870444131992586 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.9999999999999987, 0.13041013273932442, -0.8417937871268427, 0.9331389496316881, 0.0, 0.11293848786315624, -0.7290148043997547, -2.020305089104419 },
          { 0.0, 0.0, 0.0, -0.34776035397153016, 0.3367175148507357, 1.3608276348795454, -0.20044593143431666, 0.6211616832473584, 0.5977921396078001, -0.8838834764831873 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809512, 0.0, 0.0, 0.0, 0.8247860988423225, 0.0 },
          { 3.999999999999999, 0.0, 0.0, -1.5983740793871863, 0.4761904761904753, -0.5498573992282159, 0.0, -0.6388765649999417, 0.4123930494211618, -0.1428571428571425 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.355261854357879, 0.0, 0.0, 0.0, 1.173691194653929, 0.0, 0.0 },
          { 0.0, 3.999999999999996, 0.0, 0.6776309271789405, -0.5248906591678224, 0.0, -2.083095224488238, 0.5868455973269632, -0.101015254455222, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.683587574253683, 0.0, 0.0, 0.0, 1.4580296087995093, 0.0 },
          { 0.0, 0.0, 3.999999999999999, 0.8259308406823953, 0.8417937871268402, -1.7885163201274015, 0.0, -1.1293848786315663, 0.7290148043997554, -0.2525381361380519 } };
    for (std::size_t k = 0; k < num_points * 15 * 2; ++k)
        reference_values[k] = 0.0;
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Accumulate products of coefficients and basisvalues
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + c] += coefficients0[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 + c] += coefficients1[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 2 + c] += coefficients2[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 3 + c] += coefficients3[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 4 + c] += coefficients4[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 5 + c] += coefficients5[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 6 + c] += coefficients6[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 7 + c] += coefficients7[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 8 + c] += coefficients8[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 9 + c] += coefficients9[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 10 + c] += coefficients10[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 11 + c] += coefficients11[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 12 + c] += coefficients12[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 13 + c] += coefficients13[c][r] * basisvalues3[r];
        for (std::size_t c = 0; c < 2; ++c)
            for (std::size_t r = 0; r < 10; ++r)
                reference_values[15 * 2 * ip + 2 * 14 + c] += coefficients14[c][r] * basisvalues3[r];
    }
  }

  void evaluate_reference_basis_derivatives(double * reference_values,
                                            std::size_t order,
                                            std::size_t num_points,
                                            const double * X) const final override
  {
    if (order == 0)
    {
        evaluate_reference_basis(reference_values, num_points, X);
        return;
    }
    const std::size_t num_derivatives = std::pow(2, order);
    std::fill_n(reference_values, num_points * 15 * num_derivatives * 2, 0.0);
    if (order > 3)
        return;
    // Tables of derivatives of the polynomial base (transpose).
    alignas(32) static const double dmats0[2][10][10] =
        { { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
            { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } },
          { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
            { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
            { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
            { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 0.0 },
            { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } } };
    static const double coefficients0[2][10] =
        { { 0.0, 0.0, 0.0, -0.16953317256112332, 0.08417937871268429, -0.11664236870396065, 0.0, -0.14682003422210377, 0.07290148043997553, -0.10101525445522076 },
          { 0.0, 0.0, 0.0, 0.321678327423669, -0.134687005940295, 0.09720197391996724, 0.26057971086461384, -0.12987926104263017, 0.09768798378956733, -0.0631345340345131 } };
    static const double coefficients1[2][10] =
        { { 0.0, 0.0, 0.0, 0.07824607964359535, -0.1683587574253683, 0.34992710611188205, 0.0, 0.06776309271789413, -0.145802960879951, 0.30304576336566247 },
          { 0.0, 0.0, 0.0, -0.16518616813647943, 0.23570226039551642, -0.27216552697590846, -0.12026755886059136, 0.14682003422210418, -0.22453655975512488, 0.17677669529663712 } };
    static const double coefficients2[2][10] =
        { { 0.0, 0.0, 0.0, -0.039123039821797816, -0.08417937871268422, -0.34992710611188227, 0.0, -0.03388154635894715, -0.07290148043997549, -0.30304576336566286 },
          { 0.0, 0.0, 0.0, 0.06085806194501889, 0.0, 0.2138443426239283, 0.06013377943029567, 0.0395284707521043, 0.11226827987756255, -0.13889597487592942 } };
    static const double coefficients3[2][10] =
        { { 0.0, 0.0, 0.0, 0.16953317256112316, 0.08417937871268413, 0.1166423687039608, 0.0, 0.1468200342221036, 0.07290148043997546, 0.10101525445522097 },
          { 0.0, 0.0, 0.0, 0.491211499984792, 0.21886638465297922, 0.21384434262392793, -0.2605797108646135, 0.01694077317947354, -0.024786503349591843, 0.03788072042070794 } };
    static const double coefficients4[2][10] =
        { { 0.0, 0.0, 0.0, -0.07824607964359535, -0.16835875742536835, -0.34992710611188227, 0.0, -0.06776309271789413, -0.14580296087995095, -0.30304576336566286 },
          { 0.0, 0.0, 0.0, -0.2434322477800735, -0.40406101782088477, -0.6220926330877908, 0.12026755886059096, 0.07905694150420917, 0.07873359887517382, -0.12626906806902682 } };
    static const double coefficients5[2][10] =
        { { 0.0, 0.0, 0.0, 0.03912303982179783, -0.08417937871268412, 0.34992710611188205, 0.0, 0.03388154635894713, -0.07290148043997532, 0.3030457633656627 },
          { 0.0, 0.0, 0.0, 0.09998110176681535, -0.08417937871268365, 0.5637714487358108, -0.06013377943029568, 0.07341001711105219, -0.18516976031753804, 0.16414978848973458 } };
    static const double coefficients6[2][10] =
        { { 0.0, 0.0, 0.0, 0.3825363893686869, 0.30304576336566347, 0.31104631654389586, 0.0, -0.09035079029052548, -0.14580296087995084, -0.20203050891044214 },
          { 0.0, 0.0, 0.0, 0.16953317256112263, 0.08417937871268412, 0.11664236870396119, 0.16035674514745452, 0.06776309271789374, 0.032076651393589506, -0.07576144084141621 } };
    static const double coefficients7[2][10] =
        { { 0.0, 0.0, 0.0, -0.7650727787373743, 0.0, -0.1555231582719479, 0.0, 0.18070158058105062, 0.0, 0.10101525445522119 },
          { 0.0, 0.0, 0.0, -0.38253638936868667, 0.06734350297014757, -0.07776157913597413, -0.3207134902949088, 0.0903507902905252, -0.0641533027871787, 0.050507627227610714 } };
    static const double coefficients8[2][10] =
        { { 0.0, 0.0, 0.0, 0.382536389368687, -0.30304576336566347, 0.3110463165438961, 0.0, -0.09035079029052526, 0.14580296087995112, -0.20203050891044186 },
          { 0.0, 0.0, 0.0, 0.21300321680756457, -0.21886638465297933, 0.19440394783993478, 0.16035674514745457, -0.15811388300841953, 0.17787961227354052, -0.12626906806902655 } };
    static const double coefficients9[2][10] =
        { { 4.0, 0.0, 0.0, -0.36885555678165954, -0.47619047619047605, -1.649572197684647, 0.0, -0.31943828249997047, -0.4123930494211606, 0.5714285714285701 },
          { 0.0, 0.0, 0.0, 0.6147592613027614, 0.47619047619047705, -0.5498573992282143, 0.5669467095138392, 0.15971914124998665, -0.4536323543632775, 0.35714285714285793 } };
    static const double coefficients10[2][10] =
        { { 0.0, 3.999999999999999, 0.0, -0.6776309271789408, 1.8079567149113942, 0.0, 0.0, -0.5868455973269656, -1.2626906806902616, 0.0 },
          { 0.0, 0.0, 0.0, 1.054092553389457, 1.166423687039608, -0.3367175148507348, 1.041547612244119, 0.6846531968814584, -0.5808377131175199, 0.21870444131992586 } };
    static const double coefficients11[2][10] =
        { { 0.0, 0.0, 3.9999999999999987, 0.13041013273932442, -0.8417937871268427, 0.9331389496316881, 0.0, 0.11293848786315624, -0.7290148043997547, -2.020305089104419 },
          { 0.0, 0.0, 0.0, -0.34776035397153016, 0.3367175148507357, 1.3608276348795454, -0.20044593143431666, 0.6211616832473584, 0.5977921396078001, -0.8838834764831873 } };
    static const double coefficients12[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 0.9523809523809512, 0.0, 0.0, 0.0, 0.8247860988423225, 0.0 },
          { 3.999999999999999, 0.0, 0.0, -1.5983740793871863, 0.4761904761904753, -0.5498573992282159, 0.0, -0.6388765649999417, 0.4123930494211618, -0.1428571428571425 } };
    static const double coefficients13[2][10] =
        { { 0.0, 0.0, 0.0, 1.355261854357879, 0.0, 0.0, 0.0, 1.173691194653929, 0.0, 0.0 },
          { 0.0, 3.999999999999996, 0.0, 0.6776309271789405, -0.5248906591678224, 0.0, -2.083095224488238, 0.5868455973269632, -0.101015254455222, 0.0 } };
    static const double coefficients14[2][10] =
        { { 0.0, 0.0, 0.0, 0.0, 1.683587574253683, 0.0, 0.0, 0.0, 1.4580296087995093, 0.0 },
          { 0.0, 0.0, 3.999999999999999, 0.8259308406823953, 0.8417937871268402, -1.7885163201274015, 0.0, -1.1293848786315663, 0.7290148043997554, -0.2525381361380519 } };
    const std::size_t reference_offset[15] = {};
    const std::size_t num_components[15] = { 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2 };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Map from UFC reference coordinate X to FIAT reference coordinate Y
        const double Y[2] = { 2.0 * X[ip * 2] - 1.0, 2.0 * X[ip * 2 + 1] - 1.0 };
        // Compute basisvalues for each relevant embedded degree
        double basisvalues3[10] = {};
        basisvalues3[0] = 1.0;
        const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
        basisvalues3[1] = tmp1_3;
        const double tmp2_3 = (1.0 - Y[1]) / 2.0;
        const double tmp3_3 = tmp2_3 * tmp2_3;
        basisvalues3[3] = 1.5 * tmp1_3 * basisvalues3[1] - 0.5 * tmp3_3 * basisvalues3[0];
        basisvalues3[6] = 1.6666666666666667 * tmp1_3 * basisvalues3[3] - 0.6666666666666666 * tmp3_3 * basisvalues3[1];
        basisvalues3[2] = (0.5 + 1.5 * Y[1]) * basisvalues3[0];
        basisvalues3[4] = (1.5 + 2.5 * Y[1]) * basisvalues3[1];
        basisvalues3[7] = (2.5 + 3.5 * Y[1]) * basisvalues3[3];
        basisvalues3[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues3[2] - 0.5555555555555556 * basisvalues3[0];
        basisvalues3[9] = (0.05 + 1.75 * Y[1]) * basisvalues3[5] - 0.7 * basisvalues3[2];
        basisvalues3[8] = (0.54 + 2.1 * Y[1]) * basisvalues3[4] - 0.56 * basisvalues3[1];
        basisvalues3[0] *= std::sqrt(0.5);
        basisvalues3[2] *= std::sqrt(1.0);
        basisvalues3[5] *= std::sqrt(1.5);
        basisvalues3[9] *= std::sqrt(2.0);
        basisvalues3[1] *= std::sqrt(3.0);
        basisvalues3[4] *= std::sqrt(4.5);
        basisvalues3[8] *= std::sqrt(6.0);
        basisvalues3[3] *= std::sqrt(7.5);
        basisvalues3[7] *= std::sqrt(10.0);
        basisvalues3[6] *= std::sqrt(14.0);
        // Loop over all dofs
        for (std::size_t i = 0; i < 15; ++i)
        {
            double derivatives[16] = {};
            switch (i)
            {
            case 0:
                // Compute reference derivatives for dof 0.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients0[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients0[1][s] * aux[s];
                    }
                }
                break;
            case 1:
                // Compute reference derivatives for dof 1.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients1[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients1[1][s] * aux[s];
                    }
                }
                break;
            case 2:
                // Compute reference derivatives for dof 2.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients2[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients2[1][s] * aux[s];
                    }
                }
                break;
            case 3:
                // Compute reference derivatives for dof 3.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients3[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients3[1][s] * aux[s];
                    }
                }
                break;
            case 4:
                // Compute reference derivatives for dof 4.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients4[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients4[1][s] * aux[s];
                    }
                }
                break;
            case 5:
                // Compute reference derivatives for dof 5.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients5[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients5[1][s] * aux[s];
                    }
                }
                break;
            case 6:
                // Compute reference derivatives for dof 6.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients6[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients6[1][s] * aux[s];
                    }
                }
                break;
            case 7:
                // Compute reference derivatives for dof 7.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients7[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients7[1][s] * aux[s];
                    }
                }
                break;
            case 8:
                // Compute reference derivatives for dof 8.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients8[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients8[1][s] * aux[s];
                    }
                }
                break;
            case 9:
                // Compute reference derivatives for dof 9.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients9[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients9[1][s] * aux[s];
                    }
                }
                break;
            case 10:
                // Compute reference derivatives for dof 10.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients10[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients10[1][s] * aux[s];
                    }
                }
                break;
            case 11:
                // Compute reference derivatives for dof 11.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients11[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients11[1][s] * aux[s];
                    }
                }
                break;
            case 12:
                // Compute reference derivatives for dof 12.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients12[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients12[1][s] * aux[s];
                    }
                }
                break;
            case 13:
                // Compute reference derivatives for dof 13.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients13[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients13[1][s] * aux[s];
                    }
                }
                break;
            case 14:
                // Compute reference derivatives for dof 14.
                for (std::size_t r = 0; r < num_derivatives; ++r)
                {
                    double aux[10] = {};
                    // Declare derivative matrix (of polynomial basis).
                    double dmats[10][10] = {};
                    // Initialize dmats.
                    std::size_t comb = combinations[order - 1][r][0];
                    std::copy_n(&dmats0[comb][0][0], 100, &dmats[0][0]);
                    // Looping derivative order to generate dmats.
                    for (std::size_t s = 1; s < order; ++s)
                    {
                        // Store previous dmats matrix.
                        double dmats_old[10][10];
                        std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                        // Resetting dmats.
                        std::fill_n(&dmats[0][0], 100, 0.0);
                        // Update dmats using an inner product.
                        comb = combinations[order - 1][r][s];
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats0[comb][t][tu] * dmats_old[tu][u];
                    }
                    for (std::size_t s = 0; s < 10; ++s)
                        for (std::size_t t = 0; t < 10; ++t)
                            aux[s] += dmats[s][t] * basisvalues3[t];
                    derivatives[r] = 0.0;
                    derivatives[num_derivatives + r] = 0.0;
                    for (std::size_t s = 0; s < 10; ++s)
                    {
                        derivatives[r] += coefficients14[0][s] * aux[s];
                        derivatives[num_derivatives + r] += coefficients14[1][s] * aux[s];
                    }
                }
                break;
            }
            for (std::size_t r = 0; r < num_derivatives; ++r)
                for (std::size_t c = 0; c < num_components[i]; ++c)
                    reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * i + 2 * r + (reference_offset[i] + c)] = derivatives[num_derivatives * c + r];
        }
    }
  }

  void transform_reference_basis_derivatives(double * values,
                                             std::size_t order,
                                             std::size_t num_points,
                                             const double * reference_values,
                                             const double * X,
                                             const double * J,
                                             const double * detJ,
                                             const double * K,
                                             int cell_orientation) const final override
  {
    const std::size_t num_derivatives = std::pow(2, order);
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    std::fill_n(values, num_points * 15 * num_derivatives * 2, 0.0);
    const std::size_t reference_offsets[15] = {};
    const std::size_t physical_offsets[15] = {};
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        double transform[8][8];
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                transform[r][s] = 1.0;
        for (std::size_t r = 0; r < num_derivatives; ++r)
            for (std::size_t s = 0; s < num_derivatives; ++s)
                for (std::size_t k = 0; k < order; ++k)
                    transform[r][s] *= K[2 * 2 * ip + 2 * combinations[order - 1][s][k] + combinations[order - 1][r][k]];
        for (std::size_t d = 0; d < 15; ++d)
        {
            for (std::size_t s = 0; s < num_derivatives; ++s)
            {
                for (std::size_t i = 0; i < 2; ++i)
                {
                    // Using covariant Piola transform to map values back to the physical element.
                    const double mapped_value = K[2 * 2 * ip + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + reference_offsets[d]] + K[2 * 2 * ip + 2 + i] * reference_values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * s + (reference_offsets[d] + 1)];
                    // Mapping derivatives back to the physical element
                    for (std::size_t r = 0; r < num_derivatives; ++r)
                        values[15 * (num_derivatives * 2) * ip + num_derivatives * 2 * d + 2 * r + (physical_offsets[d] + i)] += transform[r][s] * mapped_value;
                }
            }
        }
    }
  }

  void evaluate_basis(std::size_t i,
                      double * values,
                      const double * x,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    double X[2] = {};
    double J[4];
    double detJ;
    double K[4];
    if (cm)
    {
        cm->compute_reference_geometry(X, J, &detJ, K, 1, x, coordinate_dofs, cell_orientation);
    }
    else
    {
        compute_jacobian_triangle_2d(J, coordinate_dofs);
        compute_jacobian_inverse_triangle_2d(K, detJ, J);
        // Compute constants
        const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
        const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
        // Get coordinates and map to the reference (FIAT) element
        double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
        // Map to FFC reference coordinate
        for (std::size_t k = 0; k < 2; ++k)
            X[k] = (Y[k] + 1.0) / 2.0;
    }
    // Evaluate basis on reference element
    double ref_values[30];
    evaluate_reference_basis(ref_values, 1, X);
    // Push forward
    double physical_values[30];
    transform_reference_basis_derivatives(physical_values, 0, 1, ref_values, X, J, &detJ, K, cell_orientation);
    for (std::size_t k = 0; k < 2; ++k)
        values[k] = physical_values[2 * i + k];
  }

  void evaluate_basis_all(double * values,
                          const double * x,
                          const double * coordinate_dofs,
                          int cell_orientation,
                          const ufc::coordinate_mapping * cm=nullptr
                          ) const final override
  {
    // Helper variable to hold values of a single dof.
    double dof_values[2] = {};
    // Loop dofs and call evaluate_basis
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis(r, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2; ++s)
            values[r * 2 + s] = dof_values[s];
    }
  }

  void evaluate_basis_derivatives(std::size_t i,
                                  std::size_t n,
                                  double * values,
                                  const double * x,
                                  const double * coordinate_dofs,
                                  int cell_orientation,
                                  const ufc::coordinate_mapping * cm=nullptr
                                  ) const final override
  {
    std::size_t num_derivatives = std::pow(2, n);
    std::fill_n(values, 2 * num_derivatives, 0.0);
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis(i, values, x, coordinate_dofs, cell_orientation);
        return;
    }
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Compute constants
    const double C0 = coordinate_dofs[2] + coordinate_dofs[4];
    const double C1 = coordinate_dofs[3] + coordinate_dofs[5];
    // Get coordinates and map to the reference (FIAT) element
    double Y[2] = { (J[1] * (C1 - 2.0 * x[1]) + J[3] * (2.0 * x[0] - C0)) / detJ, (J[0] * (2.0 * x[1] - C1) + J[2] * (C0 - 2.0 * x[0])) / detJ };
    // Precomputed combinations
    const std::size_t combinations[3][8][3] =
        { { { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 },
            { 0, 0, 0 },
            { 1, 0, 0 } },
          { { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 },
            { 0, 0, 0 },
            { 0, 1, 0 },
            { 1, 0, 0 },
            { 1, 1, 0 } },
          { { 0, 0, 0 },
            { 0, 0, 1 },
            { 0, 1, 0 },
            { 0, 1, 1 },
            { 1, 0, 0 },
            { 1, 0, 1 },
            { 1, 1, 0 },
            { 1, 1, 1 } } };
    // Declare transformation matrix
    double transform[8][8] =
        { { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 },
          { 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 } };
    // Construct transformation matrix
    for (std::size_t row = 0; row < num_derivatives; ++row)
        for (std::size_t col = 0; col < num_derivatives; ++col)
            for (std::size_t k = 0; k < n; ++k)
                transform[row][col] *= K[2 * combinations[n - 1][col][k] + combinations[n - 1][row][k]];
    switch (i)
    {
    case 0:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.16953317256112332, 0.08417937871268429, -0.11664236870396065, 0.0, -0.14682003422210377, 0.07290148043997553, -0.10101525445522076 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.321678327423669, -0.134687005940295, 0.09720197391996724, 0.26057971086461384, -0.12987926104263017, 0.09768798378956733, -0.0631345340345131 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 1:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.07824607964359535, -0.1683587574253683, 0.34992710611188205, 0.0, 0.06776309271789413, -0.145802960879951, 0.30304576336566247 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.16518616813647943, 0.23570226039551642, -0.27216552697590846, -0.12026755886059136, 0.14682003422210418, -0.22453655975512488, 0.17677669529663712 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 2:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.039123039821797816, -0.08417937871268422, -0.34992710611188227, 0.0, -0.03388154635894715, -0.07290148043997549, -0.30304576336566286 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.06085806194501889, 0.0, 0.2138443426239283, 0.06013377943029567, 0.0395284707521043, 0.11226827987756255, -0.13889597487592942 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 3:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.16953317256112316, 0.08417937871268413, 0.1166423687039608, 0.0, 0.1468200342221036, 0.07290148043997546, 0.10101525445522097 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.491211499984792, 0.21886638465297922, 0.21384434262392793, -0.2605797108646135, 0.01694077317947354, -0.024786503349591843, 0.03788072042070794 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 4:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.07824607964359535, -0.16835875742536835, -0.34992710611188227, 0.0, -0.06776309271789413, -0.14580296087995095, -0.30304576336566286 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.2434322477800735, -0.40406101782088477, -0.6220926330877908, 0.12026755886059096, 0.07905694150420917, 0.07873359887517382, -0.12626906806902682 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 5:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.03912303982179783, -0.08417937871268412, 0.34992710611188205, 0.0, 0.03388154635894713, -0.07290148043997532, 0.3030457633656627 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.09998110176681535, -0.08417937871268365, 0.5637714487358108, -0.06013377943029568, 0.07341001711105219, -0.18516976031753804, 0.16414978848973458 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 6:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.3825363893686869, 0.30304576336566347, 0.31104631654389586, 0.0, -0.09035079029052548, -0.14580296087995084, -0.20203050891044214 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.16953317256112263, 0.08417937871268412, 0.11664236870396119, 0.16035674514745452, 0.06776309271789374, 0.032076651393589506, -0.07576144084141621 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 7:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, -0.7650727787373743, 0.0, -0.1555231582719479, 0.0, 0.18070158058105062, 0.0, 0.10101525445522119 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.38253638936868667, 0.06734350297014757, -0.07776157913597413, -0.3207134902949088, 0.0903507902905252, -0.0641533027871787, 0.050507627227610714 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 8:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.382536389368687, -0.30304576336566347, 0.3110463165438961, 0.0, -0.09035079029052526, 0.14580296087995112, -0.20203050891044186 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.21300321680756457, -0.21886638465297933, 0.19440394783993478, 0.16035674514745457, -0.15811388300841953, 0.17787961227354052, -0.12626906806902655 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 9:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 4.0, 0.0, 0.0, -0.36885555678165954, -0.47619047619047605, -1.649572197684647, 0.0, -0.31943828249997047, -0.4123930494211606, 0.5714285714285701 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 0.6147592613027614, 0.47619047619047705, -0.5498573992282143, 0.5669467095138392, 0.15971914124998665, -0.4536323543632775, 0.35714285714285793 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 10:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 3.999999999999999, 0.0, -0.6776309271789408, 1.8079567149113942, 0.0, 0.0, -0.5868455973269656, -1.2626906806902616, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, 1.054092553389457, 1.166423687039608, -0.3367175148507348, 1.041547612244119, 0.6846531968814584, -0.5808377131175199, 0.21870444131992586 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 11:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 3.9999999999999987, 0.13041013273932442, -0.8417937871268427, 0.9331389496316881, 0.0, 0.11293848786315624, -0.7290148043997547, -2.020305089104419 };
            static const double coefficients1[10] = { 0.0, 0.0, 0.0, -0.34776035397153016, 0.3367175148507357, 1.3608276348795454, -0.20044593143431666, 0.6211616832473584, 0.5977921396078001, -0.8838834764831873 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 12:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 0.9523809523809512, 0.0, 0.0, 0.0, 0.8247860988423225, 0.0 };
            static const double coefficients1[10] = { 3.999999999999999, 0.0, 0.0, -1.5983740793871863, 0.4761904761904753, -0.5498573992282159, 0.0, -0.6388765649999417, 0.4123930494211618, -0.1428571428571425 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 13:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 1.355261854357879, 0.0, 0.0, 0.0, 1.173691194653929, 0.0, 0.0 };
            static const double coefficients1[10] = { 0.0, 3.999999999999996, 0.0, 0.6776309271789405, -0.5248906591678224, 0.0, -2.083095224488238, 0.5868455973269632, -0.101015254455222, 0.0 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    case 14:
        {
            double basisvalues[10] = {};
            basisvalues[0] = 1.0;
            const double tmp1_3 = (1.0 + 2.0 * Y[0] + Y[1]) / 2.0;
            basisvalues[1] = tmp1_3;
            const double tmp2_3 = (1.0 - Y[1]) / 2.0;
            const double tmp3_3 = tmp2_3 * tmp2_3;
            basisvalues[3] = 1.5 * tmp1_3 * basisvalues[1] - 0.5 * tmp3_3 * basisvalues[0];
            basisvalues[6] = 1.6666666666666667 * tmp1_3 * basisvalues[3] - 0.6666666666666666 * tmp3_3 * basisvalues[1];
            basisvalues[2] = (0.5 + 1.5 * Y[1]) * basisvalues[0];
            basisvalues[4] = (1.5 + 2.5 * Y[1]) * basisvalues[1];
            basisvalues[7] = (2.5 + 3.5 * Y[1]) * basisvalues[3];
            basisvalues[5] = (0.1111111111111111 + 1.6666666666666667 * Y[1]) * basisvalues[2] - 0.5555555555555556 * basisvalues[0];
            basisvalues[9] = (0.05 + 1.75 * Y[1]) * basisvalues[5] - 0.7 * basisvalues[2];
            basisvalues[8] = (0.54 + 2.1 * Y[1]) * basisvalues[4] - 0.56 * basisvalues[1];
            basisvalues[0] *= std::sqrt(0.5);
            basisvalues[2] *= std::sqrt(1.0);
            basisvalues[5] *= std::sqrt(1.5);
            basisvalues[9] *= std::sqrt(2.0);
            basisvalues[1] *= std::sqrt(3.0);
            basisvalues[4] *= std::sqrt(4.5);
            basisvalues[8] *= std::sqrt(6.0);
            basisvalues[3] *= std::sqrt(7.5);
            basisvalues[7] *= std::sqrt(10.0);
            basisvalues[6] *= std::sqrt(14.0);
            // Table(s) of coefficients
            static const double coefficients0[10] = { 0.0, 0.0, 0.0, 0.0, 1.683587574253683, 0.0, 0.0, 0.0, 1.4580296087995093, 0.0 };
            static const double coefficients1[10] = { 0.0, 0.0, 3.999999999999999, 0.8259308406823953, 0.8417937871268402, -1.7885163201274015, 0.0, -1.1293848786315663, 0.7290148043997554, -0.2525381361380519 };
            // Tables of derivatives of the polynomial base (transpose).
            static const double dmats0[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.898979485566352, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 9.486832980505149, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.9999999999999973, 0.0, 7.071067811865468, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 5.291502622129196, 0.0, -2.9933259094191658, 13.662601021279464, 0.0, 0.6110100926607838, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 4.381780460041362, 0.0, 0.0, 12.521980673998844, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 3.464101615137758, 0.0, 7.838367176906184, 0.0, 0.0, 8.400000000000007, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 } };
            static const double dmats1[10][10] =
                { { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.449489742783183, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 4.242640687119287, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.5819888974716196, 4.743416490252574, -0.912870929175281, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 1.9999999999999127, 6.123724356957939, 3.5355339059327346, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { -2.3094010767584914, 0.0, 8.164965809277273, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 2.6457513110645614, 5.184592558726248, -1.496662954709565, 6.831300510639718, -1.058300524425831, 0.3055050463303899, 0.0, 0.0, 0.0, 0.0 },
                  { 2.2360679774998315, 2.1908902300206905, 2.529822128134684, 8.082903768654774, 6.260990336999418, -1.807392228230127, 0.0, 0.0, 0.0, 0.0 },
                  { 1.7320508075688799, -5.091168824543124, 3.919183588453103, 0.0, 9.699484522385703, 4.200000000000008, 0.0, 0.0, 0.0, 1.1546319456101628e-14 },
                  { 5.000000000000023, 0.0, -2.828427124746265, 0.0, 0.0, 12.124355652982134, 0.0, 0.0, 0.0, 0.0 } };
            // Compute reference derivatives.
            // Declare array of derivatives on FIAT element.
            double derivatives[16] = {};
            // Declare derivative matrix (of polynomial basis).
            double dmats[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Declare (auxiliary) derivative matrix (of polynomial basis).
            double dmats_old[10][10] =
                { { 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0 },
                  { 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0 } };
            // Loop possible derivatives.
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                // Reset dmats to identity
                std::fill_n(&dmats[0][0], 100, 0.0);
                for (std::size_t t = 0; t < 10; ++t)
                    dmats[t][t] = 1.0;
                // Looping derivative order to generate dmats.
                for (std::size_t s = 0; s < n; ++s)
                {
                    std::copy_n(&dmats[0][0], 100, &dmats_old[0][0]);
                    std::fill_n(&dmats[0][0], 100, 0.0);
                    // Update dmats using an inner product.
                    // _dmats_product(shape_dmats, comb[r][s], 0)
                    if (combinations[n - 1][r][s] == 0)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats0[t][tu];
                    }
                    // _dmats_product(shape_dmats, comb[r][s], 1)
                    if (combinations[n - 1][r][s] == 1)
                    {
                        for (std::size_t t = 0; t < 10; ++t)
                            for (std::size_t u = 0; u < 10; ++u)
                                for (std::size_t tu = 0; tu < 10; ++tu)
                                    dmats[t][u] += dmats_old[tu][u] * dmats1[t][tu];
                    }
                }
                for (std::size_t s = 0; s < 10; ++s)
                {
                    for (std::size_t t = 0; t < 10; ++t)
                    {
                        derivatives[r] += coefficients0[s] * dmats[s][t] * basisvalues[t];
                        derivatives[num_derivatives + r] += coefficients1[s] * dmats[s][t] * basisvalues[t];
                    }
                }
                const double tmp_ref[2] = { derivatives[r], derivatives[num_derivatives + r] };
                // Using covariant Piola transform to map values back to the physical element
                derivatives[r] = K[0] * tmp_ref[0] + K[2] * tmp_ref[1];
                derivatives[num_derivatives + r] = K[1] * tmp_ref[0] + K[2 + 1] * tmp_ref[1];
            }
            // Transform derivatives back to physical element
            for (std::size_t r = 0; r < num_derivatives; ++r)
            {
                for (std::size_t s = 0; s < num_derivatives; ++s)
                {
                    values[r] += transform[r][s] * derivatives[s];
                    values[num_derivatives + r] += transform[r][s] * derivatives[num_derivatives + s];
                }
            }
        }
        break;
    }
  }

  void evaluate_basis_derivatives_all(std::size_t n,
                                      double * values,
                                      const double * x,
                                      const double * coordinate_dofs,
                                      int cell_orientation,
                                      const ufc::coordinate_mapping * cm=nullptr
                                      ) const final override
  {
    // Call evaluate_basis_all if order of derivatives is equal to zero.
    if (n == 0)
    {
        evaluate_basis_all(values, x, coordinate_dofs, cell_orientation);
        return;
    }
    unsigned int num_derivatives = std::pow(2, n);
    // Set values equal to zero.
    std::fill_n(values, 2 * num_derivatives * 15, 0.0);
    // If order of derivatives is greater than the maximum polynomial degree, return zeros.
    if (n > 3)
        return;
    // Helper variable to hold values of a single dof.
    double dof_values[16] = {};
    // Loop dofs and call evaluate_basis_derivatives.
    for (std::size_t r = 0; r < 15; ++r)
    {
        evaluate_basis_derivatives(r, n, dof_values, x, coordinate_dofs, cell_orientation);
        for (std::size_t s = 0; s < 2 * num_derivatives; ++s)
            values[2 * num_derivatives * r + s] = dof_values[s];
    }
  }

  double evaluate_dof(std::size_t i,
                      const ufc::function& f,
                      const double * coordinate_dofs,
                      int cell_orientation,
                      const ufc::cell& c,
                      const ufc::coordinate_mapping * cm=nullptr
                      ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    switch (i)
    {
    case 0:
        {
            y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 1:
        {
            y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 2:
        {
            y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
        }
        break;
    case 3:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 4:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 5:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
            f.evaluate(vals, y, c);
            return vals[0] * J[1] + vals[1] * J[2 + 1];
        }
        break;
    case 6:
        {
            y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
            y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 7:
        {
            y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
            y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 8:
        {
            y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
            y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
            f.evaluate(vals, y, c);
            return vals[0] * J[0] + vals[1] * J[2];
        }
        break;
    case 9:
        {
            result = 0.0;
            double X_9[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_9[36][1] = {};
            double W_9[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_9[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_9[r][0] - X_9[r][1];
                const double w1 = X_9[r][0];
                const double w2 = X_9[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_9[D_9[r][s]] * W_9[r][s];
            }
            return result;
        }
        break;
    case 10:
        {
            result = 0.0;
            double X_10[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_10[36][1] = {};
            double W_10[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_10[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_10[r][0] - X_10[r][1];
                const double w1 = X_10[r][0];
                const double w2 = X_10[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_10[D_10[r][s]] * W_10[r][s];
            }
            return result;
        }
        break;
    case 11:
        {
            result = 0.0;
            double X_11[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_11[36][1] = {};
            double W_11[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_11[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_11[r][0] - X_11[r][1];
                const double w1 = X_11[r][0];
                const double w2 = X_11[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_11[D_11[r][s]] * W_11[r][s];
            }
            return result;
        }
        break;
    case 12:
        {
            result = 0.0;
            double X_12[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_12[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_12[36][1] =
                { { 0.004380007035333952 },
                  { 0.00821012828325171 },
                  { 0.008528136573677752 },
                  { 0.0059761382734593235 },
                  { 0.002662467899383865 },
                  { 0.0005292995210569465 },
                  { 0.009223072580491742 },
                  { 0.017288239137681006 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.011962482987098903 },
                  { 0.022423142044750127 },
                  { 0.023291672330955 },
                  { 0.016321766574367406 },
                  { 0.0072716154775874856 },
                  { 0.001445599622248223 },
                  { 0.011962482987098896 },
                  { 0.022423142044750117 },
                  { 0.023291672330954985 },
                  { 0.016321766574367395 },
                  { 0.007271615477587481 },
                  { 0.0014455996222482222 },
                  { 0.009223072580491742 },
                  { 0.01728823913768101 },
                  { 0.017957875857470856 },
                  { 0.012584079569399019 },
                  { 0.005606414437499757 },
                  { 0.001114557090923834 },
                  { 0.004380007035333964 },
                  { 0.008210128283251733 },
                  { 0.008528136573677774 },
                  { 0.005976138273459339 },
                  { 0.0026624678993838725 },
                  { 0.000529299521056948 } };
            double copy_12[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_12[r][0] - X_12[r][1];
                const double w1 = X_12[r][0];
                const double w2 = X_12[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_12[D_12[r][s]] * W_12[r][s];
            }
            return result;
        }
        break;
    case 13:
        {
            result = 0.0;
            double X_13[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_13[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_13[36][1] =
                { { -0.009710973194534896 },
                  { -0.015975694174423887 },
                  { -0.012914808498775162 },
                  { -0.006024109540551331 },
                  { -0.0014033523604530267 },
                  { -8.831972792250468e-5 },
                  { -0.01449999797697064 },
                  { -0.023854203751711895 },
                  { -0.019283823912786737 },
                  { -0.00899493535830189 },
                  { -0.00209542400951097 },
                  { -0.00013187513244538945 },
                  { -0.006787033586233021 },
                  { -0.011165469284399073 },
                  { -0.009026205436370045 },
                  { -0.0042102715103650165 },
                  { -0.0009808079389071213 },
                  { -6.172697089456968e-5 },
                  { 0.006787033586233017 },
                  { 0.011165469284399062 },
                  { 0.00902620543637004 },
                  { 0.004210271510365018 },
                  { 0.0009808079389071207 },
                  { 6.172697089456923e-5 },
                  { 0.014499997976970646 },
                  { 0.023854203751711905 },
                  { 0.01928382391278674 },
                  { 0.008994935358301898 },
                  { 0.00209542400951097 },
                  { 0.00013187513244538915 },
                  { 0.00971097319453492 },
                  { 0.015975694174423925 },
                  { 0.012914808498775193 },
                  { 0.006024109540551347 },
                  { 0.0014033523604530306 },
                  { 8.831972792250464e-5 } };
            double copy_13[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_13[r][0] - X_13[r][1];
                const double w1 = X_13[r][0];
                const double w2 = X_13[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_13[D_13[r][s]] * W_13[r][s];
            }
            return result;
        }
        break;
    case 14:
        {
            result = 0.0;
            double X_14[36][2] =
                { { 0.0327753666144599, 0.029316427159784886 },
                  { 0.028765333012559124, 0.1480785996684843 },
                  { 0.022386872978030603, 0.3369846902811543 },
                  { 0.014901563366671144, 0.5586715187715502 },
                  { 0.00779187470128645, 0.7692338620300545 },
                  { 0.0024666971526702275, 0.926945671319741 },
                  { 0.1644292415948274, 0.029316427159784886 },
                  { 0.14431148695041662, 0.1480785996684843 },
                  { 0.11231168178095369, 0.3369846902811543 },
                  { 0.07475897346264909, 0.5586715187715502 },
                  { 0.039090700732824224, 0.7692338620300545 },
                  { 0.01237506041744002, 0.926945671319741 },
                  { 0.36952992437237664, 0.029316427159784886 },
                  { 0.324318304588776, 0.1480785996684843 },
                  { 0.252403568076518, 0.3369846902811543 },
                  { 0.16800951912119183, 0.5586715187715502 },
                  { 0.0878504549759972, 0.7692338620300545 },
                  { 0.027811082115360597, 0.926945671319741 },
                  { 0.6011536484678385, 0.029316427159784886 },
                  { 0.5276030957427397, 0.1480785996684843 },
                  { 0.4106117416423277, 0.3369846902811543 },
                  { 0.27331896210725803, 0.5586715187715502 },
                  { 0.1429156829939483, 0.7692338620300545 },
                  { 0.04524324656489831, 0.926945671319741 },
                  { 0.8062543312453878, 0.029316427159784886 },
                  { 0.7076099133810991, 0.1480785996684843 },
                  { 0.5507036279378921, 0.3369846902811543 },
                  { 0.36656950776580083, 0.5586715187715502 },
                  { 0.19167543723712127, 0.7692338620300545 },
                  { 0.060679268262818886, 0.926945671319741 },
                  { 0.9379082062257551, 0.029316427159784886 },
                  { 0.8231560673189564, 0.1480785996684843 },
                  { 0.640628436740815, 0.3369846902811543 },
                  { 0.42642691786177866, 0.5586715187715502 },
                  { 0.22297426326865905, 0.7692338620300545 },
                  { 0.07058763152758862, 0.926945671319741 } };
            int D_14[36][1] =
                { { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 },
                  { 1 } };
            double W_14[36][1] =
                { { -0.00564948416560004 },
                  { -0.006452908537728117 },
                  { 0.0001321127369674421 },
                  { 0.005713361221947881 },
                  { 0.00492388644483935 },
                  { 0.0013330322995734722 },
                  { -0.011896237170700168 },
                  { -0.013588024703755641 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.015429623211032667 },
                  { -0.017623900595856532 },
                  { 0.0003608205091003015 },
                  { 0.015604081423921987 },
                  { 0.013447902560801864 },
                  { 0.0036407193130650224 },
                  { -0.015429623211032657 },
                  { -0.017623900595856525 },
                  { 0.00036082050910030123 },
                  { 0.015604081423921978 },
                  { 0.013447902560801856 },
                  { 0.0036407193130650202 },
                  { -0.011896237170700168 },
                  { -0.013588024703755645 },
                  { 0.000278192558146252 },
                  { 0.012030744426549674 },
                  { 0.010368330847986927 },
                  { 0.002806994041772937 },
                  { -0.005649484165600055 },
                  { -0.006452908537728134 },
                  { 0.00013211273696744246 },
                  { 0.005713361221947897 },
                  { 0.004923886444839364 },
                  { 0.0013330322995734759 } };
            double copy_14[2];
            // Loop over points
            for (std::size_t r = 0; r < 36; ++r)
            {
                // Evaluate basis functions for affine mapping
                const double w0 = 1 - X_14[r][0] - X_14[r][1];
                const double w1 = X_14[r][0];
                const double w2 = X_14[r][1];
                // Compute affine mapping y = F(X)
                y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
                y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
                // Evaluate function at physical point
                f.evaluate(vals, y, c);
                // Map function to reference element
                copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
                copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
                // Loop over directions
                for (std::size_t s = 0; s < 1; ++s)
                    result += copy_14[D_14[r][s]] * W_14[r][s];
            }
            return result;
        }
        break;
    }
    return 0.0;
  }

  void evaluate_dofs(double * values,
                             const ufc::function& f,
                             const double * coordinate_dofs,
                             int cell_orientation,
                             const ufc::cell& c,
                             const ufc::coordinate_mapping * cm=nullptr
                             ) const final override
  {
    // Declare variables for result of evaluation
    double vals[2];
    // Declare variable for physical coordinates
    double y[2];
    double result;
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    y[0] = 0.75 * coordinate_dofs[2] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[3] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[0] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.5 * coordinate_dofs[2] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[3] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[1] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.25 * coordinate_dofs[2] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[3] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[2] = -(vals[0] * J[0] + vals[1] * J[2]) + (vals[0] * J[1] + vals[1] * J[2 + 1]);
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[4];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[3] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[4];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[4] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[4];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[5];
    f.evaluate(vals, y, c);
    values[5] = vals[0] * J[1] + vals[1] * J[2 + 1];
    y[0] = 0.75 * coordinate_dofs[0] + 0.25 * coordinate_dofs[2];
    y[1] = 0.75 * coordinate_dofs[1] + 0.25 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[6] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.5 * coordinate_dofs[0] + 0.5 * coordinate_dofs[2];
    y[1] = 0.5 * coordinate_dofs[1] + 0.5 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[7] = vals[0] * J[0] + vals[1] * J[2];
    y[0] = 0.25 * coordinate_dofs[0] + 0.75 * coordinate_dofs[2];
    y[1] = 0.25 * coordinate_dofs[1] + 0.75 * coordinate_dofs[3];
    f.evaluate(vals, y, c);
    values[8] = vals[0] * J[0] + vals[1] * J[2];
    result = 0.0;
    double X_9[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_9[36][1] = {};
    double W_9[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_9[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_9[r][0] - X_9[r][1];
        const double w1 = X_9[r][0];
        const double w2 = X_9[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_9[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_9[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_9[D_9[r][s]] * W_9[r][s];
    }
    values[9] = result;
    result = 0.0;
    double X_10[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_10[36][1] = {};
    double W_10[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_10[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_10[r][0] - X_10[r][1];
        const double w1 = X_10[r][0];
        const double w2 = X_10[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_10[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_10[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_10[D_10[r][s]] * W_10[r][s];
    }
    values[10] = result;
    result = 0.0;
    double X_11[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_11[36][1] = {};
    double W_11[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_11[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_11[r][0] - X_11[r][1];
        const double w1 = X_11[r][0];
        const double w2 = X_11[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_11[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_11[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_11[D_11[r][s]] * W_11[r][s];
    }
    values[11] = result;
    result = 0.0;
    double X_12[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_12[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_12[36][1] =
        { { 0.004380007035333952 },
          { 0.00821012828325171 },
          { 0.008528136573677752 },
          { 0.0059761382734593235 },
          { 0.002662467899383865 },
          { 0.0005292995210569465 },
          { 0.009223072580491742 },
          { 0.017288239137681006 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.011962482987098903 },
          { 0.022423142044750127 },
          { 0.023291672330955 },
          { 0.016321766574367406 },
          { 0.0072716154775874856 },
          { 0.001445599622248223 },
          { 0.011962482987098896 },
          { 0.022423142044750117 },
          { 0.023291672330954985 },
          { 0.016321766574367395 },
          { 0.007271615477587481 },
          { 0.0014455996222482222 },
          { 0.009223072580491742 },
          { 0.01728823913768101 },
          { 0.017957875857470856 },
          { 0.012584079569399019 },
          { 0.005606414437499757 },
          { 0.001114557090923834 },
          { 0.004380007035333964 },
          { 0.008210128283251733 },
          { 0.008528136573677774 },
          { 0.005976138273459339 },
          { 0.0026624678993838725 },
          { 0.000529299521056948 } };
    double copy_12[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_12[r][0] - X_12[r][1];
        const double w1 = X_12[r][0];
        const double w2 = X_12[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_12[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_12[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_12[D_12[r][s]] * W_12[r][s];
    }
    values[12] = result;
    result = 0.0;
    double X_13[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_13[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_13[36][1] =
        { { -0.009710973194534896 },
          { -0.015975694174423887 },
          { -0.012914808498775162 },
          { -0.006024109540551331 },
          { -0.0014033523604530267 },
          { -8.831972792250468e-5 },
          { -0.01449999797697064 },
          { -0.023854203751711895 },
          { -0.019283823912786737 },
          { -0.00899493535830189 },
          { -0.00209542400951097 },
          { -0.00013187513244538945 },
          { -0.006787033586233021 },
          { -0.011165469284399073 },
          { -0.009026205436370045 },
          { -0.0042102715103650165 },
          { -0.0009808079389071213 },
          { -6.172697089456968e-5 },
          { 0.006787033586233017 },
          { 0.011165469284399062 },
          { 0.00902620543637004 },
          { 0.004210271510365018 },
          { 0.0009808079389071207 },
          { 6.172697089456923e-5 },
          { 0.014499997976970646 },
          { 0.023854203751711905 },
          { 0.01928382391278674 },
          { 0.008994935358301898 },
          { 0.00209542400951097 },
          { 0.00013187513244538915 },
          { 0.00971097319453492 },
          { 0.015975694174423925 },
          { 0.012914808498775193 },
          { 0.006024109540551347 },
          { 0.0014033523604530306 },
          { 8.831972792250464e-5 } };
    double copy_13[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_13[r][0] - X_13[r][1];
        const double w1 = X_13[r][0];
        const double w2 = X_13[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_13[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_13[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_13[D_13[r][s]] * W_13[r][s];
    }
    values[13] = result;
    result = 0.0;
    double X_14[36][2] =
        { { 0.0327753666144599, 0.029316427159784886 },
          { 0.028765333012559124, 0.1480785996684843 },
          { 0.022386872978030603, 0.3369846902811543 },
          { 0.014901563366671144, 0.5586715187715502 },
          { 0.00779187470128645, 0.7692338620300545 },
          { 0.0024666971526702275, 0.926945671319741 },
          { 0.1644292415948274, 0.029316427159784886 },
          { 0.14431148695041662, 0.1480785996684843 },
          { 0.11231168178095369, 0.3369846902811543 },
          { 0.07475897346264909, 0.5586715187715502 },
          { 0.039090700732824224, 0.7692338620300545 },
          { 0.01237506041744002, 0.926945671319741 },
          { 0.36952992437237664, 0.029316427159784886 },
          { 0.324318304588776, 0.1480785996684843 },
          { 0.252403568076518, 0.3369846902811543 },
          { 0.16800951912119183, 0.5586715187715502 },
          { 0.0878504549759972, 0.7692338620300545 },
          { 0.027811082115360597, 0.926945671319741 },
          { 0.6011536484678385, 0.029316427159784886 },
          { 0.5276030957427397, 0.1480785996684843 },
          { 0.4106117416423277, 0.3369846902811543 },
          { 0.27331896210725803, 0.5586715187715502 },
          { 0.1429156829939483, 0.7692338620300545 },
          { 0.04524324656489831, 0.926945671319741 },
          { 0.8062543312453878, 0.029316427159784886 },
          { 0.7076099133810991, 0.1480785996684843 },
          { 0.5507036279378921, 0.3369846902811543 },
          { 0.36656950776580083, 0.5586715187715502 },
          { 0.19167543723712127, 0.7692338620300545 },
          { 0.060679268262818886, 0.926945671319741 },
          { 0.9379082062257551, 0.029316427159784886 },
          { 0.8231560673189564, 0.1480785996684843 },
          { 0.640628436740815, 0.3369846902811543 },
          { 0.42642691786177866, 0.5586715187715502 },
          { 0.22297426326865905, 0.7692338620300545 },
          { 0.07058763152758862, 0.926945671319741 } };
    int D_14[36][1] =
        { { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 },
          { 1 } };
    double W_14[36][1] =
        { { -0.00564948416560004 },
          { -0.006452908537728117 },
          { 0.0001321127369674421 },
          { 0.005713361221947881 },
          { 0.00492388644483935 },
          { 0.0013330322995734722 },
          { -0.011896237170700168 },
          { -0.013588024703755641 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.015429623211032667 },
          { -0.017623900595856532 },
          { 0.0003608205091003015 },
          { 0.015604081423921987 },
          { 0.013447902560801864 },
          { 0.0036407193130650224 },
          { -0.015429623211032657 },
          { -0.017623900595856525 },
          { 0.00036082050910030123 },
          { 0.015604081423921978 },
          { 0.013447902560801856 },
          { 0.0036407193130650202 },
          { -0.011896237170700168 },
          { -0.013588024703755645 },
          { 0.000278192558146252 },
          { 0.012030744426549674 },
          { 0.010368330847986927 },
          { 0.002806994041772937 },
          { -0.005649484165600055 },
          { -0.006452908537728134 },
          { 0.00013211273696744246 },
          { 0.005713361221947897 },
          { 0.004923886444839364 },
          { 0.0013330322995734759 } };
    double copy_14[2];
    // Loop over points
    for (std::size_t r = 0; r < 36; ++r)
    {
        // Evaluate basis functions for affine mapping
        const double w0 = 1 - X_14[r][0] - X_14[r][1];
        const double w1 = X_14[r][0];
        const double w2 = X_14[r][1];
        // Compute affine mapping y = F(X)
        y[0] = w0 * coordinate_dofs[0] + w1 * coordinate_dofs[2] + w2 * coordinate_dofs[4];
        y[1] = w0 * coordinate_dofs[1] + w1 * coordinate_dofs[3] + w2 * coordinate_dofs[5];
        // Evaluate function at physical point
        f.evaluate(vals, y, c);
        // Map function to reference element
        copy_14[0] = vals[0] * J[0] + vals[1] * J[2];
        copy_14[1] = vals[0] * J[1] + vals[1] * J[2 + 1];
        // Loop over directions
        for (std::size_t s = 0; s < 1; ++s)
            result += copy_14[D_14[r][s]] * W_14[r][s];
    }
    values[14] = result;
  }

  void interpolate_vertex_values(double * vertex_values,
                                 const double * dof_values,
                                 const double * coordinate_dofs,
                                 int cell_orientation,
                                 const ufc::coordinate_mapping * cm=nullptr
                                 ) const final override
  {
    // Compute Jacobian
    double J[4];
    compute_jacobian_triangle_2d(J, coordinate_dofs);
    // Compute Inverse Jacobian and determinant
    double K[4];
    double detJ;
    compute_jacobian_inverse_triangle_2d(K, detJ, J);
    // Evaluate function and change variables
    vertex_values[0] = dof_values[3] * (K[2] * 3.0) + dof_values[4] * (K[2] * -2.9999999999999982) + dof_values[5] * K[2] + dof_values[6] * (K[0] * 3.0) + dof_values[7] * (K[0] * -3.0000000000000004) + dof_values[8] * K[0];
    vertex_values[2] = dof_values[0] * (K[2] * 3.000000000000001) + dof_values[1] * (K[2] * -3.0000000000000075) + dof_values[2] * K[2] + dof_values[6] * (K[0] + K[2]) + dof_values[7] * (K[0] * -2.9999999999999987 + K[2] * -2.999999999999997) + dof_values[8] * (K[0] * 2.999999999999999 + K[2] * 3.0000000000000018);
    vertex_values[4] = dof_values[0] * -K[0] + dof_values[1] * (K[0] * 2.9999999999999942) + dof_values[2] * (K[0] * -2.999999999999997) + dof_values[3] * (K[0] + K[2]) + dof_values[4] * (K[0] * -2.999999999999997 + K[2] * -3.0000000000000013) + dof_values[5] * (K[0] * 2.999999999999995 + K[2] * 3.0000000000000018);
    vertex_values[1] = dof_values[3] * (K[2 + 1] * 3.0) + dof_values[4] * (K[2 + 1] * -2.9999999999999982) + dof_values[5] * K[2 + 1] + dof_values[6] * (K[1] * 3.0) + dof_values[7] * (K[1] * -3.0000000000000004) + dof_values[8] * K[1];
    vertex_values[3] = dof_values[0] * (K[2 + 1] * 3.000000000000001) + dof_values[1] * (K[2 + 1] * -3.0000000000000075) + dof_values[2] * K[2 + 1] + dof_values[6] * (K[1] + K[2 + 1]) + dof_values[7] * (K[1] * -2.9999999999999987 + K[2 + 1] * -2.999999999999997) + dof_values[8] * (K[1] * 2.999999999999999 + K[2 + 1] * 3.0000000000000018);
    vertex_values[5] = dof_values[0] * -K[1] + dof_values[1] * (K[1] * 2.9999999999999942) + dof_values[2] * (K[1] * -2.999999999999997) + dof_values[3] * (K[1] + K[2 + 1]) + dof_values[4] * (K[1] * -2.999999999999997 + K[2 + 1] * -3.0000000000000013) + dof_values[5] * (K[1] * 2.999999999999995 + K[2 + 1] * 3.0000000000000018);
  }

  void tabulate_dof_coordinates(double * dof_coordinates,
                                const double * coordinate_dofs,
                                const ufc::coordinate_mapping * cm=nullptr
                                ) const final override
  {
    throw std::runtime_error("tabulate_dof_coordinates is not defined for this element");
  }

  void tabulate_reference_dof_coordinates(double * reference_dof_coordinates) const final override
  {
    throw std::runtime_error("tabulate_reference_dof_coordinates is not defined for this element");
  }

  std::size_t num_sub_elements() const final override
  {
    return 0;
  }

  ufc::finite_element * create_sub_element(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::finite_element * create() const final override
  {
    return new forms_finite_element_2();
  }

};


class forms_dofmap_0: public ufc::dofmap
{
public:

  forms_dofmap_0() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Lagrange', triangle, 1)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 3;
  }

  std::size_t num_element_dofs() const final override
  {
    return 3;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 2;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 1, 2, 3 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    dofs[0] = entity_indices[0][0];
    dofs[1] = entity_indices[0][1];
    dofs[2] = entity_indices[0][2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            break;
        case 1:
            dofs[0] = 1;
            break;
        case 2:
            dofs[0] = 2;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_0();
  }

};


class forms_dofmap_1: public ufc::dofmap
{
public:

  forms_dofmap_1() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { true, false, false };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 2 * num_global_entities[0];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 6;
  }

  std::size_t num_element_dofs() const final override
  {
    return 6;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 4;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 0, 0 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 2, 4, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + entity_indices[0][0];
    dofs[1] = offset + entity_indices[0][1];
    dofs[2] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
    dofs[3] = offset + entity_indices[0][0];
    dofs[4] = offset + entity_indices[0][1];
    dofs[5] = offset + entity_indices[0][2];
    offset += num_global_entities[0];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 1;
        dofs[1] = 2;
        dofs[2] = 4;
        dofs[3] = 5;
        break;
    case 1:
        dofs[0] = 0;
        dofs[1] = 2;
        dofs[2] = 3;
        dofs[3] = 5;
        break;
    case 2:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 3;
        dofs[3] = 4;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 3;
            break;
        case 1:
            dofs[0] = 1;
            dofs[1] = 4;
            break;
        case 2:
            dofs[0] = 2;
            dofs[1] = 5;
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 1;
            dofs[1] = 2;
            dofs[2] = 4;
            dofs[3] = 5;
            break;
        case 1:
            dofs[0] = 0;
            dofs[1] = 2;
            dofs[2] = 3;
            dofs[3] = 5;
            break;
        case 2:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 3;
            dofs[3] = 4;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 2;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_0();
    case 1:
        return new forms_dofmap_0();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_1();
  }

};


class forms_dofmap_2: public ufc::dofmap
{
public:

  forms_dofmap_2() : ufc::dofmap()
  {
    // Do nothing
  }

  ~forms_dofmap_2() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC dofmap for FiniteElement('Nedelec 1st kind H(curl)', triangle, 3)";
  }

  bool needs_mesh_entities(std::size_t d) const final override
  {
    static const bool return_values[3] = { false, true, true };
    if (d >= 3)
        return false;
    return return_values[d];
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  std::size_t global_dimension(const std::vector<std::size_t>&
                               num_global_entities) const final override
  {
    return 3 * num_global_entities[1] + 6 * num_global_entities[2];
  }

  std::size_t num_global_support_dofs() const final override
  {
    return 0;
  }

  std::size_t num_element_support_dofs() const final override
  {
    return 15;
  }

  std::size_t num_element_dofs() const final override
  {
    return 15;
  }

  std::size_t num_facet_dofs() const final override
  {
    return 3;
  }

  std::size_t num_entity_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 6 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  std::size_t num_entity_closure_dofs(std::size_t d) const final override
  {
    static const std::size_t return_values[3] = { 0, 3, 15 };
    if (d >= 3)
        return 0;
    return return_values[d];
  }

  void tabulate_dofs(std::size_t * dofs,
                     const std::vector<std::size_t>& num_global_entities,
                     const std::vector<std::vector<std::size_t>>& entity_indices) const final override
  {
    std::size_t offset = 0;
    dofs[0] = offset + 3 * entity_indices[1][0];
    dofs[1] = offset + 3 * entity_indices[1][0] + 1;
    dofs[2] = offset + 3 * entity_indices[1][0] + 2;
    dofs[3] = offset + 3 * entity_indices[1][1];
    dofs[4] = offset + 3 * entity_indices[1][1] + 1;
    dofs[5] = offset + 3 * entity_indices[1][1] + 2;
    dofs[6] = offset + 3 * entity_indices[1][2];
    dofs[7] = offset + 3 * entity_indices[1][2] + 1;
    dofs[8] = offset + 3 * entity_indices[1][2] + 2;
    offset += 3 * num_global_entities[1];
    dofs[9] = offset + 6 * entity_indices[2][0];
    dofs[10] = offset + 6 * entity_indices[2][0] + 1;
    dofs[11] = offset + 6 * entity_indices[2][0] + 2;
    dofs[12] = offset + 6 * entity_indices[2][0] + 3;
    dofs[13] = offset + 6 * entity_indices[2][0] + 4;
    dofs[14] = offset + 6 * entity_indices[2][0] + 5;
    offset += 6 * num_global_entities[2];
  }

  void tabulate_facet_dofs(std::size_t * dofs,
                           std::size_t facet) const final override
  {
    switch (facet)
    {
    case 0:
        dofs[0] = 0;
        dofs[1] = 1;
        dofs[2] = 2;
        break;
    case 1:
        dofs[0] = 3;
        dofs[1] = 4;
        dofs[2] = 5;
        break;
    case 2:
        dofs[0] = 6;
        dofs[1] = 7;
        dofs[2] = 8;
        break;
    }
  }

  void tabulate_entity_dofs(std::size_t * dofs,
                            std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 9;
            dofs[1] = 10;
            dofs[2] = 11;
            dofs[3] = 12;
            dofs[4] = 13;
            dofs[5] = 14;
            break;
        }
        break;
    }
  }

  void tabulate_entity_closure_dofs(std::size_t * dofs,
                                    std::size_t d, std::size_t i) const final override
  {
    switch (d)
    {
    case 0:
        switch (i)
        {
        case 0:
            break;
        case 1:
            break;
        case 2:
            break;
        }
        break;
    case 1:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            break;
        case 1:
            dofs[0] = 3;
            dofs[1] = 4;
            dofs[2] = 5;
            break;
        case 2:
            dofs[0] = 6;
            dofs[1] = 7;
            dofs[2] = 8;
            break;
        }
        break;
    case 2:
        switch (i)
        {
        case 0:
            dofs[0] = 0;
            dofs[1] = 1;
            dofs[2] = 2;
            dofs[3] = 3;
            dofs[4] = 4;
            dofs[5] = 5;
            dofs[6] = 6;
            dofs[7] = 7;
            dofs[8] = 8;
            dofs[9] = 9;
            dofs[10] = 10;
            dofs[11] = 11;
            dofs[12] = 12;
            dofs[13] = 13;
            dofs[14] = 14;
            break;
        }
        break;
    }
  }


  std::size_t num_sub_dofmaps() const final override
  {
    return 0;
  }

  ufc::dofmap * create_sub_dofmap(std::size_t i) const final override
  {
    return nullptr;
  }

  ufc::dofmap * create() const final override
  {
    return new forms_dofmap_2();
  }

};


class forms_coordinate_mapping_1: public ufc::coordinate_mapping
{
public:

  forms_coordinate_mapping_1() : ufc::coordinate_mapping()
  {
    // Do nothing
  }

  ~forms_coordinate_mapping_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "FFC coordinate_mapping from VectorElement(FiniteElement('Lagrange', triangle, 1), dim=2)";
  }

  ufc::coordinate_mapping * create() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  std::size_t geometric_dimension() const final override
  {
    return 2;
  }

  std::size_t topological_dimension() const final override
  {
    return 2;
  }

  ufc::shape cell_shape() const final override
  {
    return ufc::shape::triangle;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
  }

  void compute_physical_coordinates(
      double * x, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double phi[3];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis values of coordinate element
        xelement.evaluate_reference_basis(phi, 1, &X[2 * ip]);
        // Compute x
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t d = 0; d < 3; ++d)
                x[2 * ip + i] += coordinate_dofs[2 * d + i] * phi[d];
    }
  }

  void compute_reference_coordinates(
      double * X, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double J[4];
    double detJ[1];
    double K[4];
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_reference_geometry(
      double * X, double * J, double * detJ, double * K, std::size_t num_points,
      const double * x,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    const double phi_X0[3] = { 1.0, 0.0, 0.0 };
    const double dphi_X0[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    double x0[2] = {};
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t k = 0; k < 3; ++k)
            x0[i] += coordinate_dofs[2 * k + i] * phi_X0[k];
    for (std::size_t i = 0; i < 2; ++i)
    {
        for (std::size_t j = 0; j < 2; ++j)
        {
            J[2 * i + j] = 0.0;
            for (std::size_t k = 0; k < 3; ++k)
                J[2 * i + j] += coordinate_dofs[2 * k + i] * dphi_X0[j][k];
        }
    }
    compute_jacobian_determinants(detJ, 1, J, cell_orientation);
    compute_jacobian_inverses(K, 1, J, detJ);
    for (std::size_t ip = 0; ip < num_points; ++ip)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t i = 0; i < 2; ++i)
                X[2 * ip + j] += K[2 * j + i] * (x[2 * ip + i] - x0[i]);
  }

  void compute_jacobians(
      double * J, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs) const final override
  {
    forms_finite_element_0 xelement;
    double dphi[6];
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        // Compute basis derivatives of coordinate element
        xelement.evaluate_reference_basis_derivatives(dphi, 1, 1, &X[2 * ip]);
        // Compute J
        for (std::size_t i = 0; i < 2; ++i)
            for (std::size_t j = 0; j < 2; ++j)
                for (std::size_t d = 0; d < 3; ++d)
                    J[2 * 2 * ip + 2 * i + j] += coordinate_dofs[2 * d + i] * dphi[2 * d + j];
    }
  }

  void compute_jacobian_determinants(
      double * detJ, std::size_t num_points,
      const double * J,
      int cell_orientation) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
        detJ[ip] = J[2 * 2 * ip] * J[2 * 2 * ip + 2 + 1] - J[2 * 2 * ip + 1] * J[2 * 2 * ip + 2];
  }

  void compute_jacobian_inverses(
      double * K, std::size_t num_points,
      const double * J, const double * detJ) const final override
  {
    for (std::size_t ip = 0; ip < num_points; ++ip)
    {
        K[2 * 2 * ip] = J[2 * 2 * ip + 2 + 1] / detJ[ip];
        K[2 * 2 * ip + 1] = -J[2 * 2 * ip + 1] / detJ[ip];
        K[2 * 2 * ip + 2] = -J[2 * 2 * ip + 2] / detJ[ip];
        K[2 * 2 * ip + 2 + 1] = J[2 * 2 * ip] / detJ[ip];
    }
  }

  void compute_geometry(
      double * x, double * J, double * detJ, double * K, std::size_t num_points,
      const double * X,
      const double * coordinate_dofs, int cell_orientation) const final override
  {
    compute_physical_coordinates(x, num_points, X, coordinate_dofs);
    compute_jacobians(J, num_points, X, coordinate_dofs);
    compute_jacobian_determinants(detJ, num_points, J, cell_orientation);
    compute_jacobian_inverses(K, num_points, J, detJ);
  }

  void compute_midpoint_geometry(
      double * x, double * J,
      const double * coordinate_dofs) const final override
  {
    const double phi_Xm[3] = { 0.33333333333333337, 0.33333333333333337, 0.3333333333333333 };
    const double dphi_Xm[2][3] =
        { { -1.0, 1.0, 0.0 },
          { -1.0, 0.0, 1.0 } };
    // Compute x
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t d = 0; d < 3; ++d)
            x[i] += coordinate_dofs[2 * d + i] * phi_Xm[d];
    // Compute J
    for (std::size_t i = 0; i < 2; ++i)
        for (std::size_t j = 0; j < 2; ++j)
            for (std::size_t d = 0; d < 3; ++d)
                J[2 * i + j] += coordinate_dofs[2 * d + i] * dphi_Xm[j][d];
  }

};


class forms_cell_integral_0_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_0_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_0_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 4
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 4
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           4
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q6[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q6[0][0][1];
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q6[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q6[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q6[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q6[0][0][1];
    alignas(32) double sp[36];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c3 / sp[2];
    sp[4] = -1 * J_c2 / sp[2];
    sp[5] = J_c0 / sp[2];
    sp[6] = sp[5] * sp[3];
    sp[7] = sp[5] * sp[4];
    sp[8] = -1 * J_c1 / sp[2];
    sp[9] = sp[3] * sp[8];
    sp[10] = sp[8] * sp[4];
    sp[11] = -1 * sp[10] + sp[6];
    sp[12] = -1 * sp[7] + sp[7];
    sp[13] = -1 * sp[9] + sp[9];
    sp[14] = -1 * sp[6] + sp[10];
    sp[15] = sp[11] * sp[11];
    sp[16] = sp[11] * sp[12];
    sp[17] = sp[11] * sp[13];
    sp[18] = sp[11] * sp[14];
    sp[19] = sp[12] * sp[12];
    sp[20] = sp[13] * sp[12];
    sp[21] = sp[12] * sp[14];
    sp[22] = sp[13] * sp[13];
    sp[23] = sp[13] * sp[14];
    sp[24] = sp[14] * sp[14];
    sp[25] = std::abs(sp[2]);
    sp[26] = sp[15] * sp[25];
    sp[27] = sp[16] * sp[25];
    sp[28] = sp[17] * sp[25];
    sp[29] = sp[18] * sp[25];
    sp[30] = sp[19] * sp[25];
    sp[31] = sp[20] * sp[25];
    sp[32] = sp[21] * sp[25];
    sp[33] = sp[22] * sp[25];
    sp[34] = sp[23] * sp[25];
    sp[35] = sp[24] * sp[25];
    A[0] = 2.633333333333354 * sp[33] + 0.358333333333346 * sp[34] + -0.6083333333333393 * sp[28] + -0.6083333333333276 * sp[31] + 0.358333333333346 * sp[34] + 0.8583333333333485 * sp[35] + -1.875000000000026 * sp[29] + -0.6083333333333395 * sp[32] + -0.6083333333333393 * sp[28] + -1.875000000000026 * sp[29] + 6.191666666666715 * sp[26] + 1.691666666666662 * sp[27] + -0.6083333333333276 * sp[31] + -0.6083333333333395 * sp[32] + 1.691666666666662 * sp[27] + 0.6333333333333255 * sp[30];
    A[1] = -2.016666666666675 * sp[33] + 1.116666666666657 * sp[34] + -0.6166666666666702 * sp[28] + -0.6166666666666841 * sp[31] + 0.2833333333333288 * sp[34] + -0.8000000000000025 * sp[35] + sp[29] + -0.6166666666666825 * sp[32] + 0.2166666666666676 * sp[28] + 1.666666666666687 * sp[29] + -3.466666666666702 * sp[26] + 2.783333333333361 * sp[27] + 0.2166666666666578 * sp[31] + 0.2166666666666783 * sp[32] + -0.7166666666666694 * sp[27] + 0.8166666666666632 * sp[30];
    A[2] = -0.03333333333332605 * sp[33] + -0.8916666666666543 * sp[34] + -0.1916666666666704 * sp[28] + -0.1916666666666649 * sp[31] + 0.4416666666666708 * sp[34] + 1.275000000000002 * sp[35] + -0.7916666666666765 * sp[29] + -0.1916666666666622 * sp[32] + -0.1916666666666675 * sp[28] + -0.7916666666666732 * sp[29] + 1.275000000000015 * sp[26] + -0.8916666666666793 * sp[27] + -0.1916666666666704 * sp[31] + -0.1916666666666788 * sp[32] + 0.44166666666667 * sp[27] + -0.03333333333333161 * sp[30];
    A[3] = -1.591666666666687 * sp[33] + -0.6500000000000155 * sp[34] + -2.283333333333355 * sp[28] + -0.6500000000000192 * sp[31] + -0.9416666666666801 * sp[34] + -1.295833333333349 * sp[35] + -0.1125000000000015 * sp[29] + -0.4666666666666746 * sp[32] + 0.6916666666666716 * sp[28] + 1.520833333333351 * sp[29] + -1.095833333333335 * sp[26] + -0.2666666666666515 * sp[27] + 0.691666666666668 * sp[31] + 0.6916666666666726 * sp[32] + 0.691666666666665 * sp[27] + 0.5083333333333412 * sp[30];
    A[4] = -0.06666666666665466 * sp[33] + -0.5333333333333161 * sp[34] + -0.09999999999999254 * sp[28] + -0.533333333333324 * sp[31] + 0.8833333333333415 * sp[34] + 1.675000000000007 * sp[35] + 0.1416666666666663 * sp[29] + 0.933333333333324 * sp[32] + -0.3833333333333366 * sp[28] + -0.9583333333333418 * sp[29] + 0.441666666666669 * sp[26] + -0.1333333333333353 * sp[27] + -0.3833333333333405 * sp[31] + -0.3833333333333464 * sp[32] + -0.383333333333336 * sp[27] + -0.6000000000000079 * sp[30];
    A[5] = -1.008333333333338 * sp[33] + 1.183333333333324 * sp[34] + -2.116666666666674 * sp[28] + 1.183333333333328 * sp[31] + 0.1416666666666634 * sp[34] + -0.8375000000000004 * sp[35] + 0.5125000000000007 * sp[29] + -0.4666666666666623 * sp[32] + 0.1083333333333352 * sp[28] + 1.145833333333346 * sp[29] + -0.6375000000000125 * sp[26] + 0.4000000000000145 * sp[27] + 0.1083333333333295 * sp[31] + 0.1083333333333449 * sp[32] + 0.1083333333333221 * sp[27] + 0.09166666666667964 * sp[30];
    A[6] = -1.091666666666672 * sp[33] + -1.10833333333334 * sp[34] + -1.108333333333344 * sp[28] + -1.108333333333339 * sp[31] + -0.7333333333333447 * sp[34] + -0.3624999999999957 * sp[35] + -1.479166666666688 * sp[29] + -1.108333333333343 * sp[32] + 2.133333333333351 * sp[28] + 1.154166666666656 * sp[29] + 3.170833333333355 * sp[26] + 2.191666666666666 * sp[27] + 1.149999999999995 * sp[31] + 1.116666666666655 * sp[32] + 1.149999999999998 * sp[27] + 1.008333333333326 * sp[30];
    A[7] = 2.600000000000016 * sp[33] + 1.216666666666669 * sp[34] + 1.216666666666676 * sp[28] + 1.216666666666665 * sp[31] + 1.466666666666685 * sp[34] + 0.3083333333333393 * sp[35] + 2.375000000000031 * sp[29] + 1.216666666666678 * sp[32] + -4.933333333333367 * sp[28] + -1.058333333333327 * sp[29] + -7.258333333333377 * sp[26] + -3.383333333333327 * sp[27] + -2.13333333333332 * sp[31] + -0.8999999999999906 * sp[32] + -2.133333333333324 * sp[27] + -1.266666666666652 * sp[30];
    A[8] = -1.50833333333334 * sp[33] + 0.3083333333333502 * sp[34] + 0.3083333333333373 * sp[28] + 0.3083333333333499 * sp[31] + -0.7333333333333395 * sp[34] + 0.7625000000000095 * sp[35] + -1.187500000000011 * sp[29] + 0.3083333333333442 * sp[32] + 2.800000000000016 * sp[28] + -2.887500000000019 * sp[29] + 4.295833333333364 * sp[26] + -1.391666666666693 * sp[27] + 0.983333333333325 * sp[31] + -0.7166666666666615 * sp[32] + 0.983333333333331 * sp[27] + -0.4083333333333355 * sp[30];
    A[9] = 1.649915822768657 * sp[33] + 0.4714045207910416 * sp[34] + -5.185449728701387 * sp[28] + -5.185449728701395 * sp[31] + 3.064129385141741 * sp[34] + 1.767766952966353 * sp[35] + -3.889087296526076 * sp[29] + -5.185449728701429 * sp[32] + -1.649915822768631 * sp[28] + 5.06759859850362 * sp[29] + 10.72445284799601 * sp[26] + 17.44196726926825 * sp[27] + -1.64991582276863 * sp[31] + -0.235702260395545 * sp[32] + 4.006938426723742 * sp[27] + 5.892556509887847 * sp[30];
    A[10] = 10.96965511460297 * sp[33] + 0.7216878364870073 * sp[34] + -10.53664241271076 * sp[28] + -10.53664241271076 * sp[31] + 0.1443375672973248 * sp[34] + -1.732050807568887 * sp[35] + -8.660254037844531 * sp[29] + -10.53664241271081 * sp[32] + 0.7216878364870769 * sp[28] + 11.5470053837925 * sp[29] + 18.47520861406814 * sp[26] + 29.30052616137361 * sp[27] + 0.7216878364870553 * sp[31] + 5.051814855409164 * sp[32] + 7.649891066762512 * sp[27] + 10.96965511460281 * sp[30];
    A[11] = -6.833333333333332 * sp[33] + 1.583333333333402 * sp[34] + 0.08333333333330728 * sp[28] + 0.08333333333332948 * sp[31] + 2.416666666666663 * sp[34] + 3.749999999999958 * sp[35] + -1.250000000000014 * sp[29] + 0.08333333333337611 * sp[32] + 0.08333333333334486 * sp[28] + -4.91666666666666 * sp[29] + -5.916666666666667 * sp[26] + -10.91666666666674 * sp[27] + 0.08333333333329188 * sp[31] + 0.5833333333333339 * sp[32] + -0.9166666666666263 * sp[27] + -1.833333333333296 * sp[30];
    A[12] = 5.892556509887886 * sp[33] + -1.649915822768633 * sp[34] + 16.73486048808173 * sp[28] + 4.006938426723819 * sp[31] + -3.299831645537232 * sp[34] + -2.474873734152924 * sp[35] + 3.181980515339538 * sp[29] + 4.006938426723853 * sp[32] + 0.4714045207910382 * sp[28] + -2.003469213361926 * sp[29] + -7.6603234628543 * sp[26] + -10.1351971970073 * sp[27] + 0.4714045207910766 * sp[31] + 0.4714045207910342 * sp[32] + -5.185449728701294 * sp[27] + -4.006938426723779 * sp[30];
    A[13] = -16.88749537379672 * sp[33] + -7.361215932167812 * sp[34] + -7.361215932167779 * sp[28] + 3.897114317029949 * sp[31] + -5.196152422706717 * sp[34] + -6.278684177437309 * sp[35] + 4.979646071760509 * sp[29] + 3.89711431702992 * sp[32] + 5.196152422706671 * sp[28] + 11.90784930203618 * sp[29] + -21.86714144555718 * sp[26] + -15.15544456622757 * sp[27] + 5.196152422706609 * sp[31] + 5.196152422706644 * sp[32] + -1.732050807568871 * sp[27] + -3.897114317029871 * sp[30];
    A[14] = 10.41666666666664 * sp[33] + -2.9166666666667 * sp[34] + 10.08333333333336 * sp[28] + -1.416666666666661 * sp[31] + -5.833333333333348 * sp[34] + -4.375000000000016 * sp[35] + -2.874999999999998 * sp[29] + -1.416666666666779 * sp[32] + 0.8333333333333364 * sp[28] + -3.54166666666673 * sp[29] + 7.958333333333428 * sp[26] + 3.583333333333326 * sp[27] + 0.8333333333334114 * sp[31] + 0.8333333333333401 * sp[32] + 1.833333333333376 * sp[27] + 2.916666666666631 * sp[30];
    A[15] = -2.016666666666675 * sp[33] + 0.2833333333333288 * sp[34] + 0.2166666666666676 * sp[28] + 0.2166666666666578 * sp[31] + 1.116666666666657 * sp[34] + -0.8000000000000025 * sp[35] + 1.666666666666687 * sp[29] + 0.2166666666666783 * sp[32] + -0.6166666666666702 * sp[28] + sp[29] + -3.466666666666702 * sp[26] + -0.7166666666666694 * sp[27] + -0.6166666666666841 * sp[31] + -0.6166666666666825 * sp[32] + 2.783333333333361 * sp[27] + 0.8166666666666632 * sp[30];
    A[16] = 2.533333333333341 * sp[33] + -1.733333333333329 * sp[34] + 0.7333333333333389 * sp[28] + 0.733333333333354 * sp[31] + -1.733333333333329 * sp[34] + 2.766666666666649 * sp[35] + -2.166666666666674 * sp[29] + 0.7333333333333418 * sp[32] + 0.7333333333333389 * sp[28] + -2.166666666666674 * sp[29] + 2.766666666666697 * sp[26] + -1.733333333333346 * sp[27] + 0.733333333333354 * sp[31] + 0.7333333333333418 * sp[32] + -1.733333333333346 * sp[27] + 2.533333333333351 * sp[30];
    A[17] = 0.8166666666666672 * sp[33] + 2.783333333333333 * sp[34] + -0.616666666666671 * sp[28] + -0.616666666666675 * sp[31] + -0.7166666666666686 * sp[34] + -3.466666666666657 * sp[35] + sp[29] + -0.6166666666666722 * sp[32] + 0.2166666666666672 * sp[28] + 1.666666666666671 * sp[29] + -0.8000000000000118 * sp[26] + 1.116666666666674 * sp[27] + 0.2166666666666736 * sp[31] + 0.2166666666666761 * sp[32] + 0.2833333333333364 * sp[27] + -2.01666666666668 * sp[30];
    A[18] = -0.06666666666666413 * sp[33] + -0.9499999999999978 * sp[34] + 0.3166666666666749 * sp[28] + -0.9499999999999909 * sp[31] + 0.4666666666666767 * sp[34] + 1.258333333333344 * sp[35] + -0.1083333333333386 * sp[29] + 0.6833333333333351 * sp[32] + 0.03333333333333288 * sp[28] + -0.7083333333333416 * sp[29] + 0.8583333333333362 * sp[26] + 0.1166666666666586 * sp[27] + 0.03333333333333294 * sp[31] + 0.03333333333333849 * sp[32] + 0.03333333333331634 * sp[27] + -0.1833333333333401 * sp[30];
    A[19] = 1.633333333333335 * sp[33] + 3.066666666666666 * sp[34] + 1.199999999999994 * sp[28] + 3.066666666666666 * sp[31] + -1.433333333333338 * sp[34] + -3.683333333333329 * sp[35] + -0.2833333333333273 * sp[29] + -2.533333333333311 * sp[32] + 0.4333333333333362 * sp[28] + 1.583333333333339 * sp[29] + -0.2166666666666666 * sp[26] + 0.9333333333333436 * sp[27] + 0.4333333333333467 * sp[31] + 0.4333333333333446 * sp[32] + 0.4333333333333551 * sp[27] + 1.200000000000034 * sp[30];
    A[20] = 1.26666666666667 * sp[33] + -2.116666666666664 * sp[34] + 2.483333333333341 * sp[28] + -2.11666666666667 * sp[31] + -0.8666666666666633 * sp[34] + 3.008333333333317 * sp[35] + -2.025000000000002 * sp[29] + 1.849999999999978 * sp[32] + 0.3666666666666685 * sp[28] + -1.958333333333339 * sp[29] + 1.275000000000014 * sp[26] + -1.05000000000001 * sp[27] + 0.366666666666677 * sp[31] + 0.3666666666666675 * sp[32] + 0.3666666666666767 * sp[27] + -1.016666666666671 * sp[30];
    A[21] = 0.1833333333333381 * sp[33] + -0.0333333333333278 * sp[34] + -0.03333333333333408 * sp[28] + -0.03333333333333446 * sp[31] + -0.1166666666666568 * sp[34] + -0.8583333333333416 * sp[35] + 0.7083333333333547 * sp[29] + -0.03333333333332666 * sp[32] + -0.6833333333333483 * sp[28] + 0.1083333333333315 * sp[29] + -1.258333333333349 * sp[26] + -0.4666666666666678 * sp[27] + 0.9500000000000013 * sp[31] + -0.3166666666666962 * sp[32] + 0.9500000000000126 * sp[27] + 0.06666666666665824 * sp[30];
    A[22] = -1.200000000000008 * sp[33] + -0.4333333333333317 * sp[34] + -0.4333333333333345 * sp[28] + -0.4333333333333269 * sp[31] + -0.9333333333333441 * sp[34] + 0.2166666666666566 * sp[35] + -1.583333333333361 * sp[29] + -0.4333333333333487 * sp[32] + 2.533333333333362 * sp[28] + 0.2833333333333348 * sp[29] + 3.683333333333368 * sp[26] + 1.433333333333336 * sp[27] + -3.06666666666668 * sp[31] + -1.199999999999985 * sp[32] + -3.066666666666695 * sp[27] + -1.633333333333325 * sp[30];
    A[23] = 1.016666666666667 * sp[33] + -0.3666666666666911 * sp[34] + -0.3666666666666716 * sp[28] + -0.3666666666666851 * sp[31] + 1.050000000000002 * sp[34] + -1.275000000000003 * sp[35] + 1.958333333333343 * sp[29] + -0.3666666666666696 * sp[32] + -1.850000000000014 * sp[28] + 2.025000000000009 * sp[29] + -3.00833333333336 * sp[26] + 0.8666666666666779 * sp[27] + 2.116666666666677 * sp[31] + -2.483333333333348 * sp[32] + 2.116666666666681 * sp[27] + -1.266666666666683 * sp[30];
    A[24] = 3.771236166328257 * sp[33] + 6.128258770283459 * sp[34] + 3.299831645537244 * sp[28] + 3.299831645537265 * sp[31] + -3.771236166328276 * sp[34] + 1.178511301977606 * sp[35] + -1.649915822768554 * sp[29] + 3.299831645537295 * sp[32] + 0.9428090415820738 * sp[28] + -5.421151989096868 * sp[29] + -2.592724864350696 * sp[26] + -8.956685895029656 * sp[27] + 0.9428090415820902 * sp[31] + 12.25651754056691 * sp[32] + 3.771236166328308 * sp[27] + 11.78511301977583 * sp[30];
    A[25] = -8.948929172439195 * sp[33] + -1.443375672973981 * sp[34] + 3.752776749732595 * sp[28] + 3.752776749732633 * sp[31] + -3.175426480542773 * sp[34] + 2.020725942163697 * sp[35] + -1.443375672973921 * sp[29] + 3.752776749732677 * sp[32] + 1.44337567297401 * sp[28] + -7.216878364870347 * sp[29] + -3.752776749732632 * sp[26] + -12.41303078757703 * sp[27] + 1.443375672973979 * sp[31] + 10.10362971081833 * sp[32] + 4.907477288111922 * sp[27] + 14.14508159514586 * sp[30];
    A[26] = 11.16666666666669 * sp[33] + 1.833333333333279 * sp[34] + -5.166666666666692 * sp[28] + -5.16666666666671 * sp[31] + -8.166666666666659 * sp[34] + -16.66666666666659 * sp[35] + 3.333333333333356 * sp[29] + -5.166666666666734 * sp[32] + 3.16666666666668 * sp[28] + 10.66666666666665 * sp[29] + 2.666666666666669 * sp[26] + 10.16666666666672 * sp[27] + 3.166666666666764 * sp[31] + -7.8333333333334 * sp[32] + -4.833333333333376 * sp[27] + -17.16666666666675 * sp[30];
    A[27] = -11.78511301977582 * sp[33] + -3.771236166328261 * sp[34] + -12.25651754056686 * sp[28] + -0.9428090415820727 * sp[31] + 8.956685895029606 * sp[34] + 2.592724864350706 * sp[35] + 5.421151989096809 * sp[29] + -0.9428090415821058 * sp[32] + -3.299831645537247 * sp[28] + 1.649915822768625 * sp[29] + -1.178511301977587 * sp[26] + 3.771236166328306 * sp[27] + -3.299831645537318 * sp[31] + -3.299831645537284 * sp[32] + -6.128258770283504 * sp[27] + -3.771236166328317 * sp[30];
    A[28] = 7.794228634060035 * sp[33] + 1.732050807568901 * sp[34] + 1.732050807568897 * sp[28] + -3.464101615137752 * sp[31] + -2.598076211353278 * sp[34] + -0.4330127018921193 * sp[35] + -5.62916512459878 * sp[29] + -3.464101615137697 * sp[32] + 2.598076211353342 * sp[28] + -2.165063509461162 * sp[29] + 13.42339375865889 * sp[26] + 8.66025403784437 * sp[27] + 2.598076211353396 * sp[31] + 2.598076211353418 * sp[32] + -0.8660254037845947 * sp[27] + -5.196152422706586 * sp[30];
    A[29] = -20.83333333333338 * sp[33] + -6.666666666666687 * sp[34] + -12.66666666666668 * sp[28] + 0.333333333333355 * sp[31] + 15.83333333333333 * sp[34] + 4.583333333333404 * sp[35] + 11.58333333333331 * sp[29] + 0.3333333333335782 * sp[32] + -5.833333333333369 * sp[28] + 2.916666666666678 * sp[29] + -10.08333333333344 * sp[26] + -1.33333333333336 * sp[27] + -5.833333333333504 * sp[31] + -5.833333333333437 * sp[32] + 2.166666666666594 * sp[27] + 13.33333333333326 * sp[30];
    A[30] = -0.03333333333332605 * sp[33] + 0.4416666666666708 * sp[34] + -0.1916666666666675 * sp[28] + -0.1916666666666704 * sp[31] + -0.8916666666666543 * sp[34] + 1.275000000000002 * sp[35] + -0.7916666666666732 * sp[29] + -0.1916666666666788 * sp[32] + -0.1916666666666704 * sp[28] + -0.7916666666666765 * sp[29] + 1.275000000000015 * sp[26] + 0.44166666666667 * sp[27] + -0.1916666666666649 * sp[31] + -0.1916666666666622 * sp[32] + -0.8916666666666793 * sp[27] + -0.03333333333333161 * sp[30];
    A[31] = 0.8166666666666672 * sp[33] + -0.7166666666666686 * sp[34] + 0.2166666666666672 * sp[28] + 0.2166666666666736 * sp[31] + 2.783333333333333 * sp[34] + -3.466666666666657 * sp[35] + 1.666666666666671 * sp[29] + 0.2166666666666761 * sp[32] + -0.616666666666671 * sp[28] + sp[29] + -0.8000000000000118 * sp[26] + 0.2833333333333364 * sp[27] + -0.616666666666675 * sp[31] + -0.6166666666666722 * sp[32] + 1.116666666666674 * sp[27] + -2.01666666666668 * sp[30];
    A[32] = 0.633333333333339 * sp[33] + 1.691666666666676 * sp[34] + -0.6083333333333395 * sp[28] + -0.6083333333333403 * sp[31] + 1.691666666666676 * sp[34] + 6.191666666666673 * sp[35] + -1.875000000000013 * sp[29] + -0.6083333333333379 * sp[32] + -0.6083333333333395 * sp[28] + -1.875000000000013 * sp[29] + 0.8583333333333425 * sp[26] + 0.3583333333333346 * sp[27] + -0.6083333333333403 * sp[31] + -0.6083333333333379 * sp[32] + 0.3583333333333346 * sp[27] + 2.633333333333351 * sp[30];
    A[33] = -1.008333333333346 * sp[33] + -1.150000000000009 * sp[34] + -1.116666666666678 * sp[28] + -1.150000000000007 * sp[31] + -2.191666666666687 * sp[34] + -3.170833333333346 * sp[35] + -1.154166666666678 * sp[29] + -2.133333333333339 * sp[32] + 1.108333333333344 * sp[28] + 1.479166666666678 * sp[29] + 0.3625000000000098 * sp[26] + 0.7333333333333439 * sp[27] + 1.108333333333342 * sp[31] + 1.108333333333335 * sp[32] + 1.108333333333351 * sp[27] + 1.091666666666674 * sp[30];
    A[34] = 1.266666666666677 * sp[33] + 2.133333333333345 * sp[34] + 0.9000000000000021 * sp[28] + 2.133333333333342 * sp[31] + 3.38333333333335 * sp[34] + 7.258333333333344 * sp[35] + 1.058333333333331 * sp[29] + 4.933333333333332 * sp[32] + -1.216666666666679 * sp[28] + -2.375000000000016 * sp[29] + -0.3083333333333383 * sp[26] + -1.466666666666681 * sp[27] + -1.216666666666679 * sp[31] + -1.216666666666674 * sp[32] + -1.21666666666668 * sp[27] + -2.600000000000025 * sp[30];
    A[35] = 0.4083333333333327 * sp[33] + -0.9833333333333376 * sp[34] + 0.7166666666666676 * sp[28] + -0.9833333333333399 * sp[31] + 1.391666666666664 * sp[34] + -4.29583333333333 * sp[35] + 2.887500000000002 * sp[29] + -2.8 * sp[32] + -0.3083333333333343 * sp[28] + 1.187500000000011 * sp[29] + -0.7625000000000073 * sp[26] + 0.7333333333333475 * sp[27] + -0.3083333333333366 * sp[31] + -0.3083333333333355 * sp[32] + -0.3083333333333367 * sp[27] + 1.508333333333342 * sp[30];
    A[36] = -0.508333333333334 * sp[33] + -0.6916666666666685 * sp[34] + -0.6916666666666739 * sp[28] + -0.6916666666666723 * sp[31] + 0.2666666666666662 * sp[34] + 1.095833333333337 * sp[35] + -1.52083333333335 * sp[29] + -0.6916666666666733 * sp[32] + 0.466666666666673 * sp[28] + 0.1125000000000037 * sp[29] + 1.295833333333345 * sp[26] + 0.941666666666672 * sp[27] + 0.6499999999999999 * sp[31] + 2.283333333333359 * sp[32] + 0.6499999999999976 * sp[27] + 1.59166666666668 * sp[30];
    A[37] = 0.6000000000000048 * sp[33] + 0.3833333333333376 * sp[34] + 0.3833333333333361 * sp[28] + 0.3833333333333373 * sp[31] + 0.1333333333333411 * sp[34] + -0.4416666666666557 * sp[35] + 0.9583333333333452 * sp[29] + 0.3833333333333459 * sp[32] + -0.933333333333349 * sp[28] + -0.1416666666666712 * sp[29] + -1.675000000000015 * sp[26] + -0.883333333333338 * sp[27] + 0.5333333333333364 * sp[31] + 0.09999999999999021 * sp[32] + 0.5333333333333465 * sp[27] + 0.0666666666666601 * sp[30];
    A[38] = -0.09166666666667071 * sp[33] + -0.1083333333333439 * sp[34] + -0.108333333333333 * sp[28] + -0.1083333333333387 * sp[31] + -0.4000000000000085 * sp[34] + 0.637499999999981 * sp[35] + -1.145833333333337 * sp[29] + -0.1083333333333435 * sp[32] + 0.4666666666666758 * sp[28] + -0.512499999999998 * sp[29] + 0.8375000000000103 * sp[26] + -0.1416666666666692 * sp[27] + -1.183333333333336 * sp[31] + 2.116666666666683 * sp[32] + -1.183333333333342 * sp[27] + 1.008333333333344 * sp[30];
    A[39] = 4.006938426723806 * sp[33] + 5.185449728701403 * sp[34] + -0.4714045207910371 * sp[28] + -0.4714045207910227 * sp[31] + 10.13519719700724 * sp[34] + 7.660323462854326 * sp[35] + 2.003469213361868 * sp[29] + -0.4714045207910432 * sp[32] + -4.006938426723809 * sp[28] + -3.181980515339501 * sp[29] + 2.47487373415293 * sp[26] + 3.299831645537247 * sp[27] + -4.006938426723805 * sp[31] + -16.73486048808174 * sp[32] + 1.649915822768589 * sp[27] + -5.892556509887926 * sp[30];
    A[40] = -0.5773502691895662 * sp[33] + -0.721687836486979 * sp[34] + -3.319764047840383 * sp[28] + -3.319764047840353 * sp[31] + 4.474464586219634 * sp[34] + 4.041451884327465 * sp[35] + -2.886751345948211 * sp[29] + -3.319764047840371 * sp[32] + -0.7216878364870607 * sp[28] + 6.928203230275559 * sp[26] + 7.64989106676259 * sp[27] + -0.7216878364870607 * sp[31] + -5.051814855409188 * sp[32] + 6.206515393788447 * sp[27] + -0.5773502691896217 * sp[30];
    A[41] = 4.833333333333357 * sp[33] + 2.416666666666665 * sp[34] + -4.083333333333377 * sp[28] + -4.08333333333338 * sp[31] + 14.9166666666667 * sp[34] + 22.91666666666662 * sp[35] + -12.08333333333341 * sp[29] + -4.083333333333346 * sp[32] + -4.083333333333369 * sp[28] + -5.750000000000002 * sp[29] + 3.250000000000032 * sp[26] + 1.58333333333334 * sp[27] + -4.08333333333339 * sp[31] + 11.41666666666675 * sp[32] + 4.916666666666709 * sp[27] + 19.83333333333346 * sp[30];
    A[42] = -5.892556509887928 * sp[33] + -4.006938426723797 * sp[34] + 0.2357022603955552 * sp[28] + 1.649915822768635 * sp[31] + -17.44196726926823 * sp[34] + -10.72445284799602 * sp[35] + -5.067598598503524 * sp[29] + 1.649915822768642 * sp[32] + 5.185449728701395 * sp[28] + 3.889087296526022 * sp[29] + -1.767766952966394 * sp[26] + -3.064129385141754 * sp[27] + 5.185449728701408 * sp[31] + 5.185449728701393 * sp[32] + -0.4714045207910194 * sp[27] + -1.649915822768602 * sp[30];
    A[43] = -3.897114317030026 * sp[33] + -3.031088913245571 * sp[34] + -3.031088913245572 * sp[28] + -0.433012701892236 * sp[31] + -5.19615242270668 * sp[34] + -4.113620667976146 * sp[35] + -1.515544456622859 * sp[29] + -0.4330127018922487 * sp[32] + 5.196152422706664 * sp[28] + 5.412658773652798 * sp[29] + -2.38156986040721 * sp[26] + -2.16506350946108 * sp[27] + 5.196152422706634 * sp[31] + 5.196152422706609 * sp[32] + -1.732050807568794 * sp[27] + 0.433012701892189 * sp[30];
    A[44] = -10.41666666666672 * sp[33] + -7.083333333333385 * sp[34] + -4.083333333333325 * sp[28] + -0.5833333333333133 * sp[31] + -30.8333333333334 * sp[34] + -18.95833333333344 * sp[35] + -12.45833333333331 * sp[29] + -0.5833333333334167 * sp[32] + 9.166666666666741 * sp[28] + 6.875000000000022 * sp[29] + 3.375000000000048 * sp[26] + 1.083333333333318 * sp[27] + 9.166666666666771 * sp[31] + 9.166666666666739 * sp[32] + 0.1666666666666927 * sp[27] + -12.91666666666671 * sp[30];
    A[45] = -1.591666666666687 * sp[33] + -0.9416666666666801 * sp[34] + 0.6916666666666716 * sp[28] + 0.691666666666668 * sp[31] + -0.6500000000000155 * sp[34] + -1.295833333333349 * sp[35] + 1.520833333333351 * sp[29] + 0.6916666666666726 * sp[32] + -2.283333333333355 * sp[28] + -0.1125000000000015 * sp[29] + -1.095833333333335 * sp[26] + 0.691666666666665 * sp[27] + -0.6500000000000192 * sp[31] + -0.4666666666666746 * sp[32] + -0.2666666666666515 * sp[27] + 0.5083333333333412 * sp[30];
    A[46] = -0.06666666666666413 * sp[33] + 0.4666666666666767 * sp[34] + 0.03333333333333288 * sp[28] + 0.03333333333333294 * sp[31] + -0.9499999999999978 * sp[34] + 1.258333333333344 * sp[35] + -0.7083333333333416 * sp[29] + 0.03333333333333849 * sp[32] + 0.3166666666666749 * sp[28] + -0.1083333333333386 * sp[29] + 0.8583333333333362 * sp[26] + 0.03333333333331634 * sp[27] + -0.9499999999999909 * sp[31] + 0.6833333333333351 * sp[32] + 0.1166666666666586 * sp[27] + -0.1833333333333401 * sp[30];
    A[47] = -1.008333333333346 * sp[33] + -2.191666666666687 * sp[34] + 1.108333333333344 * sp[28] + 1.108333333333342 * sp[31] + -1.150000000000009 * sp[34] + -3.170833333333346 * sp[35] + 1.479166666666678 * sp[29] + 1.108333333333335 * sp[32] + -1.116666666666678 * sp[28] + -1.154166666666678 * sp[29] + 0.3625000000000098 * sp[26] + 1.108333333333351 * sp[27] + -1.150000000000007 * sp[31] + -2.133333333333339 * sp[32] + 0.7333333333333439 * sp[27] + 1.091666666666674 * sp[30];
    A[48] = 2.633333333333361 * sp[33] + 2.275000000000021 * sp[34] + 3.24166666666669 * sp[28] + 2.275000000000019 * sp[31] + 2.275000000000021 * sp[34] + 2.775000000000018 * sp[35] + 1.008333333333347 * sp[29] + 1.508333333333345 * sp[32] + 3.24166666666669 * sp[28] + 1.008333333333347 * sp[29] + 10.04166666666667 * sp[26] + 5.508333333333338 * sp[27] + 2.275000000000019 * sp[31] + 1.508333333333345 * sp[32] + 5.508333333333338 * sp[27] + 3.683333333333337 * sp[30];
    A[49] = -2.016666666666689 * sp[33] + -3.13333333333336 * sp[34] + -1.400000000000006 * sp[28] + -3.133333333333349 * sp[31] + -2.300000000000017 * sp[34] + -4.216666666666683 * sp[35] + -0.683333333333336 * sp[29] + -2.600000000000005 * sp[32] + -2.233333333333348 * sp[28] + -1.683333333333351 * sp[29] + -5.08333333333332 * sp[26] + -7.933333333333326 * sp[27] + -2.30000000000001 * sp[31] + -2.766666666666676 * sp[32] + -3.433333333333324 * sp[27] + -5.86666666666666 * sp[30];
    A[50] = -0.03333333333333011 * sp[33] + 0.8583333333333459 * sp[34] + 0.1583333333333334 * sp[28] + 0.8583333333333478 * sp[31] + -0.4749999999999969 * sp[34] + 1.691666666666677 * sp[35] + -1.075000000000002 * sp[29] + 1.091666666666679 * sp[32] + 0.1583333333333395 * sp[28] + 0.258333333333332 * sp[29] + 1.625 * sp[26] + 2.424999999999996 * sp[27] + -0.4749999999999938 * sp[31] + 1.091666666666668 * sp[32] + -0.2416666666666643 * sp[27] + 2.183333333333334 * sp[30];
    A[51] = 1.508333333333335 * sp[33] + 1.81666666666667 * sp[34] + 1.816666666666682 * sp[28] + 1.816666666666677 * sp[31] + 0.7750000000000055 * sp[34] + 0.3208333333333322 * sp[35] + 2.270833333333352 * sp[29] + 1.816666666666676 * sp[32] + 4.308333333333317 * sp[28] + 7.504166666666658 * sp[29] + 0.3208333333333451 * sp[26] + 1.816666666666674 * sp[27] + 2.591666666666664 * sp[31] + 4.308333333333328 * sp[32] + 0.7750000000000165 * sp[27] + 1.508333333333343 * sp[30];
    A[52] = -2.600000000000012 * sp[33] + -1.383333333333338 * sp[34] + -1.383333333333342 * sp[28] + -1.383333333333336 * sp[31] + -1.13333333333335 * sp[34] + -0.2250000000000068 * sp[35] + -2.291666666666688 * sp[29] + -1.383333333333342 * sp[32] + -7.533333333333319 * sp[28] + -5.258333333333325 * sp[29] + 0.9416666666666643 * sp[26] + -1.383333333333328 * sp[27] + -3.933333333333346 * sp[31] + -2.86666666666667 * sp[32] + 0.03333333333331284 * sp[27] + -1.016666666666676 * sp[30];
    A[53] = 1.091666666666674 * sp[33] + -0.01666666666666056 * sp[34] + -0.01666666666666838 * sp[28] + -0.01666666666666827 * sp[31] + 0.3583333333333442 * sp[34] + -0.3874999999999951 * sp[35] + 0.7291666666666742 * sp[29] + -0.01666666666666979 * sp[32] + 3.224999999999996 * sp[28] + 0.9625000000000121 * sp[29] + -1.054166666666671 * sp[26] + -0.01666666666665777 * sp[27] + 1.341666666666679 * sp[31] + 0.5583333333333427 * sp[32] + -0.3083333333333244 * sp[27] + 0.09166666666667304 * sp[30];
    A[54] = -7.542472332656585 * sp[33] + -8.720983634634168 * sp[34] + 4.006938426723794 * sp[28] + 4.006938426723776 * sp[31] + -7.778174593052084 * sp[34] + -8.249579113843097 * sp[35] + 4.47834294751484 * sp[29] + 4.006938426723811 * sp[32] + -8.720983634634139 * sp[28] + -12.96362432175346 * sp[29] + -0.2357022603955023 * sp[26] + 4.006938426723706 * sp[27] + -7.778174593052064 * sp[31] + -11.07800623858929 * sp[32] + 0.2357022603955499 * sp[27] + 2.357022603955166 * sp[30];
    A[55] = -5.917840259193789 * sp[33] + 0.7216878364869613 * sp[34] + 11.98001808568483 * sp[28] + 11.98001808568478 * sp[31] + -0.8660254037844908 * sp[34] + -2.237232293109852 * sp[35] + 13.3512249750102 * sp[29] + 11.98001808568482 * sp[32] + -11.83568051838752 * sp[28] + 18.25870226312176 * sp[29] + 2.670244995002086 * sp[26] + 11.98001808568468 * sp[27] + -0.8660254037845858 * sp[31] + 10.96965511460278 * sp[32] + 4.041451884327469 * sp[27] + 8.804591605141827 * sp[30];
    A[56] = -3.583333333333375 * sp[33] + -4.916666666666701 * sp[34] + 6.583333333333412 * sp[28] + 6.583333333333401 * sp[31] + -7.000000000000025 * sp[34] + -7.708333333333315 * sp[35] + 7.291666666666716 * sp[29] + 6.583333333333342 * sp[32] + -2.666666666666703 * sp[28] + 4.458333333333265 * sp[29] + 5.458333333333416 * sp[26] + 6.583333333333479 * sp[27] + -7.000000000000008 * sp[31] + 2.166666666666635 * sp[32] + 6.166666666666709 * sp[27] + 6.916666666666714 * sp[30];
    A[57] = 5.892556509887954 * sp[33] + 7.542472332656553 * sp[34] + -10.84230397819383 * sp[28] + -5.185449728701411 * sp[31] + 9.192388155425158 * sp[34] + 8.367430244040827 * sp[35] + -4.360491817317128 * sp[29] + -5.185449728701432 * sp[32] + 5.421151989096889 * sp[28] + 5.067598598503654 * sp[29] + -18.97403196183909 * sp[26] + -5.185449728701349 * sp[27] + 9.192388155425126 * sp[31] + 5.892556509887916 * sp[32] + -6.835365551470056 * sp[27] + -4.006938426723817 * sp[30];
    A[58] = 16.8874953737967 * sp[33] + 9.526279441628919 * sp[34] + 9.526279441628887 * sp[28] + -1.732050807568832 * sp[31] + 11.69134295109002 * sp[34] + 10.60881119635948 * sp[35] + -0.6495190528382979 * sp[29] + -1.732050807568833 * sp[32] + 22.08364779650332 * sp[28] + 2.814582562299464 * sp[29] + 36.58957330989249 * sp[26] + -1.732050807568837 * sp[27] + 11.69134295109003 * sp[31] + 3.897114317030041 * sp[32] + 19.48557158514984 * sp[27] + 0.4330127018922245 * sp[30];
    A[59] = 10.41666666666676 * sp[33] + 13.33333333333342 * sp[34] + 0.3333333333333157 * sp[28] + 1.833333333333294 * sp[31] + 16.25000000000007 * sp[34] + 14.7916666666667 * sp[35] + 3.291666666666667 * sp[29] + 1.833333333333335 * sp[32] + 9.583333333333377 * sp[28] + 8.958333333333456 * sp[29] + 7.45833333333325 * sp[26] + 1.833333333333268 * sp[27] + 16.25000000000001 * sp[31] + 10.41666666666671 * sp[32] + 9.416666666666622 * sp[27] + 2.916666666666636 * sp[30];
    A[60] = -0.06666666666665466 * sp[33] + 0.8833333333333415 * sp[34] + -0.3833333333333366 * sp[28] + -0.3833333333333405 * sp[31] + -0.5333333333333161 * sp[34] + 1.675000000000007 * sp[35] + -0.9583333333333418 * sp[29] + -0.3833333333333464 * sp[32] + -0.09999999999999254 * sp[28] + 0.1416666666666663 * sp[29] + 0.441666666666669 * sp[26] + -0.383333333333336 * sp[27] + -0.533333333333324 * sp[31] + 0.933333333333324 * sp[32] + -0.1333333333333353 * sp[27] + -0.6000000000000079 * sp[30];
    A[61] = 1.633333333333335 * sp[33] + -1.433333333333338 * sp[34] + 0.4333333333333362 * sp[28] + 0.4333333333333467 * sp[31] + 3.066666666666666 * sp[34] + -3.683333333333329 * sp[35] + 1.583333333333339 * sp[29] + 0.4333333333333446 * sp[32] + 1.199999999999994 * sp[28] + -0.2833333333333273 * sp[29] + -0.2166666666666666 * sp[26] + 0.4333333333333551 * sp[27] + 3.066666666666666 * sp[31] + -2.533333333333311 * sp[32] + 0.9333333333333436 * sp[27] + 1.200000000000034 * sp[30];
    A[62] = 1.266666666666677 * sp[33] + 3.38333333333335 * sp[34] + -1.216666666666679 * sp[28] + -1.216666666666679 * sp[31] + 2.133333333333345 * sp[34] + 7.258333333333344 * sp[35] + -2.375000000000016 * sp[29] + -1.216666666666674 * sp[32] + 0.9000000000000021 * sp[28] + 1.058333333333331 * sp[29] + -0.3083333333333383 * sp[26] + -1.21666666666668 * sp[27] + 2.133333333333342 * sp[31] + 4.933333333333332 * sp[32] + -1.466666666666681 * sp[27] + -2.600000000000025 * sp[30];
    A[63] = -2.016666666666689 * sp[33] + -2.300000000000017 * sp[34] + -2.233333333333348 * sp[28] + -2.30000000000001 * sp[31] + -3.13333333333336 * sp[34] + -4.216666666666683 * sp[35] + -1.683333333333351 * sp[29] + -2.766666666666676 * sp[32] + -1.400000000000006 * sp[28] + -0.683333333333336 * sp[29] + -5.08333333333332 * sp[26] + -3.433333333333324 * sp[27] + -3.133333333333349 * sp[31] + -2.600000000000005 * sp[32] + -7.933333333333326 * sp[27] + -5.86666666666666 * sp[30];
    A[64] = 2.533333333333353 * sp[33] + 4.26666666666669 * sp[34] + 1.800000000000002 * sp[28] + 4.266666666666679 * sp[31] + 4.26666666666669 * sp[34] + 8.766666666666685 * sp[35] + 1.366666666666666 * sp[29] + 5.866666666666672 * sp[32] + 1.800000000000002 * sp[28] + 1.366666666666666 * sp[29] + 3.833333333333317 * sp[26] + 5.866666666666648 * sp[27] + 4.266666666666679 * sp[31] + 5.866666666666672 * sp[32] + 5.866666666666648 * sp[27] + 11.73333333333333 * sp[30];
    A[65] = 0.816666666666666 * sp[33] + -1.966666666666675 * sp[34] + 1.433333333333337 * sp[28] + -1.966666666666678 * sp[31] + 1.53333333333333 * sp[34] + -4.716666666666669 * sp[35] + 3.150000000000002 * sp[29] + -3.100000000000009 * sp[32] + 0.5999999999999963 * sp[28] + -0.5166666666666608 * sp[29] + 0.4166666666666667 * sp[26] + -2.433333333333327 * sp[27] + 1.533333333333329 * sp[31] + -3.266666666666651 * sp[32] + 2.066666666666675 * sp[27] + -5.866666666666659 * sp[30];
    A[66] = -1.016666666666666 * sp[33] + -1.383333333333333 * sp[34] + -1.383333333333348 * sp[28] + -1.383333333333343 * sp[31] + 0.03333333333333327 * sp[34] + 0.9416666666666681 * sp[35] + -2.291666666666687 * sp[29] + -1.383333333333343 * sp[32] + -2.866666666666652 * sp[28] + -5.258333333333316 * sp[29] + -0.2250000000000039 * sp[26] + -1.383333333333335 * sp[27] + -3.933333333333316 * sp[31] + -7.533333333333329 * sp[32] + -1.133333333333344 * sp[27] + -2.60000000000001 * sp[30];
    A[67] = 1.200000000000005 * sp[33] + 0.7666666666666722 * sp[34] + 0.7666666666666736 * sp[28] + 0.7666666666666739 * sp[31] + 0.2666666666666783 * sp[34] + -0.3833333333333211 * sp[35] + 1.416666666666681 * sp[29] + 0.7666666666666804 * sp[32] + 3.733333333333315 * sp[28] + 3.016666666666658 * sp[29] + -0.3833333333333345 * sp[26] + 0.7666666666666649 * sp[27] + 5.866666666666652 * sp[31] + 3.733333333333331 * sp[32] + 0.2666666666666701 * sp[27] + 1.200000000000004 * sp[30];
    A[68] = -0.1833333333333394 * sp[33] + -0.2166666666666866 * sp[34] + -0.2166666666666675 * sp[28] + -0.2166666666666771 * sp[31] + -0.3000000000000125 * sp[34] + 0.5249999999999755 * sp[35] + -1.041666666666671 * sp[29] + -0.2166666666666781 * sp[32] + -0.8666666666666619 * sp[28] + -1.008333333333355 * sp[29] + 0.3583333333333346 * sp[26] + -0.2166666666666824 * sp[27] + -1.933333333333336 * sp[31] + -1.533333333333369 * sp[32] + -0.4666666666666731 * sp[27] + -0.6000000000000258 * sp[30];
    A[69] = 8.013876853447606 * sp[33] + 10.37089945740279 * sp[34] + -0.9428090415820742 * sp[28] + -0.9428090415820451 * sp[31] + 13.19932658214896 * sp[34] + 11.78511301977588 * sp[35] + 0.4714045207910111 * sp[29] + -0.9428090415820722 * sp[32] + 5.656854249492391 * sp[28] + 11.78511301977585 * sp[29] + 0.4714045207910353 * sp[26] + -0.9428090415819943 * sp[27] + 13.19932658214893 * sp[31] + 24.51303508113378 * sp[32] + 1.885618083164146 * sp[27];
    A[70] = -1.15470053837915 * sp[33] + -1.443375672973955 * sp[34] + -6.639528095680762 * sp[28] + -6.639528095680701 * sp[31] + 4.6188021535171 * sp[34] + 5.917840259193778 * sp[35] + -7.938566201357448 * sp[29] + -6.639528095680724 * sp[32] + -5.196152422706527 * sp[28] + -14.8667694316327 * sp[29] + -1.010362971081858 * sp[26] + -6.639528095680608 * sp[27] + 4.618802153517177 * sp[31] + -16.16580753730933 * sp[32] + -2.309401076758518 * sp[27] + -10.39230484541317 * sp[30];
    A[71] = 9.666666666666718 * sp[33] + 4.833333333333328 * sp[34] + -8.16666666666675 * sp[28] + -8.166666666666753 * sp[31] + 17.33333333333337 * sp[34] + 24.58333333333329 * sp[35] + -15.41666666666676 * sp[29] + -8.166666666666703 * sp[32] + 7.000000000000003 * sp[28] + -11.41666666666668 * sp[29] + -3.416666666666707 * sp[26] + -8.166666666666769 * sp[27] + 17.33333333333338 * sp[31] + -2.666666666666717 * sp[32] + -10.66666666666676 * sp[27] + -18.00000000000018 * sp[30];
    A[72] = -11.78511301977585 * sp[33] + -8.013876853447586 * sp[34] + 0.4714045207910922 * sp[28] + 3.299831645537267 * sp[31] + -20.74179891480546 * sp[34] + -14.37783788412652 * sp[35] + -3.064129385141616 * sp[29] + 3.299831645537274 * sp[32] + -8.485281374238562 * sp[28] + -3.064129385141721 * sp[29] + 2.592724864350688 * sp[26] + 3.299831645537223 * sp[27] + -20.74179891480543 * sp[31] + -9.428090415820702 * sp[32] + 1.885618083164139 * sp[27] + 5.656854249492359 * sp[30];
    A[73] = -7.794228634060028 * sp[33] + -6.062177826491139 * sp[34] + -6.062177826491117 * sp[28] + -0.8660254037844728 * sp[31] + -10.39230484541334 * sp[34] + -8.22724133595225 * sp[35] + -3.031088913245624 * sp[29] + -0.8660254037844695 * sp[32] + -5.19615242270665 * sp[28] + -1.299038105676669 * sp[29] + -16.8874953737965 * sp[26] + -0.8660254037844812 * sp[27] + -10.39230484541326 * sp[31] + -3.464101615137748 * sp[32] + -17.32050807568873 * sp[27] + 3.464101615137751 * sp[30];
    A[74] = -20.83333333333344 * sp[33] + -14.16666666666676 * sp[34] + -8.166666666666652 * sp[28] + -1.16666666666663 * sp[31] + -36.66666666666676 * sp[34] + -25.41666666666676 * sp[35] + -12.41666666666664 * sp[29] + -1.1666666666667 * sp[32] + -14.99999999999998 * sp[28] + -5.416666666666702 * sp[29] + -12.4166666666666 * sp[26] + -1.166666666666599 * sp[27] + -36.66666666666671 * sp[31] + -16.66666666666681 * sp[32] + -24.66666666666662 * sp[27] + 10.00000000000006 * sp[30];
    A[75] = -1.008333333333338 * sp[33] + 0.1416666666666634 * sp[34] + 0.1083333333333352 * sp[28] + 0.1083333333333295 * sp[31] + 1.183333333333324 * sp[34] + -0.8375000000000004 * sp[35] + 1.145833333333346 * sp[29] + 0.1083333333333449 * sp[32] + -2.116666666666674 * sp[28] + 0.5125000000000007 * sp[29] + -0.6375000000000125 * sp[26] + 0.1083333333333221 * sp[27] + 1.183333333333328 * sp[31] + -0.4666666666666623 * sp[32] + 0.4000000000000145 * sp[27] + 0.09166666666667964 * sp[30];
    A[76] = 1.26666666666667 * sp[33] + -0.8666666666666633 * sp[34] + 0.3666666666666685 * sp[28] + 0.366666666666677 * sp[31] + -2.116666666666664 * sp[34] + 3.008333333333317 * sp[35] + -1.958333333333339 * sp[29] + 0.3666666666666675 * sp[32] + 2.483333333333341 * sp[28] + -2.025000000000002 * sp[29] + 1.275000000000014 * sp[26] + 0.3666666666666767 * sp[27] + -2.11666666666667 * sp[31] + 1.849999999999978 * sp[32] + -1.05000000000001 * sp[27] + -1.016666666666671 * sp[30];
    A[77] = 0.4083333333333327 * sp[33] + 1.391666666666664 * sp[34] + -0.3083333333333343 * sp[28] + -0.3083333333333366 * sp[31] + -0.9833333333333376 * sp[34] + -4.29583333333333 * sp[35] + 1.187500000000011 * sp[29] + -0.3083333333333355 * sp[32] + 0.7166666666666676 * sp[28] + 2.887500000000002 * sp[29] + -0.7625000000000073 * sp[26] + -0.3083333333333367 * sp[27] + -0.9833333333333399 * sp[31] + -2.8 * sp[32] + 0.7333333333333475 * sp[27] + 1.508333333333342 * sp[30];
    A[78] = -0.03333333333333011 * sp[33] + -0.4749999999999969 * sp[34] + 0.1583333333333395 * sp[28] + -0.4749999999999938 * sp[31] + 0.8583333333333459 * sp[34] + 1.691666666666677 * sp[35] + 0.258333333333332 * sp[29] + 1.091666666666668 * sp[32] + 0.1583333333333334 * sp[28] + -1.075000000000002 * sp[29] + 1.625 * sp[26] + -0.2416666666666643 * sp[27] + 0.8583333333333478 * sp[31] + 1.091666666666679 * sp[32] + 2.424999999999996 * sp[27] + 2.183333333333334 * sp[30];
    A[79] = 0.816666666666666 * sp[33] + 1.53333333333333 * sp[34] + 0.5999999999999963 * sp[28] + 1.533333333333329 * sp[31] + -1.966666666666675 * sp[34] + -4.716666666666669 * sp[35] + -0.5166666666666608 * sp[29] + -3.266666666666651 * sp[32] + 1.433333333333337 * sp[28] + 3.150000000000002 * sp[29] + 0.4166666666666667 * sp[26] + 2.066666666666675 * sp[27] + -1.966666666666678 * sp[31] + -3.100000000000009 * sp[32] + -2.433333333333327 * sp[27] + -5.866666666666659 * sp[30];
    A[80] = 0.6333333333333345 * sp[33] + -1.058333333333331 * sp[34] + 1.24166666666667 * sp[28] + -1.058333333333333 * sp[31] + -1.058333333333331 * sp[34] + 3.441666666666654 * sp[35] + -2.325000000000002 * sp[29] + 2.174999999999983 * sp[32] + 1.24166666666667 * sp[28] + -2.325000000000002 * sp[29] + 2.708333333333342 * sp[26] + -1.825000000000008 * sp[27] + -1.058333333333333 * sp[31] + 2.174999999999983 * sp[32] + -1.825000000000008 * sp[27] + 3.683333333333311 * sp[30];
    A[81] = 0.09166666666667005 * sp[33] + -0.01666666666666264 * sp[34] + -0.01666666666666548 * sp[28] + -0.01666666666666575 * sp[31] + -0.3083333333333288 * sp[34] + -1.054166666666676 * sp[35] + 0.7291666666666847 * sp[29] + -0.01666666666666139 * sp[32] + 0.5583333333333274 * sp[28] + 0.9624999999999975 * sp[29] + -0.3875000000000067 * sp[26] + -0.01666666666667099 * sp[27] + 1.341666666666669 * sp[31] + 3.225000000000002 * sp[32] + 0.3583333333333534 * sp[27] + 1.091666666666683 * sp[30];
    A[82] = -0.6000000000000063 * sp[33] + -0.2166666666666665 * sp[34] + -0.2166666666666691 * sp[28] + -0.2166666666666646 * sp[31] + -0.4666666666666729 * sp[34] + 0.3583333333333246 * sp[35] + -1.041666666666686 * sp[29] + -0.2166666666666805 * sp[32] + -1.533333333333321 * sp[28] + -1.008333333333325 * sp[29] + 0.5250000000000129 * sp[26] + -0.2166666666666545 * sp[27] + -1.933333333333336 * sp[31] + -0.8666666666666765 * sp[32] + -0.300000000000021 * sp[27] + -0.1833333333333542 * sp[30];
    A[83] = 0.5083333333333346 * sp[33] + -0.1833333333333458 * sp[34] + -0.1833333333333348 * sp[28] + -0.1833333333333426 * sp[31] + 0.7750000000000032 * sp[34] + -1.012499999999995 * sp[35] + 1.604166666666673 * sp[29] + -0.1833333333333306 * sp[32] + 0.9749999999999903 * sp[28] + 0.1708333333333174 * sp[29] + -1.012500000000014 * sp[26] + -0.1833333333333447 * sp[27] + 0.5916666666666682 * sp[31] + 0.9750000000000042 * sp[32] + 0.7750000000000099 * sp[27] + 0.5083333333333415 * sp[30];
    A[84] = 1.885618083164123 * sp[33] + 3.064129385141722 * sp[34] + 1.649915822768624 * sp[28] + 1.649915822768636 * sp[31] + -5.421151989096895 * sp[34] + -1.178511301977579 * sp[35] + -2.592724864350637 * sp[29] + 1.649915822768656 * sp[32] + 3.064129385141717 * sp[28] + 3.53553390593277 * sp[29] + 2.121320343559647 * sp[26] + 1.649915822768606 * sp[27] + -5.421151989096908 * sp[31] + -13.43502884254445 * sp[32] + -2.121320343559611 * sp[27] + -2.357022603955118 * sp[30];
    A[85] = -4.474464586219606 * sp[33] + -0.7216878364869904 * sp[34] + 1.876388374866306 * sp[28] + 1.876388374866327 * sp[31] + -3.752776749732472 * sp[34] + -0.07216878364873436 * sp[35] + -1.804219591217469 * sp[29] + 1.876388374866351 * sp[32] + -8.948929172439207 * sp[28] + 0.2165063509461388 * sp[29] + 1.948557158514981 * sp[26] + 1.876388374866276 * sp[27] + -3.752776749732475 * sp[31] + 5.196152422706637 * sp[32] + -1.732050807568771 * sp[27] + 1.587713240271566 * sp[30];
    A[86] = 5.583333333333343 * sp[33] + 0.9166666666666308 * sp[34] + -2.583333333333341 * sp[28] + -2.583333333333349 * sp[31] + -10.33333333333334 * sp[34] + -18.95833333333328 * sp[35] + 6.041666666666712 * sp[29] + -2.583333333333373 * sp[32] + 10.66666666666669 * sp[28] + 4.87499999999995 * sp[29] + -4.125000000000014 * sp[26] + -2.583333333333334 * sp[27] + -10.33333333333337 * sp[31] + 0.5 * sp[32] + 4.500000000000062 * sp[27] + 11.08333333333337 * sp[30];
    A[87] = -5.892556509887903 * sp[33] + -1.885618083164125 * sp[34] + -6.128258770283439 * sp[28] + -0.4714045207910406 * sp[31] + 11.5494107593803 * sp[34] + 4.831896338108118 * sp[35] + 6.24610990048112 * sp[29] + -0.4714045207910582 * sp[32] + -11.07800623858928 * sp[28] + -3.181980515339463 * sp[29] + -13.08147545195115 * sp[26] + -0.471404520791011 * sp[27] + 11.54941075938033 * sp[31] + 3.535533905932822 * sp[32] + 4.949747468305809 * sp[27] + -1.649915822768619 * sp[30];
    A[88] = 3.897114317030028 * sp[33] + 0.8660254037844569 * sp[34] + 0.8660254037844479 * sp[28] + -1.732050807568881 * sp[31] + -1.299038105676623 * sp[34] + -0.2165063509460352 * sp[35] + -2.814582562299348 * sp[29] + -1.732050807568834 * sp[32] + 9.093266739736672 * sp[28] + 0.6495190528383221 * sp[29] + 8.443747686898295 * sp[26] + -1.732050807568856 * sp[27] + -1.299038105676627 * sp[31] + -0.4330127018921643 * sp[32] + -2.165063509461028 * sp[27] + -3.897114317029977 * sp[30];
    A[89] = -10.41666666666667 * sp[33] + -3.333333333333334 * sp[34] + -6.333333333333336 * sp[28] + 0.1666666666666725 * sp[31] + 20.41666666666669 * sp[34] + 8.541666666666758 * sp[35] + 12.04166666666664 * sp[29] + 0.1666666666668597 * sp[32] + -19.58333333333338 * sp[28] + -5.625000000000006 * sp[29] + -12.12500000000005 * sp[26] + 0.1666666666666674 * sp[27] + 20.41666666666675 * sp[31] + 6.250000000000163 * sp[32] + 15.25 * sp[27] + -12.91666666666646 * sp[30];
    A[90] = -1.091666666666672 * sp[33] + -0.7333333333333447 * sp[34] + 2.133333333333351 * sp[28] + 1.149999999999995 * sp[31] + -1.10833333333334 * sp[34] + -0.3624999999999957 * sp[35] + 1.154166666666656 * sp[29] + 1.116666666666655 * sp[32] + -1.108333333333344 * sp[28] + -1.479166666666688 * sp[29] + 3.170833333333355 * sp[26] + 1.149999999999998 * sp[27] + -1.108333333333339 * sp[31] + -1.108333333333343 * sp[32] + 2.191666666666666 * sp[27] + 1.008333333333326 * sp[30];
    A[91] = 0.1833333333333381 * sp[33] + -0.1166666666666568 * sp[34] + -0.6833333333333483 * sp[28] + 0.9500000000000013 * sp[31] + -0.0333333333333278 * sp[34] + -0.8583333333333416 * sp[35] + 0.1083333333333315 * sp[29] + -0.3166666666666962 * sp[32] + -0.03333333333333408 * sp[28] + 0.7083333333333547 * sp[29] + -1.258333333333349 * sp[26] + 0.9500000000000126 * sp[27] + -0.03333333333333446 * sp[31] + -0.03333333333332666 * sp[32] + -0.4666666666666678 * sp[27] + 0.06666666666665824 * sp[30];
    A[92] = -0.508333333333334 * sp[33] + 0.2666666666666662 * sp[34] + 0.466666666666673 * sp[28] + 0.6499999999999999 * sp[31] + -0.6916666666666685 * sp[34] + 1.095833333333337 * sp[35] + 0.1125000000000037 * sp[29] + 2.283333333333359 * sp[32] + -0.6916666666666739 * sp[28] + -1.52083333333335 * sp[29] + 1.295833333333345 * sp[26] + 0.6499999999999976 * sp[27] + -0.6916666666666723 * sp[31] + -0.6916666666666733 * sp[32] + 0.941666666666672 * sp[27] + 1.59166666666668 * sp[30];
    A[93] = 1.508333333333335 * sp[33] + 0.7750000000000055 * sp[34] + 4.308333333333317 * sp[28] + 2.591666666666664 * sp[31] + 1.81666666666667 * sp[34] + 0.3208333333333322 * sp[35] + 7.504166666666658 * sp[29] + 4.308333333333328 * sp[32] + 1.816666666666682 * sp[28] + 2.270833333333352 * sp[29] + 0.3208333333333451 * sp[26] + 0.7750000000000165 * sp[27] + 1.816666666666677 * sp[31] + 1.816666666666676 * sp[32] + 1.816666666666674 * sp[27] + 1.508333333333343 * sp[30];
    A[94] = -1.016666666666666 * sp[33] + 0.03333333333333327 * sp[34] + -2.866666666666652 * sp[28] + -3.933333333333316 * sp[31] + -1.383333333333333 * sp[34] + 0.9416666666666681 * sp[35] + -5.258333333333316 * sp[29] + -7.533333333333329 * sp[32] + -1.383333333333348 * sp[28] + -2.291666666666687 * sp[29] + -0.2250000000000039 * sp[26] + -1.133333333333344 * sp[27] + -1.383333333333343 * sp[31] + -1.383333333333343 * sp[32] + -1.383333333333335 * sp[27] + -2.60000000000001 * sp[30];
    A[95] = 0.09166666666667005 * sp[33] + -0.3083333333333288 * sp[34] + 0.5583333333333274 * sp[28] + 1.341666666666669 * sp[31] + -0.01666666666666264 * sp[34] + -1.054166666666676 * sp[35] + 0.9624999999999975 * sp[29] + 3.225000000000002 * sp[32] + -0.01666666666666548 * sp[28] + 0.7291666666666847 * sp[29] + -0.3875000000000067 * sp[26] + 0.3583333333333534 * sp[27] + -0.01666666666666575 * sp[31] + -0.01666666666666139 * sp[32] + -0.01666666666667099 * sp[27] + 1.091666666666683 * sp[30];
    A[96] = 3.683333333333326 * sp[33] + 5.508333333333312 * sp[34] + 1.50833333333334 * sp[28] + 2.274999999999996 * sp[31] + 5.508333333333312 * sp[34] + 10.04166666666666 * sp[35] + 1.008333333333328 * sp[29] + 3.241666666666668 * sp[32] + 1.50833333333334 * sp[28] + 1.008333333333328 * sp[29] + 2.775000000000015 * sp[26] + 2.275000000000003 * sp[27] + 2.274999999999996 * sp[31] + 3.241666666666668 * sp[32] + 2.275000000000003 * sp[27] + 2.633333333333337 * sp[30];
    A[97] = -5.866666666666663 * sp[33] + -3.43333333333332 * sp[34] + -2.766666666666681 * sp[28] + -2.299999999999989 * sp[31] + -7.933333333333308 * sp[34] + -5.083333333333313 * sp[35] + -1.683333333333316 * sp[29] + -2.233333333333312 * sp[32] + -2.600000000000018 * sp[28] + -0.6833333333333325 * sp[29] + -4.216666666666687 * sp[26] + -2.299999999999998 * sp[27] + -3.133333333333327 * sp[31] + -1.399999999999992 * sp[32] + -3.133333333333328 * sp[27] + -2.016666666666655 * sp[30];
    A[98] = 2.183333333333334 * sp[33] + -0.2416666666666664 * sp[34] + 1.091666666666679 * sp[28] + -0.4750000000000049 * sp[31] + 2.424999999999992 * sp[34] + 1.625000000000026 * sp[35] + 0.2583333333333282 * sp[29] + 0.1583333333333474 * sp[32] + 1.091666666666677 * sp[28] + -1.075000000000003 * sp[29] + 1.691666666666678 * sp[26] + -0.4750000000000123 * sp[27] + 0.8583333333333298 * sp[31] + 0.1583333333333483 * sp[32] + 0.8583333333333293 * sp[27] + -0.03333333333333272 * sp[30];
    A[99] = -4.00693842672377 * sp[33] + -6.835365551469949 * sp[34] + 5.892556509887902 * sp[28] + 9.192388155425096 * sp[31] + -5.185449728701351 * sp[34] + -18.97403196183916 * sp[35] + 5.067598598503542 * sp[29] + 5.421151989096716 * sp[32] + -5.1854497287014 * sp[28] + -4.360491817317069 * sp[29] + 8.367430244040834 * sp[26] + 9.192388155425151 * sp[27] + -5.185449728701383 * sp[31] + -10.84230397819383 * sp[32] + 7.542472332656494 * sp[27] + 5.89255650988784 * sp[30];
    A[100] = 2.742413778650666 * sp[33] + 17.89785834487829 * sp[34] + 10.96965511460291 * sp[28] + 19.91858428704205 * sp[31] + 0.7216878364867974 * sp[34] + 24.753892791505 * sp[35] + 9.165435523385247 * sp[29] + 19.34123401785229 * sp[32] + 0.7216878364869839 * sp[28] + 2.525907427704563 * sp[29] + 18.11436469582458 * sp[26] + 19.91858428704215 * sp[27] + 0.7216878364869448 * sp[31] + 5.051814855409125 * sp[32] + 16.31014510460694 * sp[27] + 17.46484564298613 * sp[30];
    A[101] = -1.083333333333327 * sp[33] + 12.16666666666665 * sp[34] + -1.833333333333324 * sp[28] + 2.000000000000022 * sp[31] + -2.416666666666671 * sp[34] + 27.95833333333334 * sp[35] + -2.041666666666611 * sp[29] + 14.33333333333357 * sp[32] + -2.41666666666669 * sp[28] + -2.208333333333346 * sp[29] + 1.791666666666707 * sp[26] + 1.999999999999997 * sp[27] + -2.416666666666692 * sp[31] + 8.083333333333389 * sp[32] + 1.583333333333385 * sp[27] + 9.416666666666798 * sp[30];
    A[102] = 2.357022603955143 * sp[33] + 0.2357022603954868 * sp[34] + -11.07800623858924 * sp[28] + -7.778174593052066 * sp[31] + 4.006938426723754 * sp[34] + -0.2357022603954944 * sp[35] + -12.96362432175335 * sp[29] + -8.720983634634058 * sp[32] + 4.006938426723811 * sp[28] + 4.478342947514795 * sp[29] + -8.249579113843106 * sp[26] + -7.778174593052116 * sp[27] + 4.006938426723801 * sp[31] + 4.006938426723778 * sp[32] + -8.720983634634095 * sp[27] + -7.542472332656548 * sp[30];
    A[103] = 10.39230484541327 * sp[33] + 7.361215932167778 * sp[34] + 7.361215932167615 * sp[28] + -6.4951905283832 * sp[31] + 11.69134295108994 * sp[34] + 6.062177826491043 * sp[35] + 12.99038105676647 * sp[29] + -8.227241335952119 * sp[32] + 11.69134295109 * sp[28] + 12.99038105676669 * sp[29] + -7.794228634059955 * sp[26] + -6.495190528383207 * sp[27] + 11.69134295108996 * sp[31] + 11.69134295108997 * sp[32] + -3.897114317029988 * sp[27] + -6.062177826490993 * sp[30];
    A[104] = 4.166666666666639 * sp[33] + 0.4166666666666199 * sp[34] + 8.416666666666664 * sp[28] + 2.749999999999932 * sp[31] + 7.083333333333309 * sp[34] + -0.416666666666619 * sp[35] + 13.58333333333328 * sp[29] + -8.916666666666917 * sp[32] + 7.083333333333401 * sp[28] + 7.916666666666657 * sp[29] + 1.916666666666709 * sp[26] + 2.749999999999953 * sp[27] + 7.083333333333385 * sp[31] + 7.083333333333349 * sp[32] + 3.083333333333335 * sp[27] + -3.333333333333479 * sp[30];
    A[105] = 2.600000000000016 * sp[33] + 1.466666666666685 * sp[34] + -4.933333333333367 * sp[28] + -2.13333333333332 * sp[31] + 1.216666666666669 * sp[34] + 0.3083333333333393 * sp[35] + -1.058333333333327 * sp[29] + -0.8999999999999906 * sp[32] + 1.216666666666676 * sp[28] + 2.375000000000031 * sp[29] + -7.258333333333377 * sp[26] + -2.133333333333324 * sp[27] + 1.216666666666665 * sp[31] + 1.216666666666678 * sp[32] + -3.383333333333327 * sp[27] + -1.266666666666652 * sp[30];
    A[106] = -1.200000000000008 * sp[33] + -0.9333333333333441 * sp[34] + 2.533333333333362 * sp[28] + -3.06666666666668 * sp[31] + -0.4333333333333317 * sp[34] + 0.2166666666666566 * sp[35] + 0.2833333333333348 * sp[29] + -1.199999999999985 * sp[32] + -0.4333333333333345 * sp[28] + -1.583333333333361 * sp[29] + 3.683333333333368 * sp[26] + -3.066666666666695 * sp[27] + -0.4333333333333269 * sp[31] + -0.4333333333333487 * sp[32] + 1.433333333333336 * sp[27] + -1.633333333333325 * sp[30];
    A[107] = 0.6000000000000048 * sp[33] + 0.1333333333333411 * sp[34] + -0.933333333333349 * sp[28] + 0.5333333333333364 * sp[31] + 0.3833333333333376 * sp[34] + -0.4416666666666557 * sp[35] + -0.1416666666666712 * sp[29] + 0.09999999999999021 * sp[32] + 0.3833333333333361 * sp[28] + 0.9583333333333452 * sp[29] + -1.675000000000015 * sp[26] + 0.5333333333333465 * sp[27] + 0.3833333333333373 * sp[31] + 0.3833333333333459 * sp[32] + -0.883333333333338 * sp[27] + 0.0666666666666601 * sp[30];
    A[108] = -2.600000000000012 * sp[33] + -1.13333333333335 * sp[34] + -7.533333333333319 * sp[28] + -3.933333333333346 * sp[31] + -1.383333333333338 * sp[34] + -0.2250000000000068 * sp[35] + -5.258333333333325 * sp[29] + -2.86666666666667 * sp[32] + -1.383333333333342 * sp[28] + -2.291666666666688 * sp[29] + 0.9416666666666643 * sp[26] + 0.03333333333331284 * sp[27] + -1.383333333333336 * sp[31] + -1.383333333333342 * sp[32] + -1.383333333333328 * sp[27] + -1.016666666666676 * sp[30];
    A[109] = 1.200000000000005 * sp[33] + 0.2666666666666783 * sp[34] + 3.733333333333315 * sp[28] + 5.866666666666652 * sp[31] + 0.7666666666666722 * sp[34] + -0.3833333333333211 * sp[35] + 3.016666666666658 * sp[29] + 3.733333333333331 * sp[32] + 0.7666666666666736 * sp[28] + 1.416666666666681 * sp[29] + -0.3833333333333345 * sp[26] + 0.2666666666666701 * sp[27] + 0.7666666666666739 * sp[31] + 0.7666666666666804 * sp[32] + 0.7666666666666649 * sp[27] + 1.200000000000004 * sp[30];
    A[110] = -0.6000000000000063 * sp[33] + -0.4666666666666729 * sp[34] + -1.533333333333321 * sp[28] + -1.933333333333336 * sp[31] + -0.2166666666666665 * sp[34] + 0.3583333333333246 * sp[35] + -1.008333333333325 * sp[29] + -0.8666666666666765 * sp[32] + -0.2166666666666691 * sp[28] + -1.041666666666686 * sp[29] + 0.5250000000000129 * sp[26] + -0.300000000000021 * sp[27] + -0.2166666666666646 * sp[31] + -0.2166666666666805 * sp[32] + -0.2166666666666545 * sp[27] + -0.1833333333333542 * sp[30];
    A[111] = -5.866666666666663 * sp[33] + -7.933333333333308 * sp[34] + -2.600000000000018 * sp[28] + -3.133333333333327 * sp[31] + -3.43333333333332 * sp[34] + -5.083333333333313 * sp[35] + -0.6833333333333325 * sp[29] + -1.399999999999992 * sp[32] + -2.766666666666681 * sp[28] + -1.683333333333316 * sp[29] + -4.216666666666687 * sp[26] + -3.133333333333328 * sp[27] + -2.299999999999989 * sp[31] + -2.233333333333312 * sp[32] + -2.299999999999998 * sp[27] + -2.016666666666655 * sp[30];
    A[112] = 11.73333333333334 * sp[33] + 5.866666666666645 * sp[34] + 5.866666666666696 * sp[28] + 4.266666666666644 * sp[31] + 5.866666666666645 * sp[34] + 3.833333333333316 * sp[35] + 1.366666666666656 * sp[29] + 1.799999999999979 * sp[32] + 5.866666666666696 * sp[28] + 1.366666666666656 * sp[29] + 8.766666666666703 * sp[26] + 4.266666666666652 * sp[27] + 4.266666666666644 * sp[31] + 1.799999999999979 * sp[32] + 4.266666666666652 * sp[27] + 2.533333333333304 * sp[30];
    A[113] = -5.866666666666672 * sp[33] + 2.06666666666668 * sp[34] + -3.266666666666688 * sp[28] + 1.533333333333353 * sp[31] + -2.433333333333322 * sp[34] + 0.416666666666653 * sp[35] + -0.5166666666666624 * sp[29] + 0.5999999999999956 * sp[32] + -3.100000000000015 * sp[28] + 3.150000000000017 * sp[29] + -4.716666666666694 * sp[26] + 1.533333333333363 * sp[27] + -1.966666666666653 * sp[31] + 1.43333333333332 * sp[32] + -1.96666666666666 * sp[27] + 0.8166666666666701 * sp[30];
    A[114] = 5.656854249492405 * sp[33] + 1.885618083164128 * sp[34] + -9.428090415820655 * sp[28] + -20.74179891480538 * sp[31] + 3.29983164553724 * sp[34] + 2.592724864350727 * sp[35] + -3.06412938514168 * sp[29] + -8.485281374238474 * sp[32] + 3.299831645537255 * sp[28] + -3.064129385141726 * sp[29] + -14.3778378841265 * sp[26] + -20.74179891480545 * sp[27] + 3.299831645537245 * sp[31] + 0.4714045207910975 * sp[32] + -8.013876853447501 * sp[27] + -11.78511301977569 * sp[30];
    A[115] = 10.39230484541335 * sp[33] + -30.0222139978604 * sp[34] + -16.16580753730961 * sp[28] + -36.95041722813604 * sp[31] + -1.443375672973983 * sp[34] + -19.19689645055489 * sp[35] + -5.340489990004018 * sp[29] + -15.58845726811975 * sp[32] + -1.443375672974082 * sp[28] + -12.26869322027949 * sp[29] + -26.12509968083067 * sp[26] + -36.95041722813612 * sp[27] + -1.443375672974034 * sp[31] + -10.10362971081829 * sp[32] + -15.29978213352505 * sp[27] + -21.93931022920563 * sp[30];
    A[116] = -1.999999999999999 * sp[33] + -2.666666666666599 * sp[34] + 5.333333333333291 * sp[28] + 9.333333333333307 * sp[31] + -0.1666666666666354 * sp[34] + -8.416666666666636 * sp[35] + 1.58333333333328 * sp[29] + 2.999999999999897 * sp[32] + -0.1666666666666724 * sp[28] + 3.583333333333337 * sp[29] + 5.583333333333311 * sp[26] + 9.333333333333394 * sp[27] + -0.1666666666666325 * sp[31] + -1.166666666666686 * sp[32] + 1.833333333333273 * sp[27] + 3.666666666666569 * sp[30];
    A[117] = 1.885618083164133 * sp[34] + 24.51303508113368 * sp[28] + 13.19932658214895 * sp[31] + -0.9428090415820851 * sp[34] + 0.4714045207910273 * sp[35] + 11.78511301977576 * sp[29] + 5.656854249492387 * sp[32] + -0.9428090415820795 * sp[28] + 0.4714045207910766 * sp[29] + 11.78511301977583 * sp[26] + 13.19932658214902 * sp[27] + -0.9428090415821019 * sp[31] + -0.9428090415820551 * sp[32] + 10.37089945740264 * sp[27] + 8.013876853447565 * sp[30];
    A[118] = -20.78460969082662 * sp[33] + -10.39230484541337 * sp[34] + -10.39230484541312 * sp[28] + 17.32050807568862 * sp[31] + -10.39230484541328 * sp[34] + -3.464101615137769 * sp[35] + -17.32050807568871 * sp[29] + 3.464101615137628 * sp[32] + -10.39230484541332 * sp[28] + -17.32050807568894 * sp[29] + 24.24871130596434 * sp[26] + 17.3205080756886 * sp[27] + -10.39230484541325 * sp[31] + -10.3923048454133 * sp[32] + 3.464101615137789 * sp[27] + 7.794228634059776 * sp[30];
    A[119] = 3.333333333333328 * sp[34] + -12.66666666666669 * sp[28] + -4.666666666666618 * sp[31] + -1.666666666666708 * sp[34] + 0.8333333333333188 * sp[35] + -7.166666666666657 * sp[29] + -7.999999999999886 * sp[32] + -1.666666666666686 * sp[28] + 0.8333333333334036 * sp[29] + -7.166666666666755 * sp[26] + -4.66666666666663 * sp[27] + -1.666666666666732 * sp[31] + -1.666666666666657 * sp[32] + -3.666666666666689 * sp[27] + -5.833333333333192 * sp[30];
    A[120] = -1.50833333333334 * sp[33] + -0.7333333333333395 * sp[34] + 2.800000000000016 * sp[28] + 0.983333333333325 * sp[31] + 0.3083333333333502 * sp[34] + 0.7625000000000095 * sp[35] + -2.887500000000019 * sp[29] + -0.7166666666666615 * sp[32] + 0.3083333333333373 * sp[28] + -1.187500000000011 * sp[29] + 4.295833333333364 * sp[26] + 0.983333333333331 * sp[27] + 0.3083333333333499 * sp[31] + 0.3083333333333442 * sp[32] + -1.391666666666693 * sp[27] + -0.4083333333333355 * sp[30];
    A[121] = 1.016666666666667 * sp[33] + 1.050000000000002 * sp[34] + -1.850000000000014 * sp[28] + 2.116666666666677 * sp[31] + -0.3666666666666911 * sp[34] + -1.275000000000003 * sp[35] + 2.025000000000009 * sp[29] + -2.483333333333348 * sp[32] + -0.3666666666666716 * sp[28] + 1.958333333333343 * sp[29] + -3.00833333333336 * sp[26] + 2.116666666666681 * sp[27] + -0.3666666666666851 * sp[31] + -0.3666666666666696 * sp[32] + 0.8666666666666779 * sp[27] + -1.266666666666683 * sp[30];
    A[122] = -0.09166666666667071 * sp[33] + -0.4000000000000085 * sp[34] + 0.4666666666666758 * sp[28] + -1.183333333333336 * sp[31] + -0.1083333333333439 * sp[34] + 0.637499999999981 * sp[35] + -0.512499999999998 * sp[29] + 2.116666666666683 * sp[32] + -0.108333333333333 * sp[28] + -1.145833333333337 * sp[29] + 0.8375000000000103 * sp[26] + -1.183333333333342 * sp[27] + -0.1083333333333387 * sp[31] + -0.1083333333333435 * sp[32] + -0.1416666666666692 * sp[27] + 1.008333333333344 * sp[30];
    A[123] = 1.091666666666674 * sp[33] + 0.3583333333333442 * sp[34] + 3.224999999999996 * sp[28] + 1.341666666666679 * sp[31] + -0.01666666666666056 * sp[34] + -0.3874999999999951 * sp[35] + 0.9625000000000121 * sp[29] + 0.5583333333333427 * sp[32] + -0.01666666666666838 * sp[28] + 0.7291666666666742 * sp[29] + -1.054166666666671 * sp[26] + -0.3083333333333244 * sp[27] + -0.01666666666666827 * sp[31] + -0.01666666666666979 * sp[32] + -0.01666666666665777 * sp[27] + 0.09166666666667304 * sp[30];
    A[124] = -0.1833333333333394 * sp[33] + -0.3000000000000125 * sp[34] + -0.8666666666666619 * sp[28] + -1.933333333333336 * sp[31] + -0.2166666666666866 * sp[34] + 0.5249999999999755 * sp[35] + -1.008333333333355 * sp[29] + -1.533333333333369 * sp[32] + -0.2166666666666675 * sp[28] + -1.041666666666671 * sp[29] + 0.3583333333333346 * sp[26] + -0.4666666666666731 * sp[27] + -0.2166666666666771 * sp[31] + -0.2166666666666781 * sp[32] + -0.2166666666666824 * sp[27] + -0.6000000000000258 * sp[30];
    A[125] = 0.5083333333333346 * sp[33] + 0.7750000000000032 * sp[34] + 0.9749999999999903 * sp[28] + 0.5916666666666682 * sp[31] + -0.1833333333333458 * sp[34] + -1.012499999999995 * sp[35] + 0.1708333333333174 * sp[29] + 0.9750000000000042 * sp[32] + -0.1833333333333348 * sp[28] + 1.604166666666673 * sp[29] + -1.012500000000014 * sp[26] + 0.7750000000000099 * sp[27] + -0.1833333333333426 * sp[31] + -0.1833333333333306 * sp[32] + -0.1833333333333447 * sp[27] + 0.5083333333333415 * sp[30];
    A[126] = 2.183333333333334 * sp[33] + 2.424999999999992 * sp[34] + 1.091666666666677 * sp[28] + 0.8583333333333298 * sp[31] + -0.2416666666666664 * sp[34] + 1.625000000000026 * sp[35] + -1.075000000000003 * sp[29] + 0.1583333333333483 * sp[32] + 1.091666666666679 * sp[28] + 0.2583333333333282 * sp[29] + 1.691666666666678 * sp[26] + 0.8583333333333293 * sp[27] + -0.4750000000000049 * sp[31] + 0.1583333333333474 * sp[32] + -0.4750000000000123 * sp[27] + -0.03333333333333272 * sp[30];
    A[127] = -5.866666666666672 * sp[33] + -2.433333333333322 * sp[34] + -3.100000000000015 * sp[28] + -1.966666666666653 * sp[31] + 2.06666666666668 * sp[34] + 0.416666666666653 * sp[35] + 3.150000000000017 * sp[29] + 1.43333333333332 * sp[32] + -3.266666666666688 * sp[28] + -0.5166666666666624 * sp[29] + -4.716666666666694 * sp[26] + -1.96666666666666 * sp[27] + 1.533333333333353 * sp[31] + 0.5999999999999956 * sp[32] + 1.533333333333363 * sp[27] + 0.8166666666666701 * sp[30];
    A[128] = 3.683333333333334 * sp[33] + -1.825000000000013 * sp[34] + 2.17500000000001 * sp[28] + -1.058333333333348 * sp[31] + -1.825000000000013 * sp[34] + 2.708333333333342 * sp[35] + -2.32500000000001 * sp[29] + 1.241666666666681 * sp[32] + 2.17500000000001 * sp[28] + -2.32500000000001 * sp[29] + 3.441666666666691 * sp[26] + -1.058333333333347 * sp[27] + -1.058333333333348 * sp[31] + 1.241666666666681 * sp[32] + -1.058333333333347 * sp[27] + 0.6333333333333457 * sp[30];
    A[129] = -1.649915822768632 * sp[33] + 4.949747468305819 * sp[34] + 3.535533905932748 * sp[28] + 11.54941075938028 * sp[31] + -0.4714045207910801 * sp[34] + -13.08147545195122 * sp[35] + -3.181980515339493 * sp[29] + -11.07800623858926 * sp[32] + -0.4714045207910365 * sp[28] + 6.246109900481184 * sp[29] + 4.831896338108084 * sp[26] + 11.54941075938031 * sp[27] + -0.4714045207910515 * sp[31] + -6.128258770283485 * sp[32] + -1.885618083164182 * sp[27] + -5.892556509887959 * sp[30];
    A[130] = -13.134718624064 * sp[33] + 12.12435565298211 * sp[34] + 5.196152422706689 * sp[28] + 17.03183294109397 * sp[31] + -0.7216878364869053 * sp[34] + -6.278684177437062 * sp[35] + -4.546633369868346 * sp[29] + -12.41303078757694 * sp[32] + -0.721687836486973 * sp[28] + 9.021097956087903 * sp[29] + 7.289047148519067 * sp[26] + 17.03183294109399 * sp[27] + -0.7216878364869568 * sp[31] + -5.051814855409181 * sp[32] + -2.453738644056005 * sp[27] + -7.072540797573 * sp[30];
    A[131] = 3.083333333333317 * sp[33] + -9.500000000000052 * sp[34] + -3.499999999999966 * sp[28] + -11.33333333333332 * sp[31] + -1.583333333333456 * sp[34] + 13.37500000000005 * sp[35] + 3.375000000000059 * sp[29] + 17.66666666666677 * sp[32] + -1.583333333333339 * sp[28] + -8.458333333333321 * sp[29] + -4.458333333333332 * sp[26] + -11.33333333333339 * sp[27] + -1.583333333333415 * sp[31] + 3.916666666666718 * sp[32] + 2.416666666666711 * sp[27] + 8.583333333333419 * sp[30];
    A[132] = -2.357022603955139 * sp[33] + -2.121320343559622 * sp[34] + -13.43502884254441 * sp[28] + -5.421151989096882 * sp[31] + 1.649915822768736 * sp[34] + 2.121320343559728 * sp[35] + 3.535533905932831 * sp[29] + 3.064129385141747 * sp[32] + 1.649915822768628 * sp[28] + -2.592724864350697 * sp[29] + -1.178511301977561 * sp[26] + -5.421151989096915 * sp[27] + 1.649915822768693 * sp[31] + 1.649915822768655 * sp[32] + 3.064129385141808 * sp[27] + 1.88561808316418 * sp[30];
    A[133] = 10.39230484541332 * sp[33] + 3.031088913245591 * sp[34] + 3.031088913245481 * sp[28] + -10.82531754730542 * sp[31] + -1.299038105676705 * sp[34] + -2.598076211353372 * sp[35] + 4.330127018922319 * sp[29] + 4.76313972081438 * sp[32] + -1.299038105676686 * sp[28] + 4.330127018922257 * sp[29] + -16.45448267190441 * sp[26] + -10.82531754730542 * sp[27] + -1.299038105676736 * sp[31] + -1.299038105676736 * sp[32] + 0.4330127018923267 * sp[27] + 2.598076211353331 * sp[30];
    A[134] = -4.166666666666635 * sp[33] + -3.749999999999951 * sp[34] + 4.250000000000033 * sp[28] + 1.916666666666675 * sp[31] + 2.916666666666892 * sp[34] + 3.750000000000144 * sp[35] + -2.249999999999912 * sp[29] + -13.08333333333323 * sp[32] + 2.916666666666688 * sp[28] + -4.583333333333361 * sp[29] + 9.416666666666766 * sp[26] + 1.916666666666677 * sp[27] + 2.916666666666812 * sp[31] + 2.916666666666741 * sp[32] + -1.083333333333272 * sp[27] + -6.666666666666644 * sp[30];
    A[135] = 1.649915822768657 * sp[33] + 3.064129385141741 * sp[34] + -1.649915822768631 * sp[28] + -1.64991582276863 * sp[31] + 0.4714045207910416 * sp[34] + 1.767766952966353 * sp[35] + 5.06759859850362 * sp[29] + -0.235702260395545 * sp[32] + -5.185449728701387 * sp[28] + -3.889087296526076 * sp[29] + 10.72445284799601 * sp[26] + 4.006938426723742 * sp[27] + -5.185449728701395 * sp[31] + -5.185449728701429 * sp[32] + 17.44196726926825 * sp[27] + 5.892556509887847 * sp[30];
    A[136] = 3.771236166328257 * sp[33] + -3.771236166328276 * sp[34] + 0.9428090415820738 * sp[28] + 0.9428090415820902 * sp[31] + 6.128258770283459 * sp[34] + 1.178511301977606 * sp[35] + -5.421151989096868 * sp[29] + 12.25651754056691 * sp[32] + 3.299831645537244 * sp[28] + -1.649915822768554 * sp[29] + -2.592724864350696 * sp[26] + 3.771236166328308 * sp[27] + 3.299831645537265 * sp[31] + 3.299831645537295 * sp[32] + -8.956685895029656 * sp[27] + 11.78511301977583 * sp[30];
    A[137] = 4.006938426723806 * sp[33] + 10.13519719700724 * sp[34] + -4.006938426723809 * sp[28] + -4.006938426723805 * sp[31] + 5.185449728701403 * sp[34] + 7.660323462854326 * sp[35] + -3.181980515339501 * sp[29] + -16.73486048808174 * sp[32] + -0.4714045207910371 * sp[28] + 2.003469213361868 * sp[29] + 2.47487373415293 * sp[26] + 1.649915822768589 * sp[27] + -0.4714045207910227 * sp[31] + -0.4714045207910432 * sp[32] + 3.299831645537247 * sp[27] + -5.892556509887926 * sp[30];
    A[138] = -7.542472332656585 * sp[33] + -7.778174593052084 * sp[34] + -8.720983634634139 * sp[28] + -7.778174593052064 * sp[31] + -8.720983634634168 * sp[34] + -8.249579113843097 * sp[35] + -12.96362432175346 * sp[29] + -11.07800623858929 * sp[32] + 4.006938426723794 * sp[28] + 4.47834294751484 * sp[29] + -0.2357022603955023 * sp[26] + 0.2357022603955499 * sp[27] + 4.006938426723776 * sp[31] + 4.006938426723811 * sp[32] + 4.006938426723706 * sp[27] + 2.357022603955166 * sp[30];
    A[139] = 8.013876853447606 * sp[33] + 13.19932658214896 * sp[34] + 5.656854249492391 * sp[28] + 13.19932658214893 * sp[31] + 10.37089945740279 * sp[34] + 11.78511301977588 * sp[35] + 11.78511301977585 * sp[29] + 24.51303508113378 * sp[32] + -0.9428090415820742 * sp[28] + 0.4714045207910111 * sp[29] + 0.4714045207910353 * sp[26] + 1.885618083164146 * sp[27] + -0.9428090415820451 * sp[31] + -0.9428090415820722 * sp[32] + -0.9428090415819943 * sp[27];
    A[140] = 1.885618083164123 * sp[33] + -5.421151989096895 * sp[34] + 3.064129385141717 * sp[28] + -5.421151989096908 * sp[31] + 3.064129385141722 * sp[34] + -1.178511301977579 * sp[35] + 3.53553390593277 * sp[29] + -13.43502884254445 * sp[32] + 1.649915822768624 * sp[28] + -2.592724864350637 * sp[29] + 2.121320343559647 * sp[26] + -2.121320343559611 * sp[27] + 1.649915822768636 * sp[31] + 1.649915822768656 * sp[32] + 1.649915822768606 * sp[27] + -2.357022603955118 * sp[30];
    A[141] = -4.00693842672377 * sp[33] + -5.185449728701351 * sp[34] + -5.1854497287014 * sp[28] + -5.185449728701383 * sp[31] + -6.835365551469949 * sp[34] + -18.97403196183916 * sp[35] + -4.360491817317069 * sp[29] + -10.84230397819383 * sp[32] + 5.892556509887902 * sp[28] + 5.067598598503542 * sp[29] + 8.367430244040834 * sp[26] + 7.542472332656494 * sp[27] + 9.192388155425096 * sp[31] + 5.421151989096716 * sp[32] + 9.192388155425151 * sp[27] + 5.89255650988784 * sp[30];
    A[142] = 5.656854249492405 * sp[33] + 3.29983164553724 * sp[34] + 3.299831645537255 * sp[28] + 3.299831645537245 * sp[31] + 1.885618083164128 * sp[34] + 2.592724864350727 * sp[35] + -3.064129385141726 * sp[29] + 0.4714045207910975 * sp[32] + -9.428090415820655 * sp[28] + -3.06412938514168 * sp[29] + -14.3778378841265 * sp[26] + -8.013876853447501 * sp[27] + -20.74179891480538 * sp[31] + -8.485281374238474 * sp[32] + -20.74179891480545 * sp[27] + -11.78511301977569 * sp[30];
    A[143] = -1.649915822768632 * sp[33] + -0.4714045207910801 * sp[34] + -0.4714045207910365 * sp[28] + -0.4714045207910515 * sp[31] + 4.949747468305819 * sp[34] + -13.08147545195122 * sp[35] + 6.246109900481184 * sp[29] + -6.128258770283485 * sp[32] + 3.535533905932748 * sp[28] + -3.181980515339493 * sp[29] + 4.831896338108084 * sp[26] + -1.885618083164182 * sp[27] + 11.54941075938028 * sp[31] + -11.07800623858926 * sp[32] + 11.54941075938031 * sp[27] + -5.892556509887959 * sp[30];
    A[144] = 26.66666666666691 * sp[33] + 33.33333333333363 * sp[34] + -6.666666666666727 * sp[28] + -6.666666666666652 * sp[31] + 33.33333333333363 * sp[34] + 113.333333333334 * sp[35] + -6.666666666666593 * sp[29] + 33.33333333333346 * sp[32] + -6.666666666666727 * sp[28] + -6.666666666666593 * sp[29] + 33.33333333333339 * sp[26] + 33.3333333333334 * sp[27] + -6.666666666666652 * sp[31] + 33.33333333333346 * sp[32] + 33.3333333333334 * sp[27] + 66.66666666666657 * sp[30];
    A[145] = 4.08248290463894 * sp[33] + -4.082482904638334 * sp[34] + -28.57738033247067 * sp[28] + -28.5773803324705 * sp[31] + 8.164965809277671 * sp[34] + 14.28869016623517 * sp[35] + -34.70110468942836 * sp[29] + -4.08248290463877 * sp[32] + 8.164965809277167 * sp[28] + 14.28869016623503 * sp[29] + 63.27848502189893 * sp[26] + 69.4022093788568 * sp[27] + 8.164965809276937 * sp[31] + 57.15476066494009 * sp[32] + 57.15476066494103 * sp[27] + 102.0620726159655 * sp[30];
    A[146] = 25.92724864350691 * sp[33] + 16.49915822768611 * sp[34] + -25.927248643507 * sp[28] + -25.92724864350699 * sp[31] + 37.71236166328292 * sp[34] + -64.8181216087671 * sp[35] + -36.5338503613053 * sp[29] + -124.9221980096242 * sp[32] + 9.428090415820702 * sp[28] + 20.03469213361881 * sp[29] + -8.249579113843019 * sp[26] + 2.357022603955098 * sp[27] + 9.428090415820821 * sp[31] + -18.85618083164147 * sp[32] + -18.85618083164124 * sp[27] + -58.92556509887904 * sp[30];
    A[147] = -33.33333333333355 * sp[33] + -26.66666666666681 * sp[34] + 13.33333333333355 * sp[28] + 13.33333333333351 * sp[31] + -46.66666666666707 * sp[34] + -36.66666666666703 * sp[35] + 3.333333333333378 * sp[29] + 13.33333333333334 * sp[32] + -6.666666666666705 * sp[28] + 3.333333333333231 * sp[29] + -36.66666666666683 * sp[26] + -26.66666666666692 * sp[27] + -6.66666666666684 * sp[31] + -6.666666666666879 * sp[32] + -46.66666666666679 * sp[27] + -33.33333333333361 * sp[30];
    A[148] = -36.74234614174799 * sp[33] + -24.49489742783205 * sp[34] + -24.49489742783193 * sp[28] + -36.74234614174782 * sp[34] + -30.61862178478971 * sp[35] + -6.123724356958281 * sp[29] + 36.74234614174793 * sp[28] + 42.86607049870594 * sp[29] + -30.61862178478974 * sp[26] + -24.49489742783141 * sp[27] + 36.74234614174789 * sp[31] + 36.74234614174809 * sp[32] + -12.24744871391641 * sp[27] + -36.74234614174708 * sp[30];
    A[149] = -58.9255650988793 * sp[33] + -47.14045207910345 * sp[34] + -18.85618083164124 * sp[28] + -4.714045207910225 * sp[31] + -82.49579113843124 * sp[34] + -64.81812160876747 * sp[35] + -22.39171473757413 * sp[29] + 80.1387685344756 * sp[32] + -11.78511301977586 * sp[28] + 5.892556509887703 * sp[29] + -8.24957911384308 * sp[26] + 9.428090415820476 * sp[27] + -11.78511301977611 * sp[31] + -11.78511301977613 * sp[32] + 16.49915822768599 * sp[27] + 54.21151989096813 * sp[30];
    A[150] = 10.96965511460297 * sp[33] + 0.1443375672973248 * sp[34] + 0.7216878364870769 * sp[28] + 0.7216878364870553 * sp[31] + 0.7216878364870073 * sp[34] + -1.732050807568887 * sp[35] + 11.5470053837925 * sp[29] + 5.051814855409164 * sp[32] + -10.53664241271076 * sp[28] + -8.660254037844531 * sp[29] + 18.47520861406814 * sp[26] + 7.649891066762512 * sp[27] + -10.53664241271076 * sp[31] + -10.53664241271081 * sp[32] + 29.30052616137361 * sp[27] + 10.96965511460281 * sp[30];
    A[151] = -8.948929172439195 * sp[33] + -3.175426480542773 * sp[34] + 1.44337567297401 * sp[28] + 1.443375672973979 * sp[31] + -1.443375672973981 * sp[34] + 2.020725942163697 * sp[35] + -7.216878364870347 * sp[29] + 10.10362971081833 * sp[32] + 3.752776749732595 * sp[28] + -1.443375672973921 * sp[29] + -3.752776749732632 * sp[26] + 4.907477288111922 * sp[27] + 3.752776749732633 * sp[31] + 3.752776749732677 * sp[32] + -12.41303078757703 * sp[27] + 14.14508159514586 * sp[30];
    A[152] = -0.5773502691895662 * sp[33] + 4.474464586219634 * sp[34] + -0.7216878364870607 * sp[28] + -0.7216878364870607 * sp[31] + -0.721687836486979 * sp[34] + 4.041451884327465 * sp[35] + -5.051814855409188 * sp[32] + -3.319764047840383 * sp[28] + -2.886751345948211 * sp[29] + 6.928203230275559 * sp[26] + 6.206515393788447 * sp[27] + -3.319764047840353 * sp[31] + -3.319764047840371 * sp[32] + 7.64989106676259 * sp[27] + -0.5773502691896217 * sp[30];
    A[153] = -5.917840259193789 * sp[33] + -0.8660254037844908 * sp[34] + -11.83568051838752 * sp[28] + -0.8660254037845858 * sp[31] + 0.7216878364869613 * sp[34] + -2.237232293109852 * sp[35] + 18.25870226312176 * sp[29] + 10.96965511460278 * sp[32] + 11.98001808568483 * sp[28] + 13.3512249750102 * sp[29] + 2.670244995002086 * sp[26] + 4.041451884327469 * sp[27] + 11.98001808568478 * sp[31] + 11.98001808568482 * sp[32] + 11.98001808568468 * sp[27] + 8.804591605141827 * sp[30];
    A[154] = -1.15470053837915 * sp[33] + 4.6188021535171 * sp[34] + -5.196152422706527 * sp[28] + 4.618802153517177 * sp[31] + -1.443375672973955 * sp[34] + 5.917840259193778 * sp[35] + -14.8667694316327 * sp[29] + -16.16580753730933 * sp[32] + -6.639528095680762 * sp[28] + -7.938566201357448 * sp[29] + -1.010362971081858 * sp[26] + -2.309401076758518 * sp[27] + -6.639528095680701 * sp[31] + -6.639528095680724 * sp[32] + -6.639528095680608 * sp[27] + -10.39230484541317 * sp[30];
    A[155] = -4.474464586219606 * sp[33] + -3.752776749732472 * sp[34] + -8.948929172439207 * sp[28] + -3.752776749732475 * sp[31] + -0.7216878364869904 * sp[34] + -0.07216878364873436 * sp[35] + 0.2165063509461388 * sp[29] + 5.196152422706637 * sp[32] + 1.876388374866306 * sp[28] + -1.804219591217469 * sp[29] + 1.948557158514981 * sp[26] + -1.732050807568771 * sp[27] + 1.876388374866327 * sp[31] + 1.876388374866351 * sp[32] + 1.876388374866276 * sp[27] + 1.587713240271566 * sp[30];
    A[156] = 2.742413778650666 * sp[33] + 0.7216878364867974 * sp[34] + 0.7216878364869839 * sp[28] + 0.7216878364869448 * sp[31] + 17.89785834487829 * sp[34] + 24.753892791505 * sp[35] + 2.525907427704563 * sp[29] + 5.051814855409125 * sp[32] + 10.96965511460291 * sp[28] + 9.165435523385247 * sp[29] + 18.11436469582458 * sp[26] + 16.31014510460694 * sp[27] + 19.91858428704205 * sp[31] + 19.34123401785229 * sp[32] + 19.91858428704215 * sp[27] + 17.46484564298613 * sp[30];
    A[157] = 10.39230484541335 * sp[33] + -1.443375672973983 * sp[34] + -1.443375672974082 * sp[28] + -1.443375672974034 * sp[31] + -30.0222139978604 * sp[34] + -19.19689645055489 * sp[35] + -12.26869322027949 * sp[29] + -10.10362971081829 * sp[32] + -16.16580753730961 * sp[28] + -5.340489990004018 * sp[29] + -26.12509968083067 * sp[26] + -15.29978213352505 * sp[27] + -36.95041722813604 * sp[31] + -15.58845726811975 * sp[32] + -36.95041722813612 * sp[27] + -21.93931022920563 * sp[30];
    A[158] = -13.134718624064 * sp[33] + -0.7216878364869053 * sp[34] + -0.721687836486973 * sp[28] + -0.7216878364869568 * sp[31] + 12.12435565298211 * sp[34] + -6.278684177437062 * sp[35] + 9.021097956087903 * sp[29] + -5.051814855409181 * sp[32] + 5.196152422706689 * sp[28] + -4.546633369868346 * sp[29] + 7.289047148519067 * sp[26] + -2.453738644056005 * sp[27] + 17.03183294109397 * sp[31] + -12.41303078757694 * sp[32] + 17.03183294109399 * sp[27] + -7.072540797573 * sp[30];
    A[159] = 4.08248290463894 * sp[33] + 8.164965809277671 * sp[34] + 8.164965809277167 * sp[28] + 8.164965809276937 * sp[31] + -4.082482904638334 * sp[34] + 14.28869016623517 * sp[35] + 14.28869016623503 * sp[29] + 57.15476066494009 * sp[32] + -28.57738033247067 * sp[28] + -34.70110468942836 * sp[29] + 63.27848502189893 * sp[26] + 57.15476066494103 * sp[27] + -28.5773803324705 * sp[31] + -4.08248290463877 * sp[32] + 69.4022093788568 * sp[27] + 102.0620726159655 * sp[30];
    A[160] = 189.9999999999999 * sp[33] + 57.4999999999989 * sp[34] + 12.49999999999961 * sp[28] + 12.4999999999992 * sp[31] + 57.4999999999989 * sp[34] + 132.4999999999985 * sp[35] + 12.49999999999967 * sp[29] + 87.49999999999878 * sp[32] + 12.49999999999961 * sp[28] + 12.49999999999967 * sp[29] + 132.5000000000005 * sp[26] + 132.5000000000003 * sp[27] + 12.4999999999992 * sp[31] + 87.49999999999878 * sp[32] + 132.5000000000003 * sp[27] + 189.9999999999996 * sp[30];
    A[161] = -31.75426480542918 * sp[33] + 105.3664241271068 * sp[34] + -7.216878364870665 * sp[28] + -7.216878364870606 * sp[31] + -7.216878364869891 * sp[34] + 57.73502691896245 * sp[35] + -28.86751345948135 * sp[29] + -50.51814855409178 * sp[32] + 1.443375672974048 * sp[28] + 23.0940107675849 * sp[29] + 5.773502691896425 * sp[26] + 27.42413778650713 * sp[27] + 1.443375672974274 * sp[31] + 10.10362971081838 * sp[32] + -15.87713240271453 * sp[27] + -31.75426480542913 * sp[30];
    A[162] = 28.57738033247007 * sp[33] + -4.082482904639338 * sp[34] + 69.40220937885707 * sp[28] + -4.082482904638929 * sp[31] + 8.164965809276712 * sp[34] + -22.45365597551282 * sp[35] + -22.45365597551241 * sp[29] + -28.57738033247036 * sp[32] + 8.16496580927736 * sp[28] + 26.53613888015096 * sp[29] + -71.44345083117645 * sp[26] + -53.0722777603028 * sp[27] + 8.164965809277085 * sp[31] + 8.164965809277 * sp[32] + -89.81462390205016 * sp[27] + -69.40220937885722 * sp[30];
    A[163] = -67.50000000000082 * sp[33] + 7.499999999999979 * sp[34] + 7.499999999998909 * sp[28] + 52.50000000000041 * sp[31] + 3.749999999999925 * sp[35] + 48.7499999999989 * sp[29] + -22.49999999999951 * sp[32] + 90.0000000000006 * sp[28] + 93.75000000000072 * sp[29] + -41.25000000000001 * sp[26] + -37.49999999999941 * sp[27] + 90.00000000000047 * sp[31] + 90.00000000000071 * sp[32] + -30.00000000000074 * sp[27] + -67.49999999999909 * sp[30];
    A[164] = 50.5181485540917 * sp[33] + -7.216878364871604 * sp[34] + 44.74464586219597 * sp[28] + 105.3664241271057 * sp[31] + 14.43375672973968 * sp[34] + -39.69283100678734 * sp[35] + 72.89047148518972 * sp[29] + 62.0651539378833 * sp[32] + 14.43375672974081 * sp[28] + 46.90970937165682 * sp[29] + -13.71206889325355 * sp[26] + 18.76388374866246 * sp[27] + 14.43375672974031 * sp[31] + 14.43375672974021 * sp[32] + 31.7542648054292 * sp[27] + 50.51814855409111 * sp[30];
    A[165] = -6.833333333333332 * sp[33] + 2.416666666666663 * sp[34] + 0.08333333333334486 * sp[28] + 0.08333333333329188 * sp[31] + 1.583333333333402 * sp[34] + 3.749999999999958 * sp[35] + -4.91666666666666 * sp[29] + 0.5833333333333339 * sp[32] + 0.08333333333330728 * sp[28] + -1.250000000000014 * sp[29] + -5.916666666666667 * sp[26] + -0.9166666666666263 * sp[27] + 0.08333333333332948 * sp[31] + 0.08333333333337611 * sp[32] + -10.91666666666674 * sp[27] + -1.833333333333296 * sp[30];
    A[166] = 11.16666666666669 * sp[33] + -8.166666666666659 * sp[34] + 3.16666666666668 * sp[28] + 3.166666666666764 * sp[31] + 1.833333333333279 * sp[34] + -16.66666666666659 * sp[35] + 10.66666666666665 * sp[29] + -7.8333333333334 * sp[32] + -5.166666666666692 * sp[28] + 3.333333333333356 * sp[29] + 2.666666666666669 * sp[26] + -4.833333333333376 * sp[27] + -5.16666666666671 * sp[31] + -5.166666666666734 * sp[32] + 10.16666666666672 * sp[27] + -17.16666666666675 * sp[30];
    A[167] = 4.833333333333357 * sp[33] + 14.9166666666667 * sp[34] + -4.083333333333369 * sp[28] + -4.08333333333339 * sp[31] + 2.416666666666665 * sp[34] + 22.91666666666662 * sp[35] + -5.750000000000002 * sp[29] + 11.41666666666675 * sp[32] + -4.083333333333377 * sp[28] + -12.08333333333341 * sp[29] + 3.250000000000032 * sp[26] + 4.916666666666709 * sp[27] + -4.08333333333338 * sp[31] + -4.083333333333346 * sp[32] + 1.58333333333334 * sp[27] + 19.83333333333346 * sp[30];
    A[168] = -3.583333333333375 * sp[33] + -7.000000000000025 * sp[34] + -2.666666666666703 * sp[28] + -7.000000000000008 * sp[31] + -4.916666666666701 * sp[34] + -7.708333333333315 * sp[35] + 4.458333333333265 * sp[29] + 2.166666666666635 * sp[32] + 6.583333333333412 * sp[28] + 7.291666666666716 * sp[29] + 5.458333333333416 * sp[26] + 6.166666666666709 * sp[27] + 6.583333333333401 * sp[31] + 6.583333333333342 * sp[32] + 6.583333333333479 * sp[27] + 6.916666666666714 * sp[30];
    A[169] = 9.666666666666718 * sp[33] + 17.33333333333337 * sp[34] + 7.000000000000003 * sp[28] + 17.33333333333338 * sp[31] + 4.833333333333328 * sp[34] + 24.58333333333329 * sp[35] + -11.41666666666668 * sp[29] + -2.666666666666717 * sp[32] + -8.16666666666675 * sp[28] + -15.41666666666676 * sp[29] + -3.416666666666707 * sp[26] + -10.66666666666676 * sp[27] + -8.166666666666753 * sp[31] + -8.166666666666703 * sp[32] + -8.166666666666769 * sp[27] + -18.00000000000018 * sp[30];
    A[170] = 5.583333333333343 * sp[33] + -10.33333333333334 * sp[34] + 10.66666666666669 * sp[28] + -10.33333333333337 * sp[31] + 0.9166666666666308 * sp[34] + -18.95833333333328 * sp[35] + 4.87499999999995 * sp[29] + 0.5 * sp[32] + -2.583333333333341 * sp[28] + 6.041666666666712 * sp[29] + -4.125000000000014 * sp[26] + 4.500000000000062 * sp[27] + -2.583333333333349 * sp[31] + -2.583333333333373 * sp[32] + -2.583333333333334 * sp[27] + 11.08333333333337 * sp[30];
    A[171] = -1.083333333333327 * sp[33] + -2.416666666666671 * sp[34] + -2.41666666666669 * sp[28] + -2.416666666666692 * sp[31] + 12.16666666666665 * sp[34] + 27.95833333333334 * sp[35] + -2.208333333333346 * sp[29] + 8.083333333333389 * sp[32] + -1.833333333333324 * sp[28] + -2.041666666666611 * sp[29] + 1.791666666666707 * sp[26] + 1.583333333333385 * sp[27] + 2.000000000000022 * sp[31] + 14.33333333333357 * sp[32] + 1.999999999999997 * sp[27] + 9.416666666666798 * sp[30];
    A[172] = -1.999999999999999 * sp[33] + -0.1666666666666354 * sp[34] + -0.1666666666666724 * sp[28] + -0.1666666666666325 * sp[31] + -2.666666666666599 * sp[34] + -8.416666666666636 * sp[35] + 3.583333333333337 * sp[29] + -1.166666666666686 * sp[32] + 5.333333333333291 * sp[28] + 1.58333333333328 * sp[29] + 5.583333333333311 * sp[26] + 1.833333333333273 * sp[27] + 9.333333333333307 * sp[31] + 2.999999999999897 * sp[32] + 9.333333333333394 * sp[27] + 3.666666666666569 * sp[30];
    A[173] = 3.083333333333317 * sp[33] + -1.583333333333456 * sp[34] + -1.583333333333339 * sp[28] + -1.583333333333415 * sp[31] + -9.500000000000052 * sp[34] + 13.37500000000005 * sp[35] + -8.458333333333321 * sp[29] + 3.916666666666718 * sp[32] + -3.499999999999966 * sp[28] + 3.375000000000059 * sp[29] + -4.458333333333332 * sp[26] + 2.416666666666711 * sp[27] + -11.33333333333332 * sp[31] + 17.66666666666677 * sp[32] + -11.33333333333339 * sp[27] + 8.583333333333419 * sp[30];
    A[174] = 25.92724864350691 * sp[33] + 37.71236166328292 * sp[34] + 9.428090415820702 * sp[28] + 9.428090415820821 * sp[31] + 16.49915822768611 * sp[34] + -64.8181216087671 * sp[35] + 20.03469213361881 * sp[29] + -18.85618083164147 * sp[32] + -25.927248643507 * sp[28] + -36.5338503613053 * sp[29] + -8.249579113843019 * sp[26] + -18.85618083164124 * sp[27] + -25.92724864350699 * sp[31] + -124.9221980096242 * sp[32] + 2.357022603955098 * sp[27] + -58.92556509887904 * sp[30];
    A[175] = -31.75426480542918 * sp[33] + -7.216878364869891 * sp[34] + 1.443375672974048 * sp[28] + 1.443375672974274 * sp[31] + 105.3664241271068 * sp[34] + 57.73502691896245 * sp[35] + 23.0940107675849 * sp[29] + 10.10362971081838 * sp[32] + -7.216878364870665 * sp[28] + -28.86751345948135 * sp[29] + 5.773502691896425 * sp[26] + -15.87713240271453 * sp[27] + -7.216878364870606 * sp[31] + -50.51814855409178 * sp[32] + 27.42413778650713 * sp[27] + -31.75426480542913 * sp[30];
    A[176] = 53.33333333333351 * sp[33] + 14.16666666666645 * sp[34] + -30.83333333333359 * sp[28] + -30.83333333333368 * sp[31] + 14.16666666666645 * sp[34] + 219.1666666666669 * sp[35] + -30.83333333333335 * sp[29] + 84.16666666666728 * sp[32] + -30.83333333333359 * sp[28] + -30.83333333333335 * sp[29] + 39.1666666666669 * sp[26] + 39.16666666666688 * sp[27] + -30.83333333333368 * sp[31] + 84.16666666666728 * sp[32] + 39.16666666666688 * sp[27] + 153.3333333333343 * sp[30];
    A[177] = -58.92556509887918 * sp[33] + -25.92724864350688 * sp[34] + -40.06938426723767 * sp[28] + 2.357022603955209 * sp[31] + -18.85618083164113 * sp[34] + -22.39171473757404 * sp[35] + 5.892556509888269 * sp[29] + -11.78511301977594 * sp[32] + 37.71236166328285 * sp[28] + 34.17682775734998 * sp[29] + 5.892556509887717 * sp[26] + 2.35702260395506 * sp[27] + 37.7123616632829 * sp[31] + 37.71236166328287 * sp[32] + 9.428090415820559 * sp[27] + -2.357022603955116 * sp[30];
    A[178] = 12.99038105676664 * sp[33] + -4.330127018922234 * sp[34] + -4.330127018922373 * sp[28] + -12.99038105676665 * sp[31] + -25.98076211353341 * sp[34] + 10.8253175473055 * sp[35] + 2.165063509460595 * sp[29] + 12.99038105676663 * sp[32] + 25.98076211353339 * sp[28] + 10.82531754730559 * sp[29] + 36.80607966083888 * sp[26] + 21.65063509461081 * sp[27] + 25.98076211353328 * sp[31] + 25.980762113533 * sp[32] + -8.660254037843824 * sp[27] + 12.99038105676605 * sp[30];
    A[179] = -104.166666666667 * sp[33] + -45.83333333333361 * sp[34] + -55.83333333333337 * sp[28] + -0.8333333333331991 * sp[31] + -33.33333333333302 * sp[34] + -39.58333333333348 * sp[35] + 5.416666666666899 * sp[29] + -25.83333333333391 * sp[32] + 66.66666666666718 * sp[28] + 60.41666666666701 * sp[29] + 5.416666666666727 * sp[26] + -0.8333333333334121 * sp[27] + 66.6666666666673 * sp[31] + 66.66666666666723 * sp[32] + -3.333333333333199 * sp[27] + -104.1666666666669 * sp[30];
    A[180] = 5.892556509887886 * sp[33] + -3.299831645537232 * sp[34] + 0.4714045207910382 * sp[28] + 0.4714045207910766 * sp[31] + -1.649915822768633 * sp[34] + -2.474873734152924 * sp[35] + -2.003469213361926 * sp[29] + 0.4714045207910342 * sp[32] + 16.73486048808173 * sp[28] + 3.181980515339538 * sp[29] + -7.6603234628543 * sp[26] + -5.185449728701294 * sp[27] + 4.006938426723819 * sp[31] + 4.006938426723853 * sp[32] + -10.1351971970073 * sp[27] + -4.006938426723779 * sp[30];
    A[181] = -11.78511301977582 * sp[33] + 8.956685895029606 * sp[34] + -3.299831645537247 * sp[28] + -3.299831645537318 * sp[31] + -3.771236166328261 * sp[34] + 2.592724864350706 * sp[35] + 1.649915822768625 * sp[29] + -3.299831645537284 * sp[32] + -12.25651754056686 * sp[28] + 5.421151989096809 * sp[29] + -1.178511301977587 * sp[26] + -6.128258770283504 * sp[27] + -0.9428090415820727 * sp[31] + -0.9428090415821058 * sp[32] + 3.771236166328306 * sp[27] + -3.771236166328317 * sp[30];
    A[182] = -5.892556509887928 * sp[33] + -17.44196726926823 * sp[34] + 5.185449728701395 * sp[28] + 5.185449728701408 * sp[31] + -4.006938426723797 * sp[34] + -10.72445284799602 * sp[35] + 3.889087296526022 * sp[29] + 5.185449728701393 * sp[32] + 0.2357022603955552 * sp[28] + -5.067598598503524 * sp[29] + -1.767766952966394 * sp[26] + -0.4714045207910194 * sp[27] + 1.649915822768635 * sp[31] + 1.649915822768642 * sp[32] + -3.064129385141754 * sp[27] + -1.649915822768602 * sp[30];
    A[183] = 5.892556509887954 * sp[33] + 9.192388155425158 * sp[34] + 5.421151989096889 * sp[28] + 9.192388155425126 * sp[31] + 7.542472332656553 * sp[34] + 8.367430244040827 * sp[35] + 5.067598598503654 * sp[29] + 5.892556509887916 * sp[32] + -10.84230397819383 * sp[28] + -4.360491817317128 * sp[29] + -18.97403196183909 * sp[26] + -6.835365551470056 * sp[27] + -5.185449728701411 * sp[31] + -5.185449728701432 * sp[32] + -5.185449728701349 * sp[27] + -4.006938426723817 * sp[30];
    A[184] = -11.78511301977585 * sp[33] + -20.74179891480546 * sp[34] + -8.485281374238562 * sp[28] + -20.74179891480543 * sp[31] + -8.013876853447586 * sp[34] + -14.37783788412652 * sp[35] + -3.064129385141721 * sp[29] + -9.428090415820702 * sp[32] + 0.4714045207910922 * sp[28] + -3.064129385141616 * sp[29] + 2.592724864350688 * sp[26] + 1.885618083164139 * sp[27] + 3.299831645537267 * sp[31] + 3.299831645537274 * sp[32] + 3.299831645537223 * sp[27] + 5.656854249492359 * sp[30];
    A[185] = -5.892556509887903 * sp[33] + 11.5494107593803 * sp[34] + -11.07800623858928 * sp[28] + 11.54941075938033 * sp[31] + -1.885618083164125 * sp[34] + 4.831896338108118 * sp[35] + -3.181980515339463 * sp[29] + 3.535533905932822 * sp[32] + -6.128258770283439 * sp[28] + 6.24610990048112 * sp[29] + -13.08147545195115 * sp[26] + 4.949747468305809 * sp[27] + -0.4714045207910406 * sp[31] + -0.4714045207910582 * sp[32] + -0.471404520791011 * sp[27] + -1.649915822768619 * sp[30];
    A[186] = 2.357022603955143 * sp[33] + 4.006938426723754 * sp[34] + 4.006938426723811 * sp[28] + 4.006938426723801 * sp[31] + 0.2357022603954868 * sp[34] + -0.2357022603954944 * sp[35] + 4.478342947514795 * sp[29] + 4.006938426723778 * sp[32] + -11.07800623858924 * sp[28] + -12.96362432175335 * sp[29] + -8.249579113843106 * sp[26] + -8.720983634634095 * sp[27] + -7.778174593052066 * sp[31] + -8.720983634634058 * sp[32] + -7.778174593052116 * sp[27] + -7.542472332656548 * sp[30];
    A[187] = -0.9428090415820851 * sp[34] + -0.9428090415820795 * sp[28] + -0.9428090415821019 * sp[31] + 1.885618083164133 * sp[34] + 0.4714045207910273 * sp[35] + 0.4714045207910766 * sp[29] + -0.9428090415820551 * sp[32] + 24.51303508113368 * sp[28] + 11.78511301977576 * sp[29] + 11.78511301977583 * sp[26] + 10.37089945740264 * sp[27] + 13.19932658214895 * sp[31] + 5.656854249492387 * sp[32] + 13.19932658214902 * sp[27] + 8.013876853447565 * sp[30];
    A[188] = -2.357022603955139 * sp[33] + 1.649915822768736 * sp[34] + 1.649915822768628 * sp[28] + 1.649915822768693 * sp[31] + -2.121320343559622 * sp[34] + 2.121320343559728 * sp[35] + -2.592724864350697 * sp[29] + 1.649915822768655 * sp[32] + -13.43502884254441 * sp[28] + 3.535533905932831 * sp[29] + -1.178511301977561 * sp[26] + 3.064129385141808 * sp[27] + -5.421151989096882 * sp[31] + 3.064129385141747 * sp[32] + -5.421151989096915 * sp[27] + 1.88561808316418 * sp[30];
    A[189] = -33.33333333333355 * sp[33] + -46.66666666666707 * sp[34] + -6.666666666666705 * sp[28] + -6.66666666666684 * sp[31] + -26.66666666666681 * sp[34] + -36.66666666666703 * sp[35] + 3.333333333333231 * sp[29] + -6.666666666666879 * sp[32] + 13.33333333333355 * sp[28] + 3.333333333333378 * sp[29] + -36.66666666666683 * sp[26] + -46.66666666666679 * sp[27] + 13.33333333333351 * sp[31] + 13.33333333333334 * sp[32] + -26.66666666666692 * sp[27] + -33.33333333333361 * sp[30];
    A[190] = 28.57738033247007 * sp[33] + 8.164965809276712 * sp[34] + 8.16496580927736 * sp[28] + 8.164965809277085 * sp[31] + -4.082482904639338 * sp[34] + -22.45365597551282 * sp[35] + 26.53613888015096 * sp[29] + 8.164965809277 * sp[32] + 69.40220937885707 * sp[28] + -22.45365597551241 * sp[29] + -71.44345083117645 * sp[26] + -89.81462390205016 * sp[27] + -4.082482904638929 * sp[31] + -28.57738033247036 * sp[32] + -53.0722777603028 * sp[27] + -69.40220937885722 * sp[30];
    A[191] = -58.92556509887918 * sp[33] + -18.85618083164113 * sp[34] + 37.71236166328285 * sp[28] + 37.7123616632829 * sp[31] + -25.92724864350688 * sp[34] + -22.39171473757404 * sp[35] + 34.17682775734998 * sp[29] + 37.71236166328287 * sp[32] + -40.06938426723767 * sp[28] + 5.892556509888269 * sp[29] + 5.892556509887717 * sp[26] + 9.428090415820559 * sp[27] + 2.357022603955209 * sp[31] + -11.78511301977594 * sp[32] + 2.35702260395506 * sp[27] + -2.357022603955116 * sp[30];
    A[192] = 66.66666666666693 * sp[33] + 33.3333333333335 * sp[34] + 33.33333333333328 * sp[28] + -6.666666666666767 * sp[31] + 33.3333333333335 * sp[34] + 33.33333333333339 * sp[35] + -6.666666666666762 * sp[29] + -6.666666666666691 * sp[32] + 33.33333333333328 * sp[28] + -6.666666666666762 * sp[29] + 113.3333333333337 * sp[26] + 33.33333333333358 * sp[27] + -6.666666666666767 * sp[31] + -6.666666666666691 * sp[32] + 33.33333333333358 * sp[27] + 26.66666666666708 * sp[30];
    A[193] = 12.24744871391601 * sp[34] + 12.24744871391598 * sp[28] + 12.24744871391597 * sp[31] + 36.74234614174777 * sp[34] + 24.49489742783174 * sp[35] + 24.49489742783184 * sp[29] + 12.24744871391583 * sp[32] + -110.2270384252438 * sp[28] + -48.98979485566402 * sp[29] + -48.98979485566366 * sp[26] + 36.7423461417473 * sp[27] + -36.74234614174807 * sp[31] + -36.74234614174827 * sp[32] + 12.24744871391595 * sp[27] + 24.49489742783142 * sp[30];
    A[194] = 117.8511301977584 * sp[33] + 58.92556509887928 * sp[34] + 58.92556509887898 * sp[28] + 2.357022603954976 * sp[31] + 58.92556509887923 * sp[34] + 58.92556509887905 * sp[35] + 2.357022603955117 * sp[29] + 2.357022603954542 * sp[32] + 58.92556509887883 * sp[28] + -11.78511301977595 * sp[29] + 44.78342947514814 * sp[26] + -11.78511301977571 * sp[27] + -11.78511301977596 * sp[31] + -11.78511301977585 * sp[32] + -11.78511301977586 * sp[27] + -9.428090415820922 * sp[30];
    A[195] = -16.88749537379672 * sp[33] + -5.196152422706717 * sp[34] + 5.196152422706671 * sp[28] + 5.196152422706609 * sp[31] + -7.361215932167812 * sp[34] + -6.278684177437309 * sp[35] + 11.90784930203618 * sp[29] + 5.196152422706644 * sp[32] + -7.361215932167779 * sp[28] + 4.979646071760509 * sp[29] + -21.86714144555718 * sp[26] + -1.732050807568871 * sp[27] + 3.897114317029949 * sp[31] + 3.89711431702992 * sp[32] + -15.15544456622757 * sp[27] + -3.897114317029871 * sp[30];
    A[196] = 7.794228634060035 * sp[33] + -2.598076211353278 * sp[34] + 2.598076211353342 * sp[28] + 2.598076211353396 * sp[31] + 1.732050807568901 * sp[34] + -0.4330127018921193 * sp[35] + -2.165063509461162 * sp[29] + 2.598076211353418 * sp[32] + 1.732050807568897 * sp[28] + -5.62916512459878 * sp[29] + 13.42339375865889 * sp[26] + -0.8660254037845947 * sp[27] + -3.464101615137752 * sp[31] + -3.464101615137697 * sp[32] + 8.66025403784437 * sp[27] + -5.196152422706586 * sp[30];
    A[197] = -3.897114317030026 * sp[33] + -5.19615242270668 * sp[34] + 5.196152422706664 * sp[28] + 5.196152422706634 * sp[31] + -3.031088913245571 * sp[34] + -4.113620667976146 * sp[35] + 5.412658773652798 * sp[29] + 5.196152422706609 * sp[32] + -3.031088913245572 * sp[28] + -1.515544456622859 * sp[29] + -2.38156986040721 * sp[26] + -1.732050807568794 * sp[27] + -0.433012701892236 * sp[31] + -0.4330127018922487 * sp[32] + -2.16506350946108 * sp[27] + 0.433012701892189 * sp[30];
    A[198] = 16.8874953737967 * sp[33] + 11.69134295109002 * sp[34] + 22.08364779650332 * sp[28] + 11.69134295109003 * sp[31] + 9.526279441628919 * sp[34] + 10.60881119635948 * sp[35] + 2.814582562299464 * sp[29] + 3.897114317030041 * sp[32] + 9.526279441628887 * sp[28] + -0.6495190528382979 * sp[29] + 36.58957330989249 * sp[26] + 19.48557158514984 * sp[27] + -1.732050807568832 * sp[31] + -1.732050807568833 * sp[32] + -1.732050807568837 * sp[27] + 0.4330127018922245 * sp[30];
    A[199] = -7.794228634060028 * sp[33] + -10.39230484541334 * sp[34] + -5.19615242270665 * sp[28] + -10.39230484541326 * sp[31] + -6.062177826491139 * sp[34] + -8.22724133595225 * sp[35] + -1.299038105676669 * sp[29] + -3.464101615137748 * sp[32] + -6.062177826491117 * sp[28] + -3.031088913245624 * sp[29] + -16.8874953737965 * sp[26] + -17.32050807568873 * sp[27] + -0.8660254037844728 * sp[31] + -0.8660254037844695 * sp[32] + -0.8660254037844812 * sp[27] + 3.464101615137751 * sp[30];
    A[200] = 3.897114317030028 * sp[33] + -1.299038105676623 * sp[34] + 9.093266739736672 * sp[28] + -1.299038105676627 * sp[31] + 0.8660254037844569 * sp[34] + -0.2165063509460352 * sp[35] + 0.6495190528383221 * sp[29] + -0.4330127018921643 * sp[32] + 0.8660254037844479 * sp[28] + -2.814582562299348 * sp[29] + 8.443747686898295 * sp[26] + -2.165063509461028 * sp[27] + -1.732050807568881 * sp[31] + -1.732050807568834 * sp[32] + -1.732050807568856 * sp[27] + -3.897114317029977 * sp[30];
    A[201] = 10.39230484541327 * sp[33] + 11.69134295108994 * sp[34] + 11.69134295109 * sp[28] + 11.69134295108996 * sp[31] + 7.361215932167778 * sp[34] + 6.062177826491043 * sp[35] + 12.99038105676669 * sp[29] + 11.69134295108997 * sp[32] + 7.361215932167615 * sp[28] + 12.99038105676647 * sp[29] + -7.794228634059955 * sp[26] + -3.897114317029988 * sp[27] + -6.4951905283832 * sp[31] + -8.227241335952119 * sp[32] + -6.495190528383207 * sp[27] + -6.062177826490993 * sp[30];
    A[202] = -20.78460969082662 * sp[33] + -10.39230484541328 * sp[34] + -10.39230484541332 * sp[28] + -10.39230484541325 * sp[31] + -10.39230484541337 * sp[34] + -3.464101615137769 * sp[35] + -17.32050807568894 * sp[29] + -10.3923048454133 * sp[32] + -10.39230484541312 * sp[28] + -17.32050807568871 * sp[29] + 24.24871130596434 * sp[26] + 3.464101615137789 * sp[27] + 17.32050807568862 * sp[31] + 3.464101615137628 * sp[32] + 17.3205080756886 * sp[27] + 7.794228634059776 * sp[30];
    A[203] = 10.39230484541332 * sp[33] + -1.299038105676705 * sp[34] + -1.299038105676686 * sp[28] + -1.299038105676736 * sp[31] + 3.031088913245591 * sp[34] + -2.598076211353372 * sp[35] + 4.330127018922257 * sp[29] + -1.299038105676736 * sp[32] + 3.031088913245481 * sp[28] + 4.330127018922319 * sp[29] + -16.45448267190441 * sp[26] + 0.4330127018923267 * sp[27] + -10.82531754730542 * sp[31] + 4.76313972081438 * sp[32] + -10.82531754730542 * sp[27] + 2.598076211353331 * sp[30];
    A[204] = -36.74234614174799 * sp[33] + -36.74234614174782 * sp[34] + 36.74234614174793 * sp[28] + 36.74234614174789 * sp[31] + -24.49489742783205 * sp[34] + -30.61862178478971 * sp[35] + 42.86607049870594 * sp[29] + 36.74234614174809 * sp[32] + -24.49489742783193 * sp[28] + -6.123724356958281 * sp[29] + -30.61862178478974 * sp[26] + -12.24744871391641 * sp[27] + -24.49489742783141 * sp[27] + -36.74234614174708 * sp[30];
    A[205] = -67.50000000000082 * sp[33] + 90.0000000000006 * sp[28] + 90.00000000000047 * sp[31] + 7.499999999999979 * sp[34] + 3.749999999999925 * sp[35] + 93.75000000000072 * sp[29] + 90.00000000000071 * sp[32] + 7.499999999998909 * sp[28] + 48.7499999999989 * sp[29] + -41.25000000000001 * sp[26] + -30.00000000000074 * sp[27] + 52.50000000000041 * sp[31] + -22.49999999999951 * sp[32] + -37.49999999999941 * sp[27] + -67.49999999999909 * sp[30];
    A[206] = 12.99038105676664 * sp[33] + -25.98076211353341 * sp[34] + 25.98076211353339 * sp[28] + 25.98076211353328 * sp[31] + -4.330127018922234 * sp[34] + 10.8253175473055 * sp[35] + 10.82531754730559 * sp[29] + 25.980762113533 * sp[32] + -4.330127018922373 * sp[28] + 2.165063509460595 * sp[29] + 36.80607966083888 * sp[26] + -8.660254037843824 * sp[27] + -12.99038105676665 * sp[31] + 12.99038105676663 * sp[32] + 21.65063509461081 * sp[27] + 12.99038105676605 * sp[30];
    A[207] = 36.74234614174777 * sp[34] + -110.2270384252438 * sp[28] + -36.74234614174807 * sp[31] + 12.24744871391601 * sp[34] + 24.49489742783174 * sp[35] + -48.98979485566402 * sp[29] + -36.74234614174827 * sp[32] + 12.24744871391598 * sp[28] + 24.49489742783184 * sp[29] + -48.98979485566366 * sp[26] + 12.24744871391595 * sp[27] + 12.24744871391597 * sp[31] + 12.24744871391583 * sp[32] + 36.7423461417473 * sp[27] + 24.49489742783142 * sp[30];
    A[208] = 135.0000000000012 * sp[33] + 67.5000000000006 * sp[34] + 67.50000000000034 * sp[28] + -22.49999999999974 * sp[31] + 67.5000000000006 * sp[34] + 67.50000000000078 * sp[35] + -22.50000000000007 * sp[29] + -22.49999999999967 * sp[32] + 67.50000000000034 * sp[28] + -22.50000000000007 * sp[29] + 247.4999999999995 * sp[26] + 67.50000000000007 * sp[27] + -22.49999999999974 * sp[31] + -22.49999999999967 * sp[32] + 67.50000000000007 * sp[27] + 59.99999999999967 * sp[30];
    A[209] = 64.95190528383306 * sp[34] + -38.97114317030012 * sp[28] + 12.99038105676639 * sp[31] + 21.65063509461117 * sp[34] + 43.30127018922183 * sp[35] + -8.660254037844329 * sp[29] + 12.99038105676665 * sp[32] + 21.65063509461116 * sp[28] + 43.30127018922204 * sp[29] + -8.660254037844869 * sp[26] + 99.59292143520952 * sp[27] + 21.65063509461113 * sp[31] + 21.65063509461084 * sp[32] + -12.99038105676648 * sp[27] + 43.30127018922263 * sp[30];
    A[210] = 10.41666666666664 * sp[33] + -5.833333333333348 * sp[34] + 0.8333333333333364 * sp[28] + 0.8333333333334114 * sp[31] + -2.9166666666667 * sp[34] + -4.375000000000016 * sp[35] + -3.54166666666673 * sp[29] + 0.8333333333333401 * sp[32] + 10.08333333333336 * sp[28] + -2.874999999999998 * sp[29] + 7.958333333333428 * sp[26] + 1.833333333333376 * sp[27] + -1.416666666666661 * sp[31] + -1.416666666666779 * sp[32] + 3.583333333333326 * sp[27] + 2.916666666666631 * sp[30];
    A[211] = -20.83333333333338 * sp[33] + 15.83333333333333 * sp[34] + -5.833333333333369 * sp[28] + -5.833333333333504 * sp[31] + -6.666666666666687 * sp[34] + 4.583333333333404 * sp[35] + 2.916666666666678 * sp[29] + -5.833333333333437 * sp[32] + -12.66666666666668 * sp[28] + 11.58333333333331 * sp[29] + -10.08333333333344 * sp[26] + 2.166666666666594 * sp[27] + 0.333333333333355 * sp[31] + 0.3333333333335782 * sp[32] + -1.33333333333336 * sp[27] + 13.33333333333326 * sp[30];
    A[212] = -10.41666666666672 * sp[33] + -30.8333333333334 * sp[34] + 9.166666666666741 * sp[28] + 9.166666666666771 * sp[31] + -7.083333333333385 * sp[34] + -18.95833333333344 * sp[35] + 6.875000000000022 * sp[29] + 9.166666666666739 * sp[32] + -4.083333333333325 * sp[28] + -12.45833333333331 * sp[29] + 3.375000000000048 * sp[26] + 0.1666666666666927 * sp[27] + -0.5833333333333133 * sp[31] + -0.5833333333334167 * sp[32] + 1.083333333333318 * sp[27] + -12.91666666666671 * sp[30];
    A[213] = 10.41666666666676 * sp[33] + 16.25000000000007 * sp[34] + 9.583333333333377 * sp[28] + 16.25000000000001 * sp[31] + 13.33333333333342 * sp[34] + 14.7916666666667 * sp[35] + 8.958333333333456 * sp[29] + 10.41666666666671 * sp[32] + 0.3333333333333157 * sp[28] + 3.291666666666667 * sp[29] + 7.45833333333325 * sp[26] + 9.416666666666622 * sp[27] + 1.833333333333294 * sp[31] + 1.833333333333335 * sp[32] + 1.833333333333268 * sp[27] + 2.916666666666636 * sp[30];
    A[214] = -20.83333333333344 * sp[33] + -36.66666666666676 * sp[34] + -14.99999999999998 * sp[28] + -36.66666666666671 * sp[31] + -14.16666666666676 * sp[34] + -25.41666666666676 * sp[35] + -5.416666666666702 * sp[29] + -16.66666666666681 * sp[32] + -8.166666666666652 * sp[28] + -12.41666666666664 * sp[29] + -12.4166666666666 * sp[26] + -24.66666666666662 * sp[27] + -1.16666666666663 * sp[31] + -1.1666666666667 * sp[32] + -1.166666666666599 * sp[27] + 10.00000000000006 * sp[30];
    A[215] = -10.41666666666667 * sp[33] + 20.41666666666669 * sp[34] + -19.58333333333338 * sp[28] + 20.41666666666675 * sp[31] + -3.333333333333334 * sp[34] + 8.541666666666758 * sp[35] + -5.625000000000006 * sp[29] + 6.250000000000163 * sp[32] + -6.333333333333336 * sp[28] + 12.04166666666664 * sp[29] + -12.12500000000005 * sp[26] + 15.25 * sp[27] + 0.1666666666666725 * sp[31] + 0.1666666666668597 * sp[32] + 0.1666666666666674 * sp[27] + -12.91666666666646 * sp[30];
    A[216] = 4.166666666666639 * sp[33] + 7.083333333333309 * sp[34] + 7.083333333333401 * sp[28] + 7.083333333333385 * sp[31] + 0.4166666666666199 * sp[34] + -0.416666666666619 * sp[35] + 7.916666666666657 * sp[29] + 7.083333333333349 * sp[32] + 8.416666666666664 * sp[28] + 13.58333333333328 * sp[29] + 1.916666666666709 * sp[26] + 3.083333333333335 * sp[27] + 2.749999999999932 * sp[31] + -8.916666666666917 * sp[32] + 2.749999999999953 * sp[27] + -3.333333333333479 * sp[30];
    A[217] = -1.666666666666708 * sp[34] + -1.666666666666686 * sp[28] + -1.666666666666732 * sp[31] + 3.333333333333328 * sp[34] + 0.8333333333333188 * sp[35] + 0.8333333333334036 * sp[29] + -1.666666666666657 * sp[32] + -12.66666666666669 * sp[28] + -7.166666666666657 * sp[29] + -7.166666666666755 * sp[26] + -3.666666666666689 * sp[27] + -4.666666666666618 * sp[31] + -7.999999999999886 * sp[32] + -4.66666666666663 * sp[27] + -5.833333333333192 * sp[30];
    A[218] = -4.166666666666635 * sp[33] + 2.916666666666892 * sp[34] + 2.916666666666688 * sp[28] + 2.916666666666812 * sp[31] + -3.749999999999951 * sp[34] + 3.750000000000144 * sp[35] + -4.583333333333361 * sp[29] + 2.916666666666741 * sp[32] + 4.250000000000033 * sp[28] + -2.249999999999912 * sp[29] + 9.416666666666766 * sp[26] + -1.083333333333272 * sp[27] + 1.916666666666675 * sp[31] + -13.08333333333323 * sp[32] + 1.916666666666677 * sp[27] + -6.666666666666644 * sp[30];
    A[219] = -58.9255650988793 * sp[33] + -82.49579113843124 * sp[34] + -11.78511301977586 * sp[28] + -11.78511301977611 * sp[31] + -47.14045207910345 * sp[34] + -64.81812160876747 * sp[35] + 5.892556509887703 * sp[29] + -11.78511301977613 * sp[32] + -18.85618083164124 * sp[28] + -22.39171473757413 * sp[29] + -8.24957911384308 * sp[26] + 16.49915822768599 * sp[27] + -4.714045207910225 * sp[31] + 80.1387685344756 * sp[32] + 9.428090415820476 * sp[27] + 54.21151989096813 * sp[30];
    A[220] = 50.5181485540917 * sp[33] + 14.43375672973968 * sp[34] + 14.43375672974081 * sp[28] + 14.43375672974031 * sp[31] + -7.216878364871604 * sp[34] + -39.69283100678734 * sp[35] + 46.90970937165682 * sp[29] + 14.43375672974021 * sp[32] + 44.74464586219597 * sp[28] + 72.89047148518972 * sp[29] + -13.71206889325355 * sp[26] + 31.7542648054292 * sp[27] + 105.3664241271057 * sp[31] + 62.0651539378833 * sp[32] + 18.76388374866246 * sp[27] + 50.51814855409111 * sp[30];
    A[221] = -104.166666666667 * sp[33] + -33.33333333333302 * sp[34] + 66.66666666666718 * sp[28] + 66.6666666666673 * sp[31] + -45.83333333333361 * sp[34] + -39.58333333333348 * sp[35] + 60.41666666666701 * sp[29] + 66.66666666666723 * sp[32] + -55.83333333333337 * sp[28] + 5.416666666666899 * sp[29] + 5.416666666666727 * sp[26] + -3.333333333333199 * sp[27] + -0.8333333333331991 * sp[31] + -25.83333333333391 * sp[32] + -0.8333333333334121 * sp[27] + -104.1666666666669 * sp[30];
    A[222] = 117.8511301977584 * sp[33] + 58.92556509887923 * sp[34] + 58.92556509887883 * sp[28] + -11.78511301977596 * sp[31] + 58.92556509887928 * sp[34] + 58.92556509887905 * sp[35] + -11.78511301977595 * sp[29] + -11.78511301977585 * sp[32] + 58.92556509887898 * sp[28] + 2.357022603955117 * sp[29] + 44.78342947514814 * sp[26] + -11.78511301977586 * sp[27] + 2.357022603954976 * sp[31] + 2.357022603954542 * sp[32] + -11.78511301977571 * sp[27] + -9.428090415820922 * sp[30];
    A[223] = 21.65063509461117 * sp[34] + 21.65063509461116 * sp[28] + 21.65063509461113 * sp[31] + 64.95190528383306 * sp[34] + 43.30127018922183 * sp[35] + 43.30127018922204 * sp[29] + 21.65063509461084 * sp[32] + -38.97114317030012 * sp[28] + -8.660254037844329 * sp[29] + -8.660254037844869 * sp[26] + -12.99038105676648 * sp[27] + 12.99038105676639 * sp[31] + 12.99038105676665 * sp[32] + 99.59292143520952 * sp[27] + 43.30127018922263 * sp[30];
    A[224] = 208.333333333334 * sp[33] + 104.1666666666672 * sp[34] + 104.1666666666667 * sp[28] + 4.166666666666369 * sp[31] + 104.1666666666672 * sp[34] + 104.1666666666668 * sp[35] + 4.166666666666686 * sp[29] + 4.166666666665584 * sp[32] + 104.1666666666667 * sp[28] + 4.166666666666686 * sp[29] + 104.1666666666668 * sp[26] + 4.166666666666586 * sp[27] + 4.166666666666369 * sp[31] + 4.166666666665584 * sp[32] + 4.166666666666586 * sp[27] + 183.3333333333318 * sp[30];
  }

};


class forms_cell_integral_1_otherwise: public ufc::cell_integral
{
public:

  forms_cell_integral_1_otherwise() : ufc::cell_integral()
  {

  }

  ~forms_cell_integral_1_otherwise() override
  {

  }

  const std::vector<bool> & enabled_coefficients() const final override
  {
static const std::vector<bool> enabled({});
return enabled;
  }

  void tabulate_tensor(double * A,
                       const double * const * w,
                       const double * coordinate_dofs,
                       int cell_orientation) const final override
  {
    // This function was generated using 'uflacs' representation
    // with the following integrals metadata:
    // 
    // num_cells:         None
    // optimize:          True
    // precision:         16
    // quadrature_degree: 6
    // quadrature_rule:   'default'
    // representation:    'uflacs'
    // 
    // and the following integral 0 metadata:
    // 
    // estimated_polynomial_degree: 6
    // optimize:                    True
    // precision:                   16
    // quadrature_degree:           6
    // quadrature_rule:             'default'
    // representation:              'uflacs'
    // Precomputed values of basis functions and precomputations
    // FE* dimensions: [entities][points][dofs]
    // PI* dimensions: [entities][dofs][dofs] or [entities][dofs]
    // PM* dimensions: [entities][dofs][dofs]
    alignas(32) static const double FE3_C0_D01_Q12[1][1][2] = { { { -1.0, 1.0 } } };
    // Unstructured piecewise computations
    const double J_c0 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[2] * FE3_C0_D01_Q12[0][0][1];
    const double J_c3 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[5] * FE3_C0_D01_Q12[0][0][1];
    const double J_c1 = coordinate_dofs[0] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[4] * FE3_C0_D01_Q12[0][0][1];
    const double J_c2 = coordinate_dofs[1] * FE3_C0_D01_Q12[0][0][0] + coordinate_dofs[3] * FE3_C0_D01_Q12[0][0][1];
    alignas(32) double sp[20];
    sp[0] = J_c0 * J_c3;
    sp[1] = J_c1 * J_c2;
    sp[2] = sp[0] + -1 * sp[1];
    sp[3] = J_c0 / sp[2];
    sp[4] = -1 * J_c1 / sp[2];
    sp[5] = sp[3] * sp[3];
    sp[6] = sp[3] * sp[4];
    sp[7] = sp[4] * sp[4];
    sp[8] = J_c3 / sp[2];
    sp[9] = -1 * J_c2 / sp[2];
    sp[10] = sp[9] * sp[9];
    sp[11] = sp[8] * sp[9];
    sp[12] = sp[8] * sp[8];
    sp[13] = sp[5] + sp[10];
    sp[14] = sp[6] + sp[11];
    sp[15] = sp[12] + sp[7];
    sp[16] = std::abs(sp[2]);
    sp[17] = sp[13] * sp[16];
    sp[18] = sp[14] * sp[16];
    sp[19] = sp[15] * sp[16];
    A[0] = 0.02162698412698436 * sp[19] + -0.01116071428571436 * sp[18] + -0.01116071428571436 * sp[18] + 0.05734126984127025 * sp[17];
    A[1] = -0.02986111111111122 * sp[19] + 0.005952380952380894 * sp[18] + 0.009920634920634996 * sp[18] + -0.04871031746031778 * sp[17];
    A[2] = 0.01765873015873009 * sp[19] + -0.004712301587301553 * sp[18] + -0.004712301587301597 * sp[18] + 0.01765873015873018 * sp[17];
    A[3] = -0.01542658730158742 * sp[19] + -0.02447916666666682 * sp[18] + 0.009052579365079381 * sp[18] + 0.01860119047619061 * sp[17];
    A[4] = 0.01746031746031739 * sp[19] + 0.02167658730158716 * sp[18] + -0.005704365079365073 * sp[18] + -0.01190476190476183 * sp[17];
    A[5] = -0.023859126984127 * sp[19] + -0.03266369047619055 * sp[18] + 0.006820436507936572 * sp[18] + 0.01116071428571413 * sp[17];
    A[6] = -0.01314484126984126 * sp[19] + -0.008804563492063541 * sp[18] + 0.03067956349206358 * sp[18] + 0.02385912698412706 * sp[17];
    A[7] = 0.02777777777777798 * sp[19] + 0.01413690476190485 * sp[18] + -0.07276785714285765 * sp[18] + -0.06111111111111146 * sp[17];
    A[8] = -0.02058531746031759 * sp[19] + -0.00706845238095235 * sp[18] + 0.05820932539682561 * sp[18] + 0.05114087301587333 * sp[17];
    A[9] = 0.0434926790015511 * sp[19] + -0.02314932914598866 * sp[18] + -0.06243303921190629 * sp[18] + 0.03507474113028561 * sp[17];
    A[10] = 0.06529556615835218 * sp[19] + -0.05154913117764592 * sp[18] + -0.1271545235715237 * sp[18] + 0.06529556615835092 * sp[17];
    A[11] = -0.01686507936508149 * sp[19] + -0.007440476190475868 * sp[18] + 0.07192460317460266 * sp[18] + -0.01091269841269919 * sp[17];
    A[12] = 0.03507474113028572 * sp[19] + 0.1283735525368425 * sp[18] + -0.01192541198429712 * sp[18] + -0.1248660784238148 * sp[17];
    A[13] = -0.1005208057964096 * sp[19] + -0.06314768569261567 * sp[18] + 0.07088005536926238 * sp[18] + -0.08505606644311357 * sp[17];
    A[14] = 0.06200396825396934 * sp[19] + 0.0959821428571416 * sp[18] + -0.02108134920634964 * sp[18] + 0.05307539682539855 * sp[17];
    A[15] = -0.02986111111111122 * sp[19] + 0.009920634920634996 * sp[18] + 0.005952380952380894 * sp[18] + -0.04871031746031778 * sp[17];
    A[16] = 0.06865079365079393 * sp[19] + -0.01289682539682547 * sp[18] + -0.01289682539682547 * sp[18] + 0.06865079365079435 * sp[17];
    A[17] = -0.04871031746031753 * sp[19] + 0.005952380952380871 * sp[18] + 0.00992063492063496 * sp[18] + -0.02986111111111135 * sp[17];
    A[18] = 0.01746031746031739 * sp[19] + 0.0231646825396825 * sp[18] + -0.004216269841269739 * sp[18] + -0.01041666666666662 * sp[17];
    A[19] = -0.04384920634920632 * sp[19] + -0.05327380952380961 * sp[18] + 0.009424603174603165 * sp[18] + 0.01785714285714278 * sp[17];
    A[20] = 0.06111111111111132 * sp[19] + 0.07524801587301626 * sp[18] + -0.01165674603174612 * sp[18] + -0.02529761904761907 * sp[17];
    A[21] = 0.01041666666666664 * sp[19] + 0.00421626984126975 * sp[18] + -0.02316468253968253 * sp[18] + -0.01746031746031746 * sp[17];
    A[22] = -0.01785714285714293 * sp[19] + -0.009424603174603211 * sp[18] + 0.05327380952380983 * sp[18] + 0.04384920634920651 * sp[17];
    A[23] = 0.02529761904761929 * sp[19] + 0.01165674603174612 * sp[18] + -0.07524801587301651 * sp[18] + -0.06111111111111167 * sp[17];
    A[24] = -0.07856742013183733 * sp[19] + -0.009820927516479826 * sp[18] + 0.1360899955855054 * sp[18] + 0.0701494822605714 * sp[17];
    A[25] = -0.05326743555023483 * sp[19] + -0.008591521862941409 * sp[18] + 0.1838585678669349 * sp[18] + 0.08419691425682245 * sp[17];
    A[26] = -0.004960317460314207 * sp[19] + 0.01984126984126924 * sp[18] + -0.1626984126984121 * sp[18] + -0.1021825396825408 * sp[17];
    A[27] = -0.07014948226057138 * sp[19] + -0.1360899955855055 * sp[18] + 0.009820927516479972 * sp[18] + 0.07856742013183694 * sp[17];
    A[28] = 0.04639421805988047 * sp[19] + 0.04897167461876199 * sp[18] + -0.0128872827944105 * sp[18] + 0.03092947870658581 * sp[17];
    A[29] = -0.1240079365079385 * sp[19] + -0.2405753968253958 * sp[18] + 0.01736111111111149 * sp[18] + 0.04365079365079517 * sp[17];
    A[30] = 0.01765873015873009 * sp[19] + -0.004712301587301597 * sp[18] + -0.004712301587301553 * sp[18] + 0.01765873015873018 * sp[17];
    A[31] = -0.04871031746031753 * sp[19] + 0.00992063492063496 * sp[18] + 0.005952380952380871 * sp[18] + -0.02986111111111135 * sp[17];
    A[32] = 0.05734126984127015 * sp[19] + -0.01116071428571431 * sp[18] + -0.01116071428571431 * sp[18] + 0.02162698412698437 * sp[17];
    A[33] = -0.02385912698412707 * sp[19] + -0.03067956349206367 * sp[18] + 0.008804563492063527 * sp[18] + 0.01314484126984127 * sp[17];
    A[34] = 0.06111111111111148 * sp[19] + 0.07276785714285772 * sp[18] + -0.01413690476190483 * sp[18] + -0.02777777777777791 * sp[17];
    A[35] = -0.05114087301587318 * sp[19] + -0.05820932539682563 * sp[18] + 0.007068452380952337 * sp[18] + 0.02058531746031751 * sp[17];
    A[36] = -0.01860119047619067 * sp[19] + -0.009052579365079385 * sp[18] + 0.02447916666666683 * sp[18] + 0.01542658730158744 * sp[17];
    A[37] = 0.01190476190476198 * sp[19] + 0.005704365079365094 * sp[18] + -0.02167658730158729 * sp[18] + -0.01746031746031747 * sp[17];
    A[38] = -0.01116071428571434 * sp[19] + -0.006820436507936545 * sp[18] + 0.03266369047619068 * sp[18] + 0.02385912698412714 * sp[17];
    A[39] = 0.1248660784238152 * sp[19] + 0.01192541198429698 * sp[18] + -0.1283735525368424 * sp[18] + -0.03507474113028572 * sp[17];
    A[40] = -0.003436608745177525 * sp[19] + -0.01718304372588166 * sp[18] + -0.05154913117764447 * sp[18] + -0.003436608745176629 * sp[17];
    A[41] = 0.1001984126984119 * sp[19] + -0.07192460317460353 * sp[18] + 0.1026785714285715 * sp[18] + 0.1180555555555574 * sp[17];
    A[42] = -0.03507474113028568 * sp[19] + 0.06243303921190646 * sp[18] + 0.02314932914598859 * sp[18] + -0.04349267900155104 * sp[17];
    A[43] = -0.02319710902993974 * sp[19] + 0.001288728279441005 * sp[18] + 0.03221820698602823 * sp[18] + -0.01804219591217503 * sp[17];
    A[44] = -0.06200396825396937 * sp[19] + 0.1460813492063475 * sp[18] + 0.04092261904761974 * sp[18] + -0.06498015873016047 * sp[17];
    A[45] = -0.01542658730158742 * sp[19] + 0.009052579365079381 * sp[18] + -0.02447916666666682 * sp[18] + 0.01860119047619061 * sp[17];
    A[46] = 0.01746031746031739 * sp[19] + -0.004216269841269739 * sp[18] + 0.0231646825396825 * sp[18] + -0.01041666666666662 * sp[17];
    A[47] = -0.02385912698412707 * sp[19] + 0.008804563492063527 * sp[18] + -0.03067956349206367 * sp[18] + 0.01314484126984127 * sp[17];
    A[48] = 0.02162698412698436 * sp[19] + 0.03278769841269873 * sp[18] + 0.03278769841269873 * sp[18] + 0.1012896825396833 * sp[17];
    A[49] = -0.02986111111111129 * sp[19] + -0.03581349206349222 * sp[18] + -0.03978174603174631 * sp[18] + -0.09444444444444484 * sp[17];
    A[50] = 0.01765873015873012 * sp[19] + 0.02237103174603169 * sp[18] + 0.02237103174603174 * sp[18] + 0.04474206349206337 * sp[17];
    A[51] = 0.02058531746031757 * sp[19] + 0.0135168650793652 * sp[18] + 0.07879464285714319 * sp[18] + 0.02058531746031758 * sp[17];
    A[52] = -0.02777777777777797 * sp[19] + -0.01364087301587308 * sp[18] + -0.1005456349206356 * sp[18] + -0.02529761904761922 * sp[17];
    A[53] = 0.01314484126984125 * sp[19] + 0.004340277777777688 * sp[18] + 0.04382440476190485 * sp[18] + 0.01116071428571427 * sp[17];
    A[54] = -0.07856742013183693 * sp[19] + 0.02665680325901718 * sp[18] + -0.152925871328041 * sp[18] + 0.04208968935634286 * sp[17];
    A[55] = -0.03522523963805742 * sp[19] + 0.07947157723220412 * sp[18] + 0.02104922856420371 * sp[18] + 0.1159855451497029 * sp[17];
    A[56] = -0.04513888888888826 * sp[19] + 0.04340277777777812 * sp[18] + 0.005704365079364507 * sp[18] + 0.05208333333333313 * sp[17];
    A[57] = 0.03507474113028568 * sp[19] + -0.09329881140655687 * sp[18] + 0.04700015311458285 * sp[18] + -0.206239477846075 * sp[17];
    A[58] = 0.1005208057964095 * sp[19] + 0.03737312010379384 * sp[18] + 0.1714008611656717 * sp[18] + 0.1933092419161695 * sp[17];
    A[59] = 0.06200396825396928 * sp[19] + -0.03397817460317271 * sp[18] + 0.08308531746031896 * sp[18] + 0.04017857142857482 * sp[17];
    A[60] = 0.01746031746031739 * sp[19] + -0.005704365079365073 * sp[18] + 0.02167658730158716 * sp[18] + -0.01190476190476183 * sp[17];
    A[61] = -0.04384920634920632 * sp[19] + 0.009424603174603165 * sp[18] + -0.05327380952380961 * sp[18] + 0.01785714285714278 * sp[17];
    A[62] = 0.06111111111111148 * sp[19] + -0.01413690476190483 * sp[18] + 0.07276785714285772 * sp[18] + -0.02777777777777791 * sp[17];
    A[63] = -0.02986111111111129 * sp[19] + -0.03978174603174631 * sp[18] + -0.03581349206349222 * sp[18] + -0.09444444444444484 * sp[17];
    A[64] = 0.06865079365079411 * sp[19] + 0.08154761904761972 * sp[18] + 0.08154761904761972 * sp[18] + 0.1630952380952394 * sp[17];
    A[65] = -0.04871031746031758 * sp[19] + -0.05466269841269857 * sp[18] + -0.05863095238095264 * sp[18] + -0.0944444444444449 * sp[17];
    A[66] = -0.0252976190476193 * sp[19] + -0.0136408730158731 * sp[18] + -0.1005456349206356 * sp[18] + -0.02777777777777796 * sp[17];
    A[67] = 0.01785714285714295 * sp[19] + 0.008432539682539706 * sp[18] + 0.07113095238095248 * sp[18] + 0.01785714285714285 * sp[17];
    A[68] = -0.01041666666666665 * sp[19] + -0.006200396825396813 * sp[18] + -0.03358134920634901 * sp[18] + -0.01190476190476181 * sp[17];
    A[69] = 0.148716902392409 * sp[19] + 0.002805979290422705 * sp[18] + 0.2946278254943951 * sp[18];
    A[70] = -0.006873217490354647 * sp[19] + -0.04725337024617517 * sp[18] + -0.1778445025628795 * sp[18] + -0.1030982623552913 * sp[17];
    A[71] = 0.1289682539682536 * sp[19] + -0.09176587301587366 * sp[18] + -0.01636904761904653 * sp[18] + -0.17857142857143 * sp[17];
    A[72] = -0.07014948226057137 * sp[19] + 0.0659405133249344 * sp[18] + -0.07997040977705136 * sp[18] + 0.1346870059402919 * sp[17];
    A[73] = -0.04639421805988043 * sp[19] + 0.002577456558881445 * sp[18] + -0.05928150085429063 * sp[18] + -0.04123930494211479 * sp[17];
    A[74] = -0.1240079365079386 * sp[19] + 0.116567460317458 * sp[18] + -0.1413690476190501 * sp[18] + 0.1428571428571429 * sp[17];
    A[75] = -0.023859126984127 * sp[19] + 0.006820436507936572 * sp[18] + -0.03266369047619055 * sp[18] + 0.01116071428571413 * sp[17];
    A[76] = 0.06111111111111132 * sp[19] + -0.01165674603174612 * sp[18] + 0.07524801587301626 * sp[18] + -0.02529761904761907 * sp[17];
    A[77] = -0.05114087301587318 * sp[19] + 0.007068452380952337 * sp[18] + -0.05820932539682563 * sp[18] + 0.02058531746031751 * sp[17];
    A[78] = 0.01765873015873012 * sp[19] + 0.02237103174603174 * sp[18] + 0.02237103174603169 * sp[18] + 0.04474206349206337 * sp[17];
    A[79] = -0.04871031746031758 * sp[19] + -0.05863095238095264 * sp[18] + -0.05466269841269857 * sp[18] + -0.0944444444444449 * sp[17];
    A[80] = 0.05734126984127005 * sp[19] + 0.06850198412698449 * sp[18] + 0.06850198412698449 * sp[18] + 0.1012896825396832 * sp[17];
    A[81] = 0.01116071428571432 * sp[19] + 0.004340277777777715 * sp[18] + 0.04382440476190488 * sp[18] + 0.01314484126984122 * sp[17];
    A[82] = -0.01190476190476196 * sp[19] + -0.006200396825396858 * sp[18] + -0.03358134920634893 * sp[18] + -0.01041666666666648 * sp[17];
    A[83] = 0.01860119047619066 * sp[19] + 0.009548611111111204 * sp[18] + 0.04308035714285727 * sp[18] + 0.01860119047619045 * sp[17];
    A[84] = -0.08979133729352942 * sp[19] + -0.01543288609732552 * sp[18] + -0.1950155606843834 * sp[18] + -0.04208968935634268 * sp[17];
    A[85] = -0.02663371777511744 * sp[19] + -0.0107394023286766 * sp[18] + -0.007302793583500347 * sp[18] + -0.0128872827944121 * sp[17];
    A[86] = -0.03819444444444232 * sp[19] + 0.03596230158730127 * sp[18] + 0.1054067460317484 * sp[18] + 0.1264880952380963 * sp[17];
    A[87] = -0.03507474113028566 * sp[19] + -0.09750778034219193 * sp[18] + -0.05822407027627422 * sp[18] + -0.1641497884897313 * sp[17];
    A[88] = 0.02319710902993976 * sp[19] + 0.02448583730938047 * sp[18] + 0.05541531601596771 * sp[18] + 0.07474624020758401 * sp[17];
    A[89] = -0.06200396825396916 * sp[19] + -0.2080853174603164 * sp[18] + -0.1029265873015889 * sp[18] + -0.3139880952380976 * sp[17];
    A[90] = -0.01314484126984126 * sp[19] + 0.03067956349206358 * sp[18] + -0.008804563492063541 * sp[18] + 0.02385912698412706 * sp[17];
    A[91] = 0.01041666666666664 * sp[19] + -0.02316468253968253 * sp[18] + 0.00421626984126975 * sp[18] + -0.01746031746031746 * sp[17];
    A[92] = -0.01860119047619067 * sp[19] + 0.02447916666666683 * sp[18] + -0.009052579365079385 * sp[18] + 0.01542658730158744 * sp[17];
    A[93] = 0.02058531746031757 * sp[19] + 0.07879464285714319 * sp[18] + 0.0135168650793652 * sp[18] + 0.02058531746031758 * sp[17];
    A[94] = -0.0252976190476193 * sp[19] + -0.1005456349206356 * sp[18] + -0.0136408730158731 * sp[18] + -0.02777777777777796 * sp[17];
    A[95] = 0.01116071428571432 * sp[19] + 0.04382440476190488 * sp[18] + 0.004340277777777715 * sp[18] + 0.01314484126984122 * sp[17];
    A[96] = 0.1012896825396832 * sp[19] + 0.03278769841269867 * sp[18] + 0.03278769841269867 * sp[18] + 0.02162698412698433 * sp[17];
    A[97] = -0.09444444444444478 * sp[19] + -0.0397817460317462 * sp[18] + -0.03581349206349214 * sp[18] + -0.02986111111111123 * sp[17];
    A[98] = 0.04474206349206336 * sp[19] + 0.02237103174603172 * sp[18] + 0.02237103174603169 * sp[18] + 0.01765873015873013 * sp[17];
    A[99] = -0.2062394778460754 * sp[19] + 0.04700015311458264 * sp[18] + -0.09329881140655695 * sp[18] + 0.03507474113028552 * sp[17];
    A[100] = 0.131450284502998 * sp[19] + 0.1576544261849665 * sp[18] + -0.01073940232867436 * sp[18] + 0.1039574145415857 * sp[17];
    A[101] = 0.1473214285714273 * sp[19] + 0.1068948412698424 * sp[18] + 0.04935515873015893 * sp[18] + 0.05605158730158821 * sp[17];
    A[102] = 0.04208968935634285 * sp[19] + -0.1529258713280406 * sp[18] + 0.02665680325901715 * sp[18] + -0.07856742013183667 * sp[17];
    A[103] = 0.1030982623552902 * sp[19] + 0.01546473935329265 * sp[18] + 0.07732369676646847 * sp[18] + -0.05670404429540918 * sp[17];
    A[104] = 0.07440476190476326 * sp[19] + 0.01537698412698341 * sp[18] + 0.04712301587301668 * sp[18] + -0.007936507936507948 * sp[17];
    A[105] = 0.02777777777777798 * sp[19] + -0.07276785714285765 * sp[18] + 0.01413690476190485 * sp[18] + -0.06111111111111146 * sp[17];
    A[106] = -0.01785714285714293 * sp[19] + 0.05327380952380983 * sp[18] + -0.009424603174603211 * sp[18] + 0.04384920634920651 * sp[17];
    A[107] = 0.01190476190476198 * sp[19] + -0.02167658730158729 * sp[18] + 0.005704365079365094 * sp[18] + -0.01746031746031747 * sp[17];
    A[108] = -0.02777777777777797 * sp[19] + -0.1005456349206356 * sp[18] + -0.01364087301587308 * sp[18] + -0.02529761904761922 * sp[17];
    A[109] = 0.01785714285714295 * sp[19] + 0.07113095238095248 * sp[18] + 0.008432539682539706 * sp[18] + 0.01785714285714285 * sp[17];
    A[110] = -0.01190476190476196 * sp[19] + -0.03358134920634893 * sp[18] + -0.006200396825396858 * sp[18] + -0.01041666666666648 * sp[17];
    A[111] = -0.09444444444444478 * sp[19] + -0.03581349206349214 * sp[18] + -0.0397817460317462 * sp[18] + -0.02986111111111123 * sp[17];
    A[112] = 0.1630952380952392 * sp[19] + 0.08154761904761951 * sp[18] + 0.08154761904761951 * sp[18] + 0.068650793650794 * sp[17];
    A[113] = -0.09444444444444478 * sp[19] + -0.05863095238095269 * sp[18] + -0.05466269841269848 * sp[18] + -0.04871031746031762 * sp[17];
    A[114] = 0.1346870059402923 * sp[19] + -0.07997040977705099 * sp[18] + 0.06594051332493438 * sp[18] + -0.07014948226057105 * sp[17];
    A[115] = 0.1030982623552917 * sp[19] + -0.1520699369740541 * sp[18] + 0.1022391101689944 * sp[18] + -0.1305911323167022 * sp[17];
    A[116] = -0.107142857142856 * sp[19] + 0.01934523809523943 * sp[18] + -0.05605158730158696 * sp[18] + 0.02182539682539753 * sp[17];
    A[117] = 0.2946278254943944 * sp[18] + 0.002805979290422823 * sp[18] + 0.1487169023924081 * sp[17];
    A[118] = -0.2061965247105821 * sp[19] + -0.1030982623552908 * sp[18] + -0.1030982623552909 * sp[18] + 0.1082531754730538 * sp[17];
    A[119] = -0.1458333333333376 * sp[18] + 0.004960317460317583 * sp[18] + -0.07043650793651003 * sp[17];
    A[120] = -0.02058531746031759 * sp[19] + 0.05820932539682561 * sp[18] + -0.00706845238095235 * sp[18] + 0.05114087301587333 * sp[17];
    A[121] = 0.02529761904761929 * sp[19] + -0.07524801587301651 * sp[18] + 0.01165674603174612 * sp[18] + -0.06111111111111167 * sp[17];
    A[122] = -0.01116071428571434 * sp[19] + 0.03266369047619068 * sp[18] + -0.006820436507936545 * sp[18] + 0.02385912698412714 * sp[17];
    A[123] = 0.01314484126984125 * sp[19] + 0.04382440476190485 * sp[18] + 0.004340277777777688 * sp[18] + 0.01116071428571427 * sp[17];
    A[124] = -0.01041666666666665 * sp[19] + -0.03358134920634901 * sp[18] + -0.006200396825396813 * sp[18] + -0.01190476190476181 * sp[17];
    A[125] = 0.01860119047619066 * sp[19] + 0.04308035714285727 * sp[18] + 0.009548611111111204 * sp[18] + 0.01860119047619045 * sp[17];
    A[126] = 0.04474206349206336 * sp[19] + 0.02237103174603169 * sp[18] + 0.02237103174603172 * sp[18] + 0.01765873015873013 * sp[17];
    A[127] = -0.09444444444444478 * sp[19] + -0.05466269841269848 * sp[18] + -0.05863095238095269 * sp[18] + -0.04871031746031762 * sp[17];
    A[128] = 0.1012896825396832 * sp[19] + 0.06850198412698456 * sp[18] + 0.06850198412698456 * sp[18] + 0.0573412698412703 * sp[17];
    A[129] = -0.1641497884897317 * sp[19] + -0.0582240702762745 * sp[18] + -0.09750778034219187 * sp[18] + -0.03507474113028587 * sp[17];
    A[130] = -0.2345485468582882 * sp[19] + -0.06142938132002933 * sp[18] + -0.167964252420494 * sp[18] + -0.04209845712841176 * sp[17];
    A[131] = 0.2217261904761907 * sp[19] + 0.09945436507936618 * sp[18] + 0.1252480158730155 * sp[18] + 0.05109126984127027 * sp[17];
    A[132] = -0.04208968935634277 * sp[19] + -0.1950155606843827 * sp[18] + -0.01543288609732564 * sp[18] + -0.0897913372935288 * sp[17];
    A[133] = 0.1030982623552905 * sp[19] + 0.0876335230019981 * sp[18] + 0.02577456558882192 * sp[18] + -0.04639421805987955 * sp[17];
    A[134] = -0.07440476190476317 * sp[19] + -0.0590277777777792 * sp[18] + -0.02728174603174651 * sp[18] + -0.003968253968254233 * sp[17];
    A[135] = 0.0434926790015511 * sp[19] + -0.06243303921190629 * sp[18] + -0.02314932914598866 * sp[18] + 0.03507474113028561 * sp[17];
    A[136] = -0.07856742013183733 * sp[19] + 0.1360899955855054 * sp[18] + -0.009820927516479826 * sp[18] + 0.0701494822605714 * sp[17];
    A[137] = 0.1248660784238152 * sp[19] + -0.1283735525368424 * sp[18] + 0.01192541198429698 * sp[18] + -0.03507474113028572 * sp[17];
    A[138] = -0.07856742013183693 * sp[19] + -0.152925871328041 * sp[18] + 0.02665680325901718 * sp[18] + 0.04208968935634286 * sp[17];
    A[139] = 0.148716902392409 * sp[19] + 0.2946278254943951 * sp[18] + 0.002805979290422705 * sp[18];
    A[140] = -0.08979133729352942 * sp[19] + -0.1950155606843834 * sp[18] + -0.01543288609732552 * sp[18] + -0.04208968935634268 * sp[17];
    A[141] = -0.2062394778460754 * sp[19] + -0.09329881140655695 * sp[18] + 0.04700015311458264 * sp[18] + 0.03507474113028552 * sp[17];
    A[142] = 0.1346870059402923 * sp[19] + 0.06594051332493438 * sp[18] + -0.07997040977705099 * sp[18] + -0.07014948226057105 * sp[17];
    A[143] = -0.1641497884897317 * sp[19] + -0.09750778034219187 * sp[18] + -0.0582240702762745 * sp[18] + -0.03507474113028587 * sp[17];
    A[144] = 4.920634920634908 * sp[19] + 0.1984126984127018 * sp[18] + 0.1984126984127018 * sp[18] + 0.396825396825403 * sp[17];
    A[145] = 0.02430049347996754 * sp[19] + -0.0607512336999721 * sp[18] + 0.2308546880599299 * sp[18] + 0.6075123369998054 * sp[17];
    A[146] = -0.519106168728203 * sp[19] + -0.806719045996554 * sp[18] + -0.3016427737204522 * sp[18] + -0.3507474113028567 * sp[17];
    A[147] = -0.1984126984127017 * sp[19] + 4.305555555555532 * sp[18] + 0.01984126984126995 * sp[18] + -0.1984126984127012 * sp[17];
    A[148] = -0.2187044413199087 * sp[19] + -0.03645074021998945 * sp[18] + 0.2551551815399187 * sp[18] + -0.2187044413199261 * sp[17];
    A[149] = -0.3507474113028565 * sp[19] + 0.5401510134063862 * sp[18] + 0.03507474113028539 * sp[18] + 0.3226876183986326 * sp[17];
    A[150] = 0.06529556615835218 * sp[19] + -0.1271545235715237 * sp[18] + -0.05154913117764592 * sp[18] + 0.06529556615835092 * sp[17];
    A[151] = -0.05326743555023483 * sp[19] + 0.1838585678669349 * sp[18] + -0.008591521862941409 * sp[18] + 0.08419691425682245 * sp[17];
    A[152] = -0.003436608745177525 * sp[19] + -0.05154913117764447 * sp[18] + -0.01718304372588166 * sp[18] + -0.003436608745176629 * sp[17];
    A[153] = -0.03522523963805742 * sp[19] + 0.02104922856420371 * sp[18] + 0.07947157723220412 * sp[18] + 0.1159855451497029 * sp[17];
    A[154] = -0.006873217490354647 * sp[19] + -0.1778445025628795 * sp[18] + -0.04725337024617517 * sp[18] + -0.1030982623552913 * sp[17];
    A[155] = -0.02663371777511744 * sp[19] + -0.007302793583500347 * sp[18] + -0.0107394023286766 * sp[18] + -0.0128872827944121 * sp[17];
    A[156] = 0.131450284502998 * sp[19] + -0.01073940232867436 * sp[18] + 0.1576544261849665 * sp[18] + 0.1039574145415857 * sp[17];
    A[157] = 0.1030982623552917 * sp[19] + 0.1022391101689944 * sp[18] + -0.1520699369740541 * sp[18] + -0.1305911323167022 * sp[17];
    A[158] = -0.2345485468582882 * sp[19] + -0.167964252420494 * sp[18] + -0.06142938132002933 * sp[18] + -0.04209845712841176 * sp[17];
    A[159] = 0.02430049347996754 * sp[19] + 0.2308546880599299 * sp[18] + -0.0607512336999721 * sp[18] + 0.6075123369998054 * sp[17];
    A[160] = 5.416666666666709 * sp[19] + 0.4315476190476327 * sp[18] + 0.4315476190476327 * sp[18] + 1.130952380952398 * sp[17];
    A[161] = -0.1890134809847086 * sp[19] + -0.06873217490352382 * sp[18] + -0.274928699614105 * sp[18] + -0.1890134809847016 * sp[17];
    A[162] = 0.170103454359952 * sp[19] + 0.449559129379842 * sp[18] + 0.1579532076199494 * sp[18] + -0.4131083891598583 * sp[17];
    A[163] = -0.4017857142857234 * sp[19] + 3.593749999999994 * sp[18] + 0.5580357142857227 * sp[18] + -0.4017857142857146 * sp[17];
    A[164] = 0.3007032652029479 * sp[19] + 0.1761261981902901 * sp[18] + 0.2792244605455822 * sp[18] + 0.3007032652029424 * sp[17];
    A[165] = -0.01686507936508149 * sp[19] + 0.07192460317460266 * sp[18] + -0.007440476190475868 * sp[18] + -0.01091269841269919 * sp[17];
    A[166] = -0.004960317460314207 * sp[19] + -0.1626984126984121 * sp[18] + 0.01984126984126924 * sp[18] + -0.1021825396825408 * sp[17];
    A[167] = 0.1001984126984119 * sp[19] + 0.1026785714285715 * sp[18] + -0.07192460317460353 * sp[18] + 0.1180555555555574 * sp[17];
    A[168] = -0.04513888888888826 * sp[19] + 0.005704365079364507 * sp[18] + 0.04340277777777812 * sp[18] + 0.05208333333333313 * sp[17];
    A[169] = 0.1289682539682536 * sp[19] + -0.01636904761904653 * sp[18] + -0.09176587301587366 * sp[18] + -0.17857142857143 * sp[17];
    A[170] = -0.03819444444444232 * sp[19] + 0.1054067460317484 * sp[18] + 0.03596230158730127 * sp[18] + 0.1264880952380963 * sp[17];
    A[171] = 0.1473214285714273 * sp[19] + 0.04935515873015893 * sp[18] + 0.1068948412698424 * sp[18] + 0.05605158730158821 * sp[17];
    A[172] = -0.107142857142856 * sp[19] + -0.05605158730158696 * sp[18] + 0.01934523809523943 * sp[18] + 0.02182539682539753 * sp[17];
    A[173] = 0.2217261904761907 * sp[19] + 0.1252480158730155 * sp[18] + 0.09945436507936618 * sp[18] + 0.05109126984127027 * sp[17];
    A[174] = -0.519106168728203 * sp[19] + -0.3016427737204522 * sp[18] + -0.806719045996554 * sp[18] + -0.3507474113028567 * sp[17];
    A[175] = -0.1890134809847086 * sp[19] + -0.274928699614105 * sp[18] + -0.06873217490352382 * sp[18] + -0.1890134809847016 * sp[17];
    A[176] = 5.555555555555567 * sp[19] + 0.5902777777777792 * sp[18] + 0.5902777777777792 * sp[18] + 0.9126984126984284 * sp[17];
    A[177] = -0.3507474113028569 * sp[19] + -0.3016427737204443 * sp[18] + 0.203433498555657 * sp[18] + -0.01402989645209721 * sp[17];
    A[178] = 0.07732369676647419 * sp[19] + 0.1675346763273474 * sp[18] + 0.06443641397205614 * sp[18] + 0.07732369676647148 * sp[17];
    A[179] = -0.6200396825396944 * sp[19] + 3.395337301587294 * sp[18] + 0.3596230158730218 * sp[18] + -0.6200396825397015 * sp[17];
    A[180] = 0.03507474113028572 * sp[19] + -0.01192541198429712 * sp[18] + 0.1283735525368425 * sp[18] + -0.1248660784238148 * sp[17];
    A[181] = -0.07014948226057138 * sp[19] + 0.009820927516479972 * sp[18] + -0.1360899955855055 * sp[18] + 0.07856742013183694 * sp[17];
    A[182] = -0.03507474113028568 * sp[19] + 0.02314932914598859 * sp[18] + 0.06243303921190646 * sp[18] + -0.04349267900155104 * sp[17];
    A[183] = 0.03507474113028568 * sp[19] + 0.04700015311458285 * sp[18] + -0.09329881140655687 * sp[18] + -0.206239477846075 * sp[17];
    A[184] = -0.07014948226057137 * sp[19] + -0.07997040977705136 * sp[18] + 0.0659405133249344 * sp[18] + 0.1346870059402919 * sp[17];
    A[185] = -0.03507474113028566 * sp[19] + -0.05822407027627422 * sp[18] + -0.09750778034219193 * sp[18] + -0.1641497884897313 * sp[17];
    A[186] = 0.04208968935634285 * sp[19] + 0.02665680325901715 * sp[18] + -0.1529258713280406 * sp[18] + -0.07856742013183667 * sp[17];
    A[187] = 0.002805979290422823 * sp[18] + 0.2946278254943944 * sp[18] + 0.1487169023924081 * sp[17];
    A[188] = -0.04208968935634277 * sp[19] + -0.01543288609732564 * sp[18] + -0.1950155606843827 * sp[18] + -0.0897913372935288 * sp[17];
    A[189] = -0.1984126984127017 * sp[19] + 0.01984126984126995 * sp[18] + 4.305555555555532 * sp[18] + -0.1984126984127012 * sp[17];
    A[190] = 0.170103454359952 * sp[19] + 0.1579532076199494 * sp[18] + 0.449559129379842 * sp[18] + -0.4131083891598583 * sp[17];
    A[191] = -0.3507474113028569 * sp[19] + 0.203433498555657 * sp[18] + -0.3016427737204443 * sp[18] + -0.01402989645209721 * sp[17];
    A[192] = 0.3968253968254035 * sp[19] + 0.1984126984127018 * sp[18] + 0.1984126984127018 * sp[18] + 4.920634920634906 * sp[17];
    A[193] = -0.1458029608799468 * sp[18] + -0.729014804399747 * sp[18] + -0.4374088826398527 * sp[17];
    A[194] = 0.7014948226057136 * sp[19] + 0.350747411302857 * sp[18] + 0.3507474113028572 * sp[18] + 0.280597929042258 * sp[17];
    A[195] = -0.1005208057964096 * sp[19] + 0.07088005536926238 * sp[18] + -0.06314768569261567 * sp[18] + -0.08505606644311357 * sp[17];
    A[196] = 0.04639421805988047 * sp[19] + -0.0128872827944105 * sp[18] + 0.04897167461876199 * sp[18] + 0.03092947870658581 * sp[17];
    A[197] = -0.02319710902993974 * sp[19] + 0.03221820698602823 * sp[18] + 0.001288728279441005 * sp[18] + -0.01804219591217503 * sp[17];
    A[198] = 0.1005208057964095 * sp[19] + 0.1714008611656717 * sp[18] + 0.03737312010379384 * sp[18] + 0.1933092419161695 * sp[17];
    A[199] = -0.04639421805988043 * sp[19] + -0.05928150085429063 * sp[18] + 0.002577456558881445 * sp[18] + -0.04123930494211479 * sp[17];
    A[200] = 0.02319710902993976 * sp[19] + 0.05541531601596771 * sp[18] + 0.02448583730938047 * sp[18] + 0.07474624020758401 * sp[17];
    A[201] = 0.1030982623552902 * sp[19] + 0.07732369676646847 * sp[18] + 0.01546473935329265 * sp[18] + -0.05670404429540918 * sp[17];
    A[202] = -0.2061965247105821 * sp[19] + -0.1030982623552909 * sp[18] + -0.1030982623552908 * sp[18] + 0.1082531754730538 * sp[17];
    A[203] = 0.1030982623552905 * sp[19] + 0.02577456558882192 * sp[18] + 0.0876335230019981 * sp[18] + -0.04639421805987955 * sp[17];
    A[204] = -0.2187044413199087 * sp[19] + 0.2551551815399187 * sp[18] + -0.03645074021998945 * sp[18] + -0.2187044413199261 * sp[17];
    A[205] = -0.4017857142857234 * sp[19] + 0.5580357142857227 * sp[18] + 3.593749999999994 * sp[18] + -0.4017857142857146 * sp[17];
    A[206] = 0.07732369676647419 * sp[19] + 0.06443641397205614 * sp[18] + 0.1675346763273474 * sp[18] + 0.07732369676647148 * sp[17];
    A[207] = -0.729014804399747 * sp[18] + -0.1458029608799468 * sp[18] + -0.4374088826398527 * sp[17];
    A[208] = 0.8035714285714426 * sp[19] + 0.4017857142857201 * sp[18] + 0.4017857142857201 * sp[18] + 5.357142857142861 * sp[17];
    A[209] = -0.05154913117763659 * sp[18] + -0.2577456558882171 * sp[18] + -0.154647393532927 * sp[17];
    A[210] = 0.06200396825396934 * sp[19] + -0.02108134920634964 * sp[18] + 0.0959821428571416 * sp[18] + 0.05307539682539855 * sp[17];
    A[211] = -0.1240079365079385 * sp[19] + 0.01736111111111149 * sp[18] + -0.2405753968253958 * sp[18] + 0.04365079365079517 * sp[17];
    A[212] = -0.06200396825396937 * sp[19] + 0.04092261904761974 * sp[18] + 0.1460813492063475 * sp[18] + -0.06498015873016047 * sp[17];
    A[213] = 0.06200396825396928 * sp[19] + 0.08308531746031896 * sp[18] + -0.03397817460317271 * sp[18] + 0.04017857142857482 * sp[17];
    A[214] = -0.1240079365079386 * sp[19] + -0.1413690476190501 * sp[18] + 0.116567460317458 * sp[18] + 0.1428571428571429 * sp[17];
    A[215] = -0.06200396825396916 * sp[19] + -0.1029265873015889 * sp[18] + -0.2080853174603164 * sp[18] + -0.3139880952380976 * sp[17];
    A[216] = 0.07440476190476326 * sp[19] + 0.04712301587301668 * sp[18] + 0.01537698412698341 * sp[18] + -0.007936507936507948 * sp[17];
    A[217] = 0.004960317460317583 * sp[18] + -0.1458333333333376 * sp[18] + -0.07043650793651003 * sp[17];
    A[218] = -0.07440476190476317 * sp[19] + -0.02728174603174651 * sp[18] + -0.0590277777777792 * sp[18] + -0.003968253968254233 * sp[17];
    A[219] = -0.3507474113028565 * sp[19] + 0.03507474113028539 * sp[18] + 0.5401510134063862 * sp[18] + 0.3226876183986326 * sp[17];
    A[220] = 0.3007032652029479 * sp[19] + 0.2792244605455822 * sp[18] + 0.1761261981902901 * sp[18] + 0.3007032652029424 * sp[17];
    A[221] = -0.6200396825396944 * sp[19] + 0.3596230158730218 * sp[18] + 3.395337301587294 * sp[18] + -0.6200396825397015 * sp[17];
    A[222] = 0.7014948226057136 * sp[19] + 0.3507474113028572 * sp[18] + 0.350747411302857 * sp[18] + 0.280597929042258 * sp[17];
    A[223] = -0.2577456558882171 * sp[18] + -0.05154913117763659 * sp[18] + -0.154647393532927 * sp[17];
    A[224] = 1.240079365079385 * sp[19] + 0.6200396825396914 * sp[18] + 0.6200396825396914 * sp[18] + 5.615079365079413 * sp[17];
  }

};


class forms_form_0: public ufc::form
{
public:

  forms_form_0() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_0() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "f7ade342237e5af4964c4356cf0b121fecb7c546c2c72d54a3d7f9c3718a8755a939353c4e59adb32539a005c2463fb5e8af82bc1aadd81f9dfdc51a48bee4cd";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_0_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};


class forms_form_1: public ufc::form
{
public:

  forms_form_1() : ufc::form()
  {
    // Do nothing
  }

  ~forms_form_1() override
  {
    // Do nothing
  }

  const char * signature() const final override
  {
    return "a3226853386d2b74b50fbefb85d9e0f4f839379042f756b24439e8ccc90d14f112726c9f00229d697576706f783f14fe1fb718aff5c3d4d48b40494a4aef7b2b";
  }

  std::size_t rank() const final override
  {
    return 2;
  }

  std::size_t num_coefficients() const final override
  {
    return 0;
  }

  std::size_t original_coefficient_position(std::size_t i) const final override
  {
    throw std::runtime_error("Invalid original coefficient index.");
    return i;
  }

  ufc::finite_element * create_coordinate_finite_element() const final override
  {
    return new forms_finite_element_1();
  }

  ufc::dofmap * create_coordinate_dofmap() const final override
  {
    return new forms_dofmap_1();
   }

  ufc::coordinate_mapping * create_coordinate_mapping() const final override
  {
    return new forms_coordinate_mapping_1();
  }

  ufc::finite_element * create_finite_element(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_finite_element_2();
    case 1:
        return new forms_finite_element_2();
    default:
        return nullptr;
    }
  }

  ufc::dofmap * create_dofmap(std::size_t i) const final override
  {
    switch (i)
    {
    case 0:
        return new forms_dofmap_2();
    case 1:
        return new forms_dofmap_2();
    default:
        return nullptr;
    }
  }

  std::size_t max_cell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_exterior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interior_facet_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_vertex_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_custom_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_cutcell_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_interface_subdomain_id() const final override
  {
    return 0;
  }

  std::size_t max_overlap_subdomain_id() const final override
  {
    return 0;
  }

  bool has_cell_integrals() const final override
  {
    return true;
  }

  bool has_exterior_facet_integrals() const final override
  {
    return false;
  }

  bool has_interior_facet_integrals() const final override
  {
    return false;
  }

  bool has_vertex_integrals() const final override
  {
    return false;
  }

  bool has_custom_integrals() const final override
  {
    return false;
  }

  bool has_cutcell_integrals() const final override
  {
    return false;
  }

  bool has_interface_integrals() const final override
  {
    return false;
  }

  bool has_overlap_integrals() const final override
  {
    return false;
  }

  ufc::cell_integral * create_cell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::exterior_facet_integral * create_exterior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_interior_facet_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_vertex_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_custom_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_cutcell_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_interface_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_overlap_integral(std::size_t subdomain_id) const final override
  {
    return nullptr;
  }

  ufc::cell_integral * create_default_cell_integral() const final override
  {
    return new forms_cell_integral_1_otherwise();
  }

  ufc::exterior_facet_integral * create_default_exterior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::interior_facet_integral * create_default_interior_facet_integral() const final override
  {
    return nullptr;
  }

  ufc::vertex_integral * create_default_vertex_integral() const final override
  {
    return nullptr;
  }

  ufc::custom_integral * create_default_custom_integral() const final override
  {
    return nullptr;
  }

  ufc::cutcell_integral * create_default_cutcell_integral() const final override
  {
    return nullptr;
  }

  ufc::interface_integral * create_default_interface_integral() const final override
  {
    return nullptr;
  }

  ufc::overlap_integral * create_default_overlap_integral() const final override
  {
    return nullptr;
  }

};

// DOLFIN wrappers

// Standard library includes
#include <string>

// DOLFIN includes
#include <dolfin/common/NoDeleter.h>
#include <dolfin/mesh/Mesh.h>
#include <dolfin/mesh/MultiMesh.h>
#include <dolfin/fem/FiniteElement.h>
#include <dolfin/fem/DofMap.h>
#include <dolfin/fem/Form.h>
#include <dolfin/fem/MultiMeshForm.h>
#include <dolfin/function/FunctionSpace.h>
#include <dolfin/function/MultiMeshFunctionSpace.h>
#include <dolfin/function/GenericFunction.h>
#include <dolfin/function/CoefficientAssigner.h>
#include <dolfin/function/MultiMeshCoefficientAssigner.h>
#include <dolfin/adaptivity/ErrorControl.h>
#include <dolfin/adaptivity/GoalFunctional.h>
#include <dolfin/la/GenericVector.h>

namespace Forms
{

class Form_a_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_a_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_a_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_a_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_a_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_a: public dolfin::Form
{
public:

  // Constructor
  Form_a(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_0>();
  }

  // Destructor
  ~Form_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_a: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_a(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_a(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_a()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_a_FunctionSpace_0 TestSpace;
  typedef Form_a_FunctionSpace_1 TrialSpace;
  typedef Form_a_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_a_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class Form_L_FunctionSpace_0: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_0(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_FunctionSpace_1: public dolfin::FunctionSpace
{
public:

  // Constructor for standard function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh))
  {
    // Do nothing
  }

  // Constructor for constrained function space
  Form_L_FunctionSpace_1(std::shared_ptr<const dolfin::Mesh> mesh, std::shared_ptr<const dolfin::SubDomain> constrained_domain):
    dolfin::FunctionSpace(mesh,
                          std::make_shared<const dolfin::FiniteElement>(std::make_shared<forms_finite_element_2>()),
                          std::make_shared<const dolfin::DofMap>(std::make_shared<forms_dofmap_2>(), *mesh, constrained_domain))
  {
    // Do nothing
  }

};

class Form_L_MultiMeshFunctionSpace_0: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_0(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_0(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L_MultiMeshFunctionSpace_1: public dolfin::MultiMeshFunctionSpace
{
public:

  // Constructor for multimesh function space
  Form_L_MultiMeshFunctionSpace_1(std::shared_ptr<const dolfin::MultiMesh> multimesh): dolfin::MultiMeshFunctionSpace(multimesh)
  {
    // Create and add standard function spaces
    for (std::size_t part = 0; part < multimesh->num_parts(); part++)
    {
      std::shared_ptr<const dolfin::FunctionSpace> V(new Form_L_FunctionSpace_1(multimesh->part(part)));
      add(V);
    }

    // Build multimesh function space
    build();
  }

};

class Form_L: public dolfin::Form
{
public:

  // Constructor
  Form_L(std::shared_ptr<const dolfin::FunctionSpace> V1, std::shared_ptr<const dolfin::FunctionSpace> V0):
    dolfin::Form(2, 0)
  {
    _function_spaces[0] = V0;
    _function_spaces[1] = V1;

    _ufc_form = std::make_shared<const forms_form_1>();
  }

  // Destructor
  ~Form_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

class MultiMeshForm_L: public dolfin::MultiMeshForm
{
public:

  // Constructor
  MultiMeshForm_L(std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V1, std::shared_ptr<const dolfin::MultiMeshFunctionSpace> V0):
    dolfin::MultiMeshForm(V1, V0)
  {
    // Create and add standard forms
    std::size_t num_parts = V0->num_parts(); // assume all equal and pick first
    for (std::size_t part = 0; part < num_parts; part++)
    {
      std::shared_ptr<dolfin::Form> a(new Form_L(V1->part(part), V0->part(part)));
    add(a);

    }
    // Build multimesh form
    build();

    /// Assign coefficients

  }

  // Destructor
  ~MultiMeshForm_L()
  {}

  /// Return the number of the coefficient with this name
  virtual std::size_t coefficient_number(const std::string& name) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return 0;
  }

  /// Return the name of the coefficient with this number
  virtual std::string coefficient_name(std::size_t i) const
  {

    dolfin::dolfin_error("generated code for class Form",
                         "access coefficient data",
                         "There are no coefficients");
    return "unnamed";
  }

  // Typedefs
  typedef Form_L_FunctionSpace_0 TestSpace;
  typedef Form_L_FunctionSpace_1 TrialSpace;
  typedef Form_L_MultiMeshFunctionSpace_0 MultiMeshTestSpace;
  typedef Form_L_MultiMeshFunctionSpace_1 MultiMeshTrialSpace;

  // Coefficients
};

// Class typedefs
typedef Form_a::TestSpace FunctionSpace;
typedef Form_a::MultiMeshTestSpace MultiMeshFunctionSpace;

}

#endif
